(function e(t,n,r){function s(o,u){if(!n[o]){if(!t[o]){var a=typeof require=="function"&&require;if(!u&&a)return a(o,!0);if(i)return i(o,!0);var f=new Error("Cannot find module '"+o+"'");throw f.code="MODULE_NOT_FOUND",f}var l=n[o]={exports:{}};t[o][0].call(l.exports,function(e){var n=t[o][1][e];return s(n?n:e)},l,l.exports,e,t,n,r)}return n[o].exports}var i=typeof require=="function"&&require;for(var o=0;o<r.length;o++)s(r[o]);return s})({1:[function(require,module,exports){
var Random = require('./Random');
var Distance = require('./Distance');
var Direction = require('./util/Direction');
var Stat = require('./Stat.class');
var Item = require('./Item.class');
var Effects = require('./monster/Effects.enum');
var Stats = require('./monster/Stats.enum');
var TrainerAI = require('./ai/Trainer');

function Being(game, level, race, xpLevel){
	this.game = game;
	this.race = race;
	this.level = level;
	this.tile = race.tile;
	this.x = null;
	this.y = null;
	this.counters = [];
	this.iv = {
		hp: 0,
		attack: 0,
		defense: 0,
		spAttack: 0,
		spDefense: 0 
	};

	this.ev = {
		hp: 1,
		attack: 1,
		defense: 1,
		spAttack: 1,
		spDefense: 1 
	}
	
	this.speed = new Stat(race.speed);
	this.intent = 'CHASE';
	this.isFriendly = false;
	this.xpLevel = xpLevel;
	this.randomId = Random.n(8,10000);
	if (xpLevel){
		this.xp = this.calculateXP(xpLevel);
		this.nextLevelXP = this.calculateXP(xpLevel+1);
		this.calculateStats();
	}
	if (race.skills && xpLevel){
		this.skills = race.skills.filter(function(def){return def.level <= xpLevel;});
		this.skills = this.skills.map(function(val){
			return {
				skill: val.skill,
				pp: new Stat(val.skill.pp)
			};
		});
		if (race.parentRace){
			var newSkills = race.parentRace.skills.filter(function(def){return def.level <= xpLevel;});
			newSkills = newSkills.map(function(val){
				return {
					skill: val.skill,
					pp: new Stat(val.skill.pp)
				};
			});
			this.skills = this.skills.concat(newSkills);
		}
		while (this.skills.length > 4){
			Random.from(this.skills, true);
		}
		this.basicAttackSkill = this.skills.find(function(skill){return skill.skill.effect === Effects.DAMAGE;});
	}
}

Being.prototype = {
	act: function(){
		if (this.nextSkill){
			if (this.validateSkill(this.nextSkill)){
				this.nextSkill.pp.reduce(1);
				this.nextSkill.skill.effect(this, this.nextSkill.skill);
			}
			this.nextSkill = false;
			return;
		}

		switch (this.intent){
			case 'RANDOM':
				this.actRandom();
				break;
			case 'CHASE':
				this.actChase();
				break;
			case 'STILL':
				this.actStill();
				break;
			case 'TRAINER':
				this.actAsTrainer();
				break;
		}
	},
	actAsTrainer: function(){
		TrainerAI.act(this);
	},
	actRandom: function(){
		var dx = Random.n(-1, 1);
		var dy = Random.n(-1, 1);
		if (!this.level.canWalkTo(this.x+dx,this.y+dy)){
			return;
		}
		this.moveTo(dx, dy);
	},
	actStill: function(){
		if (this.seen){
			this.actRandom();
		} else {
			// Do nothing
		}
	},
	actChase: function(){
		var nearestEnemy = this.getNearestEnemy();
		if (!nearestEnemy){
			return;
		}
		var dx = Math.sign(nearestEnemy.x - this.x);
		var dy = Math.sign(nearestEnemy.y - this.y);
		if (this.game.player.x === this.x+dx && this.game.player.y === this.y+dy){
			this.tacklePlayer();
			return;
		}
		var being = this.level.getBeing(this.x+dx,this.y+dy);
		if (being){
			if (this.isFriendly !== being.isFriendly){
				this.tackle(being);
			}
			return;
		}
		if (!this.level.canWalkTo(this.x+dx,this.y+dy)){
			return;
		}
		this.moveTo(dx, dy);
	},
	tackle: function(enemy){
		if (!this.basicAttackSkill){
			return;
		}
		var selectedSkill = this.basicAttackSkill; 
		if (Random.chance(50)){
			selectedSkill = Random.from(this.skills);
		}
		if (selectedSkill.pp.empty()){
			// Try to get another basic attack skill
			selectedSkill = this.skills.find(
				function(skill){
					return skill.skill.effect === Effects.DAMAGE && !skill.pp.empty();
				}
			);
			if (!selectedSkill){
				// Try to use any skill
				selectedSkill = this.skills.find(
					function(skill){
						return !skill.pp.empty();
					}
				);
			}

			if (!selectedSkill){
				// Struggle it is then
				this.game.display.message("The "+this.race.name+" can't attack!");
				return;
			}
		}
		if (!this.validateSkill(selectedSkill)){
			return;
		}
		selectedSkill.pp.reduce(1);
		selectedSkill.skill.effect(this, selectedSkill.skill);
	},
	tacklePlayer: function(){
		this.game.display.message("The "+this.race.name+" attacks you.");
		this.game.player.hp.reduce(1);
		if (this.game.player.hp.current <= 0){
			this.game.player.die();
		}
	},
	die: function(){
		if (this.slotNumber !== undefined){
			this.game.display.message("Your "+this.race.name+" dies!");
			this.game.player.monsterSlots[this.slotNumber] = false;
			if (this.game.input.selectedMonsterSlot === this.slotNumber){
				this.game.input.selectAvailableMonsterSlot();
			}
			if (this.game.player.gymTown){
				this.game.player.releasedMonster = false;
			}
		} else {
			this.game.display.message("The "+this.race.name+" dies!");
			if (this.enemiesList && this.enemiesList.length > 0){
				// The monster can die without enemies, for example by suicide
				var xp = Math.floor(this.calculateXPGain() / this.enemiesList.length);
				this.enemiesList.forEach(function(enemy){
					if (!enemy.dead){
						enemy.addXP(xp);
					}
				});
			}
		}
		this.dead = true;
		this.game.world.level.removeBeing(this);
		if (this.owner){
			this.owner.monsterDied(this);
		}
	},
	getNearestEnemy: function(){
		var nearestDistance = 999;
		var nearestEnemy = false;
		for (var i = 0; i < this.level.beingsList.length; i++){
			var being = this.level.beingsList[i];
			if (this.isTame && being.isTrainer){
				continue;
			}
			if (being.isFriendly != this.isFriendly){
				var distance = Distance.flatDistance(being.x, being.y, this.x, this.y);
				if (distance < this.getSightRange() && distance < nearestDistance){
					nearestDistance = distance;
					nearestEnemy = being;
				}
			}
		}
		if (!this.isFriendly && !this.isTame){
			// Consider the player too
			var distance = Distance.flatDistance(this.game.player.x, this.game.player.y, this.x, this.y);
			if (distance < this.getSightRange() && distance < nearestDistance){
				nearestDistance = distance;
				nearestEnemy = this.game.player;
			}
		}
		return nearestEnemy;
	},
	moveTo: function(dx,dy){
		this.level.beings[this.x][this.y] = false;
		this.x = this.x + dx;
		this.y = this.y + dy;
		if (!this.level.beings[this.x])
			this.level.beings[this.x] = [];
		this.level.beings[this.x][this.y] = this;
	},
	getSightRange: function(){
		return 10;
	},
	recoverHP: function(points){
		this.hp.increase(points);
	},
	// Trainer functions
	pullBackMonster: function(){
		var monster = this.monsterDeployed;
		this.game.display.message(this.race.name+" calls back "+monster.race.name+".");
		this.game.world.level.removeBeing(monster);
		this.monsterDeployed = false;
	},
	useItem: function(item){
		//Used on the current monster
	},
	issueOrder: function(order){

	},
	releaseMonster: function(monster){
		// Select a direction toward player
		var dir = Direction.direction(this.x, this.y, this.game.player.x, this.game.player.y);
		if (this.game.world.level.canWalkTo(this.x + dir.x, this.y + dir.y) &&
			this.game.world.level.canWalkTo(this.x + dir.x * 2, this.y + dir.y * 2)){
			monster.level = this.level;
			this.game.world.level.addBeing(monster, this.x + dir.x * 2, this.y + dir.y * 2);
			this.game.display.message(this.race.name+" sends out "+monster.race.name+".");
			this.monsterDeployed = monster;
		}
	},
	monsterDied: function(monster){
		this.monsterDeployed = false;
		this.monsters.splice(this.monsters.indexOf(monster), 1);
	},
	givePrize: function(){
		if (this.prize){
			this.game.display.message("Congratulations! take the "+this.prize.name+"!");
			this.game.player.addItem(new Item(this.prize));
			this.gavePrize = true;
			this.game.player.gymTown.gymComplete = true;
			this.game.player.gymTown = false;
			this.game.player.badgesCount++;
			this.game.player.money += this.prizeMoney;
			if (this.game.player.badgesCount === 8){
				this.game.display.showScene("VICTORY");
			}
		} else if (this.prizeMoney){

		}
	},
	healAll: function(){
		for (var i = 0; i < this.monsters.length; i++){
			this.monsters[i].heal();
		}
	},
	validateSkill: function(skill){
		if (skill.pp.empty()){
			this.game.display.message(this.race.name+" has no power points!");
			return false;
		}
		if (Effects.skipTarget(skill.skill)){
			return true;
		}
		var nearestEnemy = this.getNearestEnemy();
		if (!nearestEnemy){
			this.game.display.message("No target!");
			return false;
		}
		var distance = Distance.flatDistance(this.x, this.y, nearestEnemy.x, nearestEnemy.y);
		if (!skill.skill.range){
			skill.skill.range = 1;
		}
		if (distance > skill.skill.range){
			this.game.display.message(nearestEnemy.race.name+" is too far!");
			return false;
		}
		return true;
	},
	useSkill: function(index){
		if (this.skills && this.skills[index]){
			this.nextSkill = this.skills[index];
			this.game.display.message(this.race.name+", use "+this.skills[index].skill.name+"!");
			this.game.player.endTurn();
		}
	},
	heal: function(){
		this.hp.replenish();
		this.skills.forEach(function(skill){skill.pp.replenish();});
	},
	calculateXPGain: function(){
		var a = this.isTame ? 1.5 : 1;
		var b = this.race.xp;
		var e = 1; // Lucky Egg
		var f = 1; // Affection
		var L = this.xpLevel;
		var p = 1; // Exp Points Power
		var s = this.enemiesList.length;
		var t = 1; // Trading origin
		var v = 1; // Non evolve bonus
		if (s === 0)
			s = 1;
		return Math.floor((a*t*b*e*L*p*f*v)/(7*s));
	},
	calculateXP: function(level){
		return Math.pow(level, 3); // Corresponds to the Medium Fast group
		/*
		// Alternate 
		if (level === 1){
			return 0;
		}
		var xp = 100;
		for (var i = 2; i <= level; i++){
			xp += (i-1) * 50;
		}
		return xp;
		*/
	},
	recordHitBy: function(enemy){
		if (!this.enemiesList){
			this.enemiesMap = {};
			this.enemiesList = [];
		}
		if (!this.enemiesMap[enemy.randomId]){
			this.enemiesList.push(enemy);
			this.enemiesMap[enemy.randomId] = enemy;
		}
	},
	addXP: function(xp){
		this.game.display.message(this.race.name+" gets "+xp+" XP");
		this.xp += xp;
		if (this.xp >= this.nextLevelXP){
			this.levelUp();
		}
	},
	levelUp: function(){
		this.game.display.message(this.race.name+" levels up!");
		this.xpLevel++;
		this.xp = this.calculateXP(this.xpLevel);
		this.nextLevelXP = this.calculateXP(this.xpLevel+1);
		// Increase stats
		this.calculateStats();

		// Check evolution and new skills
		var newSkill = this.race.skills.find(function(def){
			return def.level === this.xpLevel;
		}, this);

		if (newSkill && this.skills.find(function(existingSkill){ return existingSkill.skill === newSkill.skill;})){
			newSkill = false;
		}

		if (newSkill){
			if (this.skills.length === 4){
				// Randomly forget one ;)
				var oldSkill = Random.from(this.skills, true);
				this.game.display.message(this.race.name+" forgets "+oldSkill.skill.name+".");
			} 
			this.skills.push({
				skill: newSkill.skill,
				pp: new Stat(newSkill.skill.pp)
			});
			this.game.display.message(this.race.name+" learns "+newSkill.skill.name+".");
		}
		if (this.race.evolution && this.race.evolution.minLevel === this.xpLevel){
			var newRace = this.race.evolution.race;
			this.game.display.message(this.race.name+" evolves into "+newRace.name+"!");
			this.setRace(newRace);
		}
	},
	setRace: function(race){
		this.race = race;
		this.tile = race.tile;
	},
	_calculateStatBase: function(stat){
		var base = this.race[stat];
		var iv = this.iv[stat];
		var ev = this.ev[stat];
		//return Math.floor((Math.floor((base + iv) * 2 + (Math.sqrt(ev) / 4))*this.xpLevel)/100);
		if (stat === 'hp'){
			var statValue = (base + iv + 50) * this.xpLevel / 50 + 10;
		} else {
 			statValue = (base + iv) * this.xpLevel / 50 + 5;
		}
		statValue = Math.floor(statValue);
		var extraPoints = Math.floor(((Math.sqrt(ev - 1)) + 1) * this.xpLevel / 400);
		extraPoints = Math.floor(extraPoints);
		return statValue + extraPoints;
	},
	calculateStats: function(){
		var hp = this._calculateStatBase('hp') + this.xpLevel;
		var attack = this._calculateStatBase('attack');
		var defense = this._calculateStatBase('defense');
		var spAttack = this._calculateStatBase('spAttack');
		var spDefense = this._calculateStatBase('spDefense');

		if (this.hp){
			this.hp.max = hp;
		} else {
			this.hp = new Stat(hp);
		} 
		this.attack = new Stat(attack);
		this.defense = new Stat(defense);
		this.spAttack = new Stat(spAttack);
		this.spDefense = new Stat(spDefense);
	},
	takeDamage: function(damage){
		this.hp.reduce(damage);
		if (this.hp.current <= 0){
			this.die();
		}
	},
	isUnderground: function(){
		return false; //TODO: Implement
	},
	changeStat: function(stat, turns, level){
		this.counters.push({type: "CHANGE_STAT", stat: stat, turns: turns, level: level});
	},
	lowerCounters: function(){
		for (var i = 0; i < this.counters.length; i++){
			this.counters[i].turns--;
			if (this.counters[i].turns < 0){
				if (this.counters[i].type === "CHANGE_STAT"){
					if (this.counters[i].level < 0)
						this.game.display.message("The "+this.race.name+"'s "+Stats[this.counters[i].stat].name+" recovers.");
				}
				this.counters.splice(i,1);
				i--;
			}
		}
	},
	getEffectiveAttack: function(){
		return this.getEffectiveStat('attack', 'ATK');
	},
	getEffectiveDefense: function(){
		return this.getEffectiveStat('defense', 'DEF');
	},
	getEffectiveSpecialAttack: function(){
		return this.getEffectiveStat('spAttack', 'SP_ATK');
	},
	getEffectiveSpecialDefense: function(){
		return this.getEffectiveStat('spDefense', 'SP_DEF');
	},
	getEffectiveSpeed: function(){
		return this.getEffectiveStat('speed', 'SPD');
	},
	getEffectiveAccuracy: function(){
		return this.getEffectiveStat('accuracy', 'ACC');
	},
	getEffectiveEvasion: function(){
		return this.getEffectiveStat('evasion', 'EVA');
	},
	getEffectiveStat: function(statName, statId){
		var variation = 0;
		var base = 0;
		for (var i = 0; i < this.counters.length; i++){
			if (this.counters[i].type === "CHANGE_STAT" && this.counters[i].stat === statId){
				variation += this.counters[i].level;
			}
		}
		if (statId === 'EVA' || statId === 'ACC'){
			base = 1;
		} else {
			base = this[statName].current;
		}
		if (variation < -6)
			variation = -6;
		if (variation > 6){
			variation = 6;
		}
		return base * this.STAGE_MULTIPLIERS[variation];
	},
	STAGE_MULTIPLIERS: {
		"-6": 25 / 100,
		"-5": 28 / 100,
		"-4": 33 / 100,
		"-3": 40 / 100,
		"-2": 50 / 100,
		"-1": 66 / 100,
		"0": 100 / 100,
		"1": 150 / 100,
		"2": 200 / 100,
		"3": 250 / 100,
		"4": 300 / 100,
		"5": 350 / 100,
		"6": 400 / 100
	},
	inflictStatus: function(status, turns){
		this.counters.push({type: "SET_STATUS", statusId: status.id, turns: turns});
	},
	endTurn: function(){
		this.lowerCounters();
	},
	hasStatus: function(status){
		for (var i = 0; i < this.counters.length; i++){
			if (this.counters[i].type === "SET_STATUS" && this.counters[i].statusId === status.id){
				return true;
			}
		}
	}
}

module.exports = Being;
},{"./Distance":3,"./Item.class":6,"./Random":15,"./Stat.class":17,"./ai/Trainer":20,"./monster/Effects.enum":26,"./monster/Stats.enum":31,"./util/Direction":37}],2:[function(require,module,exports){
var TextBox = require('./ui/TextBox.class');
var Box = require('./ui/Box.class');

module.exports = {
	BLANK_TILE: new ut.Tile(' ', 255, 255, 255),
	CURSOR_TILE: new ut.Tile('*', 255, 255, 255),
	init: function(game){
		this.game = game;
		this.term = new ut.Viewport(document.getElementById("game"), 80, 25);
		this.eng = new ut.Engine(this.term, this.getDisplayedTile.bind(this), 80, 25);
		this.textBox = new TextBox(this.term, 2, 80, {x:0, y:0}, this);
		this.inventoryBox = new Box(this.term, 25, 40, {x:19, y:0});
		this.sceneBox = new TextBox(this.term, 10, 45, {x:20, y:3}, this);
	},
	getDisplayedTile: function(x,y){
		var level = this.game.world.level;
		if (x === level.player.x && y === level.player.y){
			return level.player.tile;
		}
		var xr = x - level.player.x;
		var yr = y - level.player.y;
		if (level.player.canSee(xr, yr)){
			if (level.beings[x] && level.beings[x][y]){
				return level.beings[x][y].tile;
			} else if (level.items[x] && level.items[x][y]){
				return level.items[x][y].def.tile;
			} else if (level.map[x] && level.map[x][y]){
				return level.map[x][y].tile;
			} else {
				return ut.NULLTILE;
			}
		} else if (level.player.remembers(x, y)){
			if (level.map[x] && level.map[x][y]){
				return level.map[x][y].darkTile;
			} else {
				return ut.NULLTILE;
			}
		} else {
			return ut.NULLTILE;
		}
	},
	refresh: function(){
		this.eng.update(this.game.player.x, this.game.player.y);
		this.updateStatus();
		this.textBox.draw();
		this.term.render();
		if (this.currentScene){
			this.showScene(this.currentScene);
		}
	},
	updateStatus: function(){
		this.term.putString("HP "+this.game.player.hp.getText(), 2, 3, 255, 255, 255);
		this.term.putString("$"+this.game.player.money, 2, 4, 255, 255, 255);
		this.term.putString(this.game.world.level.name, 2, 5, 255, 255, 255);
		// Monster list
		var baseX = 3;
		var baseY = 7;
		for (var i = 0; i < this.game.player.monsterSlots.length; i++){
			var slot = this.game.player.monsterSlots[i];
			if (!slot){
				continue;
			}
			if (i == this.game.input.selectedMonsterSlot){
				this.term.putString(">"+(i+1)+"   "+slot.being.race.name, baseX-1, baseY + i*3, 255, 0, 0);
			} else {
				this.term.putString((i+1)+"   "+slot.being.race.name, baseX, baseY + i*3, 255, 255, 255);
			}
			this.term.put(slot.being.race.tile, baseX + 2, baseY + i*3);
			this.term.putString("  Lv"+slot.being.xpLevel+" HP "+slot.being.hp.getText(), baseX, baseY + i*3 + 1, 255, 255, 255);
			this.term.putString(slot.onPocket ? "  On Pocket" : "  Released", baseX, baseY + i*3 + 2, 255, 255, 255);
		}
		// Monster actions
		baseX = 60;
		baseY = 3;
		var actions = []; //TODO: Cache this
		if (this.game.player.gymTown){
			actions.push({
				key: 'G',
				name: 'Give up'
			});
		}
		if (this.game.input.selectedMonsterSlot !== undefined && this.game.input.selectedMonsterSlot !== false){
			var slot = this.game.player.monsterSlots[this.game.input.selectedMonsterSlot];
			if (slot.onPocket){
				actions.push({
					key: 'R',
					name: 'Release'
				});

			} else {
				actions.push({
					key: 'P',
					name: 'Pull back'
				});
			}
			for (var i = 0; i < slot.being.skills.length; i++){
				actions.push({
					key: slot.onPocket ? '*' : this.SKILL_KEYS[i].key,
					name: slot.being.skills[i].skill.name,
					info: "["+slot.being.skills[i].pp.getText()+"]"
				})
			}
			this.term.putString(slot.being.race.name, baseX + 2, baseY, 255, 255, 255);
			this.term.put(slot.being.race.tile, baseX, baseY);
			this.term.putString("HP "+slot.being.hp.getText()+" Lv"+slot.being.xpLevel, baseX, baseY + 1, 255, 255, 255);
			this.term.putString("("+slot.being.xp+"/"+slot.being.nextLevelXP+")", baseX, baseY + 2, 255, 255, 255);
			this.term.putString("ATK "+slot.being.attack.current, baseX, baseY + 3, 255, 255, 255);
			this.term.putString("DEF "+slot.being.defense.current, baseX+8, baseY + 3, 255, 255, 255);
			this.term.putString("SPA "+slot.being.spAttack.current, baseX, baseY + 4, 255, 255, 255);
			this.term.putString("SPD "+slot.being.spDefense.current, baseX+8, baseY + 4, 255, 255, 255);

			this.term.putString(slot.being.race.name, baseX + 2, baseY, 255, 255, 255);
			this.term.putString(slot.being.race.name, baseX + 2, baseY, 255, 255, 255);

		} 
		for (var i = 0; i < actions.length && i < 5; i++){
			this.term.putString("("+actions[i].key + ")",  baseX, baseY + (i*2) + 6, 255, 0, 0);
			this.term.putString(actions[i].name, baseX+4, baseY + (i*2) + 6, 255, 255, 255);
			if (actions[i].info){
				this.term.putString(actions[i].info, baseX+4, baseY + (i*2)+1 + 6, 255, 255, 255);
			}
		}

		// Show nearby monsters
		baseX = 19;
		baseY = 23;
		for (var i = 0; i < this.game.player.observedMonsters.length && i < 4; i++){
			var monster = this.game.player.observedMonsters[i];
			this.term.putString("  "+monster.race.name, baseX + i * 15, baseY, 255, 255, 255);
			this.term.put(monster.race.tile, baseX  + i * 15, baseY);
			if (monster.hp){
				this.term.putString("Lv"+monster.xpLevel+" HP "+Math.round(monster.hp.getProportion()*100)+"%", baseX + i * 15, baseY + 1, 255, 255, 255);
			}
		}
	},
	SKILL_KEYS: [
		{
			key: "V"
		},
		{
			key: "B"
		},
		{
			key: "N"
		},
		{
			key: "M"
		}
	],
	showInventory: function(){
		this.inventoryBox.draw();
		var xBase = 20;
		var yBase = 0;
		this.term.putString("Inventory", xBase, yBase, 255, 0, 0);
		for (var i = 0; i < this.game.player.items.length; i++){
			var item = this.game.player.items[i];
			if (item == this.game.input.selectedItem){
				this.term.put(this.CURSOR_TILE, xBase, yBase+1+i);
			} else {
				this.term.put(this.BLANK_TILE, xBase, yBase+1+i);
			}
			this.term.put(item.def.tile, xBase+2, yBase+1+i);
			this.term.put(item.def.tile, xBase+2, yBase+1+i);
			this.term.putString(item.def.name, xBase + 4, yBase+1+i, 255, 255, 255);
		}
		this.term.render();
	},
	hideInventory: function(){
		this.term.clear();
		this.refresh();		
	},
	message: function(str){
		this.textBox.addText(str+" ");
		this.textBox.draw();
		this.term.render();
	},
	SCENES: {
		WELCOME: "Welcome to Monster Trainer RL! Select your starter monster using ,",
		VICTORY: "Congratulations, you have become a Monster Master!"
	},
	showScene: function(id){
		this.currentScene = id;
		this.sceneBox.setText(this.SCENES[id]);
		this.game.input.mode = 'SCENE';
		this.sceneBox.draw();
		this.term.putString("Press Enter to continue...", 30, 11, 255, 255, 255);
		this.term.render();
	},
	hideScene: function(){
		this.currentScene = false;
		this.refresh();		
	}
}

},{"./ui/Box.class":35,"./ui/TextBox.class":36}],3:[function(require,module,exports){
module.exports = {
	distance: function (x1, y1, x2, y2) {
    	return Math.sqrt((x2-x1)*(x2-x1) + (y2-y1)*(y2-y1));
	},
	flatDistance: function (x1, y1, x2, y2){
		var xDist = Math.abs(x1 - x2);
		var yDist = Math.abs(y1 - y2);
		if (xDist === yDist)
			return xDist;
		else
			return xDist + yDist;
	}
}
},{}],4:[function(require,module,exports){
var Display = require('./Display');
var World = require('./World');
var Player = require('./Player');
var Input = require('./Input');
var Scenario = require('./Scenario');

var Game = {
	start: function(){
		this.display = Display;
		this.world = World;
		this.player = Player;
		this.input = Input;
		Display.init(this);
		Player.init(this);
		World.init(this);
		Input.init(this);
		Scenario.start(this);
		this.player.updateFOV();
		Display.refresh();
		Display.showScene("WELCOME");
	},
	version: "1.2"
}

window.Game = Game;

module.exports = Game;
},{"./Display":2,"./Input":5,"./Player":14,"./Scenario":16,"./World":19}],5:[function(require,module,exports){
module.exports = {
	inputEnabled: true,
	init: function(game){
		this.game = game;
		ut.initInput(this.onKeyDown.bind(this));
		this.mode = 'MOVEMENT';
		this.SKILL_KEYS = {};
		this.SKILL_KEYS[ut.KEY_V] = 0;
		this.SKILL_KEYS[ut.KEY_B] = 1;
		this.SKILL_KEYS[ut.KEY_N] = 2;
		this.SKILL_KEYS[ut.KEY_M] = 3;
	},
	movedir: { x: 0, y: 0 },
	selectAvailableMonsterSlot: function(){
		this.selectedMonsterSlot = false;
		for (var i = 0; i < this.game.player.monsterSlots.length; i++){
			if (this.game.player.monsterSlots[i]){
				this.selectedMonsterSlot = i;
				return;
			}
		}
	},
	isLeftish: function(k){
		return k === ut.KEY_LEFT || 
			k === ut.KEY_H || 
			k === ut.KEY_NUMPAD4 || k === ut.KEY_NUMPAD1 || k === ut.KEY_NUMPAD7 ||
			k === ut.KEY_Q || k === ut.KEY_A || k === ut.KEY_Z;
	},
	isRightish: function(k){
		return k === ut.KEY_RIGHT || 
			k === ut.KEY_L || 
			k === ut.KEY_NUMPAD6 || k === ut.KEY_NUMPAD9 || k === ut.KEY_NUMPAD3 ||
			k === ut.KEY_E || k === ut.KEY_D || k === ut.KEY_C;
				
	},
	isUppish: function(k){
		return k === ut.KEY_UP || 
			k === ut.KEY_K || 
			k === ut.KEY_NUMPAD8 || k === ut.KEY_NUMPAD7 || k === ut.KEY_NUMPAD9 ||
			k === ut.KEY_Q || k === ut.KEY_W || k === ut.KEY_E;
	},
	isDownish: function(k){
		return k === ut.KEY_DOWN || 
			k === ut.KEY_J || 
			k === ut.KEY_NUMPAD2 || k === ut.KEY_NUMPAD1 || k === ut.KEY_NUMPAD3 ||
			k === ut.KEY_Z || k === ut.KEY_X || k === ut.KEY_C;
	},
	setMoveDir: function(k){
		if (this.isLeftish(k)) {
			this.movedir.x = -1;
		}
		if (this.isRightish(k)) {
			this.movedir.x = 1;
		}
		if (this.isUppish(k)) {
			this.movedir.y = -1;
		}
		if (this.isDownish(k)) {
			this.movedir.y = 1;
		}
	},
	onKeyDown: function(k){
		if (!this.inputEnabled)
			return;
		if (this.mode === "SCENE"){
			if (k === ut.KEY_ENTER){
				this.game.display.hideScene();
				this.mode = "MOVEMENT";
			}
		} else if (this.mode === "PROMPT"){
			if (k === ut.KEY_Y){
				this.promptFunction(true);
			} else if (k === ut.KEY_N){
				this.promptFunction(false);
			}
		} else if (this.mode === 'MOVEMENT'){
			if (k === ut.KEY_COMMA){
				this.game.player.tryPickup();
				return;
			}
			if (k === ut.KEY_I){
				if (this.game.player.items.length === 0){
					this.game.display.message("You don't have any items");
					return;
				}
				this.mode = 'INVENTORY';
				this.selectedItemIndex = 0;
				this.selectedItem = this.game.player.items[0];
				this.game.display.showInventory();
				return;
			}
			// Monster slots
			if (k >= ut.KEY_1 && k <= ut.KEY_6){
				var slot = k-ut.KEY_1;
				if (this.game.player.monsterSlots[slot]){
					this.selectedMonsterSlot = slot;
					this.game.display.refresh();
				}
				return;
			}
			if (k === ut.KEY_R){
				//Release
				var slot = this.game.player.monsterSlots[this.selectedMonsterSlot];
				if (slot && slot.onPocket){
					this.game.display.message("Select a direction.");
					this.mode = 'SELECT_DIRECTION';
					this.directionAction = 'RELEASE_MONSTER';
				}
				return;
			}
			if (k === ut.KEY_G){
				// Give up
				this.game.player.giveUpGymBattle();
				return;
			}
			if (k === ut.KEY_P){
				// Pull back
				var slot = this.game.player.monsterSlots[this.selectedMonsterSlot];
				if (slot && !slot.onPocket){
					this.game.player.pullBack();
				}
				return;
			}
			if (k === ut.KEY_V || k === ut.KEY_B || k === ut.KEY_N || k === ut.KEY_M){
				var slot = this.game.player.monsterSlots[this.selectedMonsterSlot];
				if (slot && !slot.onPocket){
					var index = this.SKILL_KEYS[k];
					slot.being.useSkill(index);
				}
				return;
			}

			// Movement
			this.movedir.x = 0;
			this.movedir.y = 0;
			this.setMoveDir(k);
			if (this.movedir.x === 0 && this.movedir.y === 0){
				return;
			}
			this.inputEnabled = false;
			this.game.player.tryMove(this.movedir);
		} else if (this.mode === 'INVENTORY'){
			if (k === ut.KEY_ESCAPE){
				this.game.display.hideInventory();
				this.mode = 'MOVEMENT';
			} else if (this.isUppish(k)){
				if (this.selectedItemIndex > 0){
					this.selectedItemIndex --;
				}
				this.selectedItem = this.game.player.items[this.selectedItemIndex];
				this.game.display.showInventory();
			} else if (this.isDownish(k)){
				if (this.selectedItemIndex < this.game.player.items.length - 1){
					this.selectedItemIndex ++;
				}
				this.selectedItem = this.game.player.items[this.selectedItemIndex];
				this.game.display.showInventory();
			} else if (k === ut.KEY_D){
				this.game.player.tryDrop(this.selectedItem);
				this.game.display.hideInventory();
				this.mode = 'MOVEMENT';
			} else if (k === ut.KEY_ENTER || k === ut.KEY_U){
				if (this.selectedItem.def.targetted || this.selectedItem.def.type.targetted){
					this.game.display.message("Select a direction.");
					this.game.display.hideInventory();
					this.mode = 'SELECT_DIRECTION';
					this.directionAction = 'USE_ITEM';
				} else {
					this.game.player.tryUse(this.selectedItem);
					this.game.display.hideInventory();
					this.mode = 'MOVEMENT';
				}
			}
		} else if (this.mode === 'SELECT_DIRECTION'){
			if (k === ut.KEY_ESCAPE){
				if (this.directionAction === 'USE_ITEM'){
					this.mode = 'INVENTORY';
					this.game.display.showInventory();
				} else if (this.directionAction === 'RELEASE_MONSTER'){
					this.mode = 'MOVEMENT';
				}
				this.game.display.message("Cancelled.");
				return;
			}
			this.movedir.x = 0;
			this.movedir.y = 0;
			this.setMoveDir(k);
			if (this.movedir.x === 0 && this.movedir.y === 0){
				return;
			}
			if (this.directionAction === 'USE_ITEM'){
				this.game.player.tryUse(this.selectedItem, this.movedir.x, this.movedir.y);
			} else if (this.directionAction === 'RELEASE_MONSTER'){
				this.game.player.releaseMonster(this.movedir);
			}
			this.mode = 'MOVEMENT';
		}
	}
}
},{}],6:[function(require,module,exports){
function Item(def, forSale){
	this.def = def;
	this.forSale = forSale;
}

Item.prototype = {

}

module.exports = Item;
},{}],7:[function(require,module,exports){
var Random = require('./Random');

module.exports = {
	LOADED_CATCHBALL: {
		name: 'Loaded Catchball',
		pickupFunction: function(game, item){
			game.player.getMonster(item.def.race);
		}
	},
	CATCHBALL: {
		name: 'Catchball',
		useFunction: function(game, item, dx, dy){
			if (game.player.getAvailableSlotNumber() === false){
				game.display.message("You don't have any monster slots available");
				return;
			}
			game.display.message("You throw the "+item.def.name+"!");
			game.player.removeItem(item);
			for (var i = 1; i < 5; i++){
				var monster = game.world.level.getBeing(game.player.x+i*dx, game.player.y+i*dy);
				if (monster){
					if (monster.slotNumber !== undefined){
						game.display.message(monster.race.name+" is already in your team.");
					} else {
						var catchChance = 100 - monster.hp.getProportion() * 100 + 5 + (item.def.catchBoost ? item.def.catchBoost : 0);
						if (Random.chance(catchChance)){
							game.display.message("You capture the "+monster.race.name+"!");
							game.player.addMonster(monster);
							game.world.level.removeBeing(monster);
						} else {
							game.display.message("The "+monster.race.name+" breaks free!");
						}
					}
					game.player.endTurn();
					return;
				}
				if (!game.world.level.canWalkTo(game.player.x+i*dx, game.player.y+i*dy)){
					break;
				}
			}
			i--;
			game.world.level.addItem(item, game.player.x+i*dx, game.player.y+i*dy);
			game.player.endTurn();
		},
		targetted: true
	},
	POTION: {
		name: 'Potion',
		useFunction: function(game, item, dx, dy){
			var monster = game.world.level.getBeing(game.player.x+dx, game.player.y+dy);
			if (monster){
				game.display.message("The "+monster.race.name+" recovers "+item.def.points+" HP.");
				game.player.removeItem(item);
				monster.recoverHP(item.def.points);
				game.player.endTurn();
			} else {
				game.display.message("There's no monster there");
			}
		},
		targetted: true
	},
	BADGE: {
		name: "Badge",
		useFunction: function(game, item){
			game.display.message("You proudly show off the "+item.def.name+".");
		}
	}
}
},{"./Random":15}],8:[function(require,module,exports){
var ItemType = require('./ItemType.enum');
var Races = require('./monster/Races.enum');

module.exports = {
	CATCHBALL: {
		type: ItemType.CATCHBALL,
		name: 'Catchball',
		tile: new ut.Tile('*', 255, 0, 0),
		cost: 100
	},
	GREATBALL: {
		type: ItemType.CATCHBALL,
		name: 'Great Ball',
		tile: new ut.Tile('*', 0, 255, 0),
		catchBoost: 10,
		cost: 200
	},
	ULTRABALL: {
		type: ItemType.CATCHBALL,
		name: 'Ultra Ball',
		tile: new ut.Tile('*', 0, 255, 0),
		catchBoost: 20,
		cost: 500
	},
	POTION: {
		type: ItemType.POTION,
		name: 'Potion',
		tile: new ut.Tile('!', 255, 255, 0),
		points: 50,
		cost: 50
	},
	SUPER_POTION: {
		type: ItemType.POTION,
		name: 'Super Potion',
		tile: new ut.Tile('!', 0, 255, 255),
		points: 150,
		cost: 100
	},
	HYPER_POTION: {
		type: ItemType.POTION,
		name: 'Hyper Potion',
		tile: new ut.Tile('!', 0, 255, 255),
		points: 400,
		cost: 100
	},
	MAX_POTION: {
		type: ItemType.POTION,
		name: 'Max Potion',
		tile: new ut.Tile('!', 0, 255, 255),
		points: 1000,
		cost: 100
	},

	BOULDER_BADGE: {
		type: ItemType.BADGE,
		name: 'Boulder Badge',
		tile: new ut.Tile('O', 255, 255, 255)
	},
	CASCADE_BADGE: {
		type: ItemType.BADGE,
		name: 'Cascade Badge',
		tile: new ut.Tile('O', 255, 255, 255)
	},
	THUNDER_BADGE: {
		type: ItemType.BADGE,
		name: 'Thunder Badge',
		tile: new ut.Tile('O', 255, 255, 255)
	},
	RAINBOW_BADGE: {
		type: ItemType.BADGE,
		name: 'Rainbow Badge',
		tile: new ut.Tile('O', 255, 255, 255)
	},
	MARSH_BADGE: {
		type: ItemType.BADGE,
		name: 'Marsh Badge',
		tile: new ut.Tile('O', 255, 255, 255)
	},

	CHARMANDER_CATCHBALL: {
		type: ItemType.LOADED_CATCHBALL,
		name: 'Charmander',
		tile: new ut.Tile('*', 255, 0, 0),
		race: Races.CHARMANDER
	},
	BULBASAUR_CATCHBALL: {
		type: ItemType.LOADED_CATCHBALL,
		name: 'Bulbasaur',
		tile: new ut.Tile('*', 0, 128, 0),
		race: Races.BULBASAUR
	},
	SQUIRTLE_CATCHBALL: {
		type: ItemType.LOADED_CATCHBALL,
		name: 'Squirtle',
		tile: new ut.Tile('*', 83, 255, 255),
		race: Races.SQUIRTLE
	},
	PIKACHU_CATCHBALL: {
		type: ItemType.LOADED_CATCHBALL,
		name: 'Pikachu',
		tile: new ut.Tile('*', 255, 255, 83),
		race: Races.PIKACHU
	}

}
},{"./ItemType.enum":7,"./monster/Races.enum":29}],9:[function(require,module,exports){
var Distance = require('./Distance');
var Random = require('./Random');
var Being = require('./Being.class');

var Level = function(game, id){
	this.init(game, id);
}

Level.prototype = {
	init: function(game, id){
		this.map = [];
		this.beings = [];
		this.beingsList = [];
		this.exits = [];
		this.exitsMap = [];
		this.items = [];
		this.spawnPositions = []; // For respawning
		this.spawnCounter = 200;

		this.storePlaces = []; // For restocking

		this.game = game;
		this.id = id;
		this.player = game.player;
	},
	getBeing: function(x, y){
		if (!this.beings[x])
			return false;
		return this.beings[x][y];
	},
	respawnMonsters: function(){
		var initialPopulation = this.initialPopulation + Random.n(0,5);
		var currentMonsters = this.beingsList.length;
		initialPopulation -= currentMonsters;
		var level = this;
		for (var i = 0; i < initialPopulation; i++){
			var spawnPosition = level.spawnPositions.length > 0 ? Random.from(level.spawnPositions) : false;
			if (spawnPosition){
				var x = spawnPosition.x;
				var y = spawnPosition.y;
			}
			if (!spawnPosition || level.getBeing(x, y)){
				// Place somewhere else
				x = Random.n(0,this.map.length-1);
				y = Random.n(0,this.map[0].length-1);
			}
			if (Distance.distance(x,y,this.game.player.x, this.game.player.y) < 12){
				continue;
			}
			var wm = Random.fromWeighted(this.wildMonsters);
			var being = new Being(level.game, level, wm.race, wm.level);
			level.addBeing(being, x, y);
			if (wm.race.aggressive){
				being.intent = 'CHASE';
			} else if (wm.race.trainer){
				being.intent = 'TRAINER';
			} else {
				being.intent = 'STILL';
			}
		}
	},
	beingsTurn: function(){
		this.spawnCounter--;
		if (this.spawnCounter === 0){
			this.respawnMonsters();
		}
		this.beingsList.sort(this.speedSorter);
		/*
		this.beingsList.map(function(monster, i){
			console.log(i+": "+monster.race.name+" "+monster.getEffectiveSpeed());
		})
		*/
		for (var i = 0; i < this.beingsList.length; i++){
			this.beingsList[i].endTurn();
			this.beingsList[i].act();
		}
		this.player.updateFOV();
		this.game.display.refresh();
		this.game.input.inputEnabled = true;
	},
	speedSorter: function(a, b){
		return b.getEffectiveSpeed() - a.getEffectiveSpeed();
	},
	addBeing: function(being, x, y){
		this.beingsList.push(being);
		if (!this.beings[x])
			this.beings[x] = [];
		being.x = x;
		being.y = y;
		this.beings[x][y] = being;
	},
	removeBeing: function(being){
		this.beings[being.x][being.y] = false;
		this.beingsList.splice(this.beingsList.indexOf(being), 1);
	},
	getCell: function(x, y){
		try {
			return this.map[x][y];
		} catch (e){
			// Catch OOB
			return false;
		}
	},
	canWalkTo: function(x, y){
		try {
			if (this.map[x][y].solid){
				return false;
			}
		} catch (e){
			// Catch OOB
			return false;
		}
		if (this.beings[x] && this.beings[x][y]){
			return false;
		}
		return true;
	},
	addExit: function(x,y, levelId, tile){
		if (!this.exits[x])
			this.exits[x] = [];
		this.exits[x][y] = levelId;
		this.exitsMap[levelId] = {
			x: x,
			y: y
		};
	},
	getExit: function(levelId){
		return this.exitsMap[levelId];
	},
	addItem: function(item, x, y){
		if (!this.items[x])
			this.items[x] = [];
		this.items[x][y] = item;
	},
	getItem: function(x, y){
		if (!this.items[x])
			return false;
		return this.items[x][y];
	},
	removeItem: function(x, y){
		if (!this.items[x])
			this.items[x] = [];
		this.items[x][y] = false;
	},
}

module.exports = Level;
},{"./Being.class":1,"./Distance":3,"./Random":15}],10:[function(require,module,exports){
var Tiles = require('./Tiles.enum');
var NPCRaces = require('./NPCRaces.enum');
var Items = require('./Items.enum');
var Being = require('./Being.class');
var Item = require('./Item.class');
var CA = require('./ca/CA');
var Rule = require('./ca/Rule.class');
var Random = require('./Random');
var Direction = require('./util/Direction');

module.exports = {
	generateTestLevel: function(level, specs){
		this.level = level;
		this.level.name = specs.name;
		switch (specs.type){
			case "TOWN":
				this.basicFill(level, specs);
				this.buildTown(level, specs);
				break;
			case "ROUTE":
				this.basicFill(level, specs);
				this.buildRoute(level, specs);
				break;
			case "GYM":
				this.buildGym(level, specs);
				break;
		}
		if (specs.wildMonsters){
			level.initialPopulation = specs.initialPopulation;
			level.wildMonsters = specs.wildMonsters;
			level.respawnMonsters();
		}
		for (var i = 0; i < specs.exits.length; i++){
			var xs = Math.round(specs.width/2);
			var ys = Math.round(specs.height/2);
			var exit = specs.exits[i];
			switch (exit.dir){
				case 'UP':
					ys = 0;
					break;
				case 'DOWN':
					ys = specs.height-1;
					break;
				case 'LEFT':
					xs = 0;
					break;
				case 'RIGHT':
					xs = specs.width-1;
					break;
			}
			var dx = Direction.dxMap[Direction.opposite[exit.dir]];
			switch (specs.type){
				case "TOWN":
					level.map[xs][ys] = Tiles.GRASS;
					level.map[xs+dx.x][ys+dx.y] = Tiles.GRASS;
					if (dx.x == 0){
						level.map[xs+1][ys] = Tiles.FENCE;
						level.map[xs-1][ys] = Tiles.FENCE;
					} else {
						level.map[xs][ys+1] = Tiles.FENCE;
						level.map[xs][ys-1] = Tiles.FENCE;
					}
					break;
				case "ROUTE":
				case "GYM":
					level.map[xs][ys] = Tiles.STAIRS_DOWN;
					break;
			}

			
			level.addExit(xs, ys, exit.toId);
		}
		if (specs.startPosition){
			level.player.x = specs.startPosition.x;
			level.player.y = specs.startPosition.y;
		}
	},
	CA_GRASS_RULES: [
		new Rule(Tiles.GRASS, Rule.MORE_THAN, 2, Tiles.TALL_GRASS, Tiles.TALL_GRASS, 50)
	],
	basicFill: function(level, specs){
		for (var x = 0; x < specs.width; x++){
			level.map[x] = [];
			for (var y = 0; y < specs.height; y++){
				level.map[x][y] = Tiles.GRASS;
			}
		}
		for (var i = 0; i < 40; i++){
			level.map[Random.n(0,specs.width-1)][Random.n(0,specs.height-1)] = Tiles.BUSH;
		}
	},
	buildRoute: function(level, specs){
		// Place a road based on the orientation and some patches of grass
		switch (specs.orientation){
			case "HORIZONTAL":
				var midy = Math.round(specs.height/2);
				for (var x = 0; x < specs.width; x++){
					for (var y = midy-5; y < midy + 2; y++){
						this.level.map[x][y] = Tiles.ROAD;
					}
				}
			break;
			case "VERTICAL":
				var midx = Math.round(specs.width/2);
				for (var x = midx-5; x < midx+5; x++){
					for (var y = 0; y < specs.height; y++){
						this.level.map[x][y] = Tiles.ROAD;
					}
				}
			break;
		}
		var patches = Random.n(3,10);
		for (var i = 0; i < patches; i++){
			var w = Random.n(8,10);
			var h = Random.n(8,10);
			var x = Random.n(0,specs.width - w - 1);
			var y = Random.n(0,specs.height - h - 1);
			for (var xx = x; xx < x + w; xx++){
				for (var yy = y; yy < y + h; yy++){
					if (Random.chance(80)){
						this.level.map[xx][yy] = Tiles.TALL_GRASS;
					}
					if (xx > x + 3 && xx < x + w - 3 && yy > y + 3 && yy < y + h - 3 && Random.chance(30)){
						this.level.spawnPositions.push({x: xx, y: yy});
					}
				}
			}
		}
		// Run a Non deterministic CA to smooth patches of grass
		CA.runCA(level.map, this.CA_GRASS_RULES, 4);
	},
	buildTown: function(level, specs){
		// Place the borders
		for (var xx = 1; xx < specs.width - 1; xx++){
			this.level.map[xx][1] = Tiles.FENCE;
			this.level.map[xx][specs.height - 2] = Tiles.FENCE;
		}
		for (var yy = 1; yy < specs.height - 1; yy++){
			this.level.map[1][yy] = Tiles.FENCE;
			this.level.map[specs.width - 2][yy] = Tiles.FENCE;
		}

		// Place houses based on specs on a grid
		var grid = [];
		var gridx = Math.floor((specs.width - 6) / 10);
		var gridy = Math.floor((specs.height - 6) / 10);
		for (var i = 0; i < gridx; i++){
			grid[i] = [];
		}
		for (var i = 0; i < specs.features.length; i++){
			var feature = specs.features[i];
			var x = feature.x;
			var y = feature.y;
			var w = feature.w;
			var h = feature.h;
			if (!w)
				w = Random.n(7,9);
			if (!h)
				h = Random.n(7,9);
			if (!x){
				x = Random.n(0,gridx-1);
			}
			if (!y){
				y = Random.n(0,gridy-1);
			}
			while (grid[x][y]){
				x = Random.n(0,gridx-1);
				y = Random.n(0,gridy-1);	
			}
			grid[x][y] = true;
			x = x * 10 + Random.n(0,10-w-1) + 3;
			y = y * 10 + Random.n(0,10-h-1) + 3;
			this.fillFeature(feature, x, y, w, h);
		}
	},
	fillFeature: function(feature, x, y, w, h){
		switch (feature.type){
			case 'myHouse':
				this.fillMyHouse(x,y,w,h);
				break;
			case 'lab':
				this.fillLab(x,y,w,h, feature.monsters);
				break;
			case 'house':
				this.fillHouse(x,y,w,h);
				break;
			case 'pond':
				this.fillPond(x,y,w,h);
				break;
			case 'mart':
				this.fillMart(x,y,w,h, feature.items);
				break;
			case 'hospital':
				this.fillHospital(x,y,w,h);
				break;
			case 'gym':
				this.fillGym(x,y,w,h, feature);
				break;
		}
	},
	fillHouse: function(x, y, w, h){
		for (var xx = x; xx < x + w; xx++){
			for (var yy = y; yy < y + h; yy++){
				if (xx === x || xx === x + w - 1 || yy === y || yy === y + h - 1){
					this.level.map[xx][yy] = Tiles.WALL;
				} else {
					this.level.map[xx][yy] = Tiles.FLOOR;
				}
			}
		}
		// Place door
		var xd = x + 2 + Random.n(0, w - 4);
		var yd = y + 2 + Random.n(0, h - 4);
		switch (Random.n(0,3)){
			case 0:
				yd = y;
				break;
			case 1:
				yd = y+h-1;
				break;
			case 2:
				xd = x;
				break;
			case 3:
				xd = x+w-1;
				break;
		}
		this.level.map[xd][yd] = Tiles.FLOOR;
	},
	fillLab: function(x, y, w, h, monsters){
		this.fillHouse(x,y,w,h);
		monsters.forEach(function(monster){
			while (true){
				var xx = Random.n(x+1, x + w -2);
				var yy = Random.n(y+1, y + h -2);
				if (!this.level.getBeing(xx, yy) && !this.level.getItem(xx, yy)){
					break;
				}
			}
			this.level.addItem(new Item(monster), xx, yy);
		}, this);
		while (true){
			var xx = Random.n(x+1, x + w -2);
			var yy = Random.n(y+1, y + h -2);
			if (!this.level.getItem(xx, yy)){
				break;
			}
		}
		var proffessor = new Being(this.level.game, this.level, NPCRaces.PROFFESSOR);
		this.level.addBeing(proffessor, xx, yy);
		proffessor.isTrainer = true;
		proffessor.intent = 'STILL';
	},
	fillMyHouse: function(x, y, w, h){
		this.fillHouse(x,y,w,h);
	},
	fillPond: function(x, y, w, h){
		for (var xx = x; xx < x + w; xx++){
			for (var yy = y; yy < y + h; yy++){
				this.level.map[xx][yy] = Tiles.WATER;
			}
		}
	},
	_fillWithCounter: function(x, y, w, h, clerk){
		for (var xx = x; xx < x + w; xx++){
			for (var yy = y; yy < y + h; yy++){
				if (xx === x || xx === x + w - 1 || yy === y || yy === y + h - 1){
					this.level.map[xx][yy] = Tiles.WALL;
				} else {
					this.level.map[xx][yy] = Tiles.FLOOR;
				}
			}
		}
		// Place door, counter and clerk
		var xd = x + 2 + Random.n(0, w - 4);
		var yd = y + 2 + Random.n(0, h - 4);
		switch (Random.n(0,3)){
			case 0:
				yd = y;
				break;
			case 1:
				yd = y+h-1;
				break;
			case 2:
				xd = x;
				break;
			case 3:
				xd = x+w-1;
				break;
		}
		this.level.map[xd][yd] = Tiles.FLOOR;
		var cx = xd;
		var cy = yd;
		var itemAreaBounds = {
			x1: x+1,
			y1: y+1,
			x2: x+w-2,
			y2: y+h-2,
		};
		if (xd === x){
			cx = x + w - 2;
			for (var yy = y+1; yy < y + h -1; yy++){
				this.level.map[x + w - 3][yy] = Tiles.V_COUNTER;
			}
			itemAreaBounds.x2 = x + w - 4;
		} else if (xd === x + w - 1){
			cx = x + 1;
			for (var yy = y+1; yy < y + h -1; yy++){
				this.level.map[x + 2][yy] = Tiles.V_COUNTER;
			}
			itemAreaBounds.x1 = x + 3;
		} else if (yd === y){
			cy = y + h - 2;
			for (var xx = x + 1; xx < x + w - 1; xx++){
				this.level.map[xx][y+h-3] = Tiles.H_COUNTER;
			}
			itemAreaBounds.y2 = y + h - 4;
		} else {
			cy = y + 1;
			for (var xx = x + 1; xx < x + w - 1; xx++){
				this.level.map[xx][y+2] = Tiles.H_COUNTER;
			}
			itemAreaBounds.y1 = y + 3;
		}
		this.level.addBeing(new Being(this.level.game, this.level, clerk), cx, cy);
		return itemAreaBounds;
	},
	fillHospital: function(x, y, w, h){
		this._fillWithCounter(x, y, w, h, NPCRaces.NURSE);
	},
	fillMart: function(x, y, w, h, items){
		var itemAreaBounds = this._fillWithCounter(x, y, w, h, NPCRaces.STORE_CLERK)
		// Let's make this Nethack style lol!
		for (var xx = itemAreaBounds.x1; xx <= itemAreaBounds.x2; xx++){
			for (var yy = itemAreaBounds.y1; yy <= itemAreaBounds.y2; yy++){
				if (Random.chance(80)){
					this.level.addItem(new Item(Random.fromWeighted(items).item, true), xx, yy);
				}
				this.level.storePlaces.push({x: xx, y: yy});
			}
		}
	},
	fillGym: function(x, y, w, h, feature){
		for (var xx = x; xx < x + w; xx++){
			for (var yy = y; yy < y + h; yy++){
				this.level.map[xx][yy] = Tiles.WALL;
			}
		}
		// Place door
		var xd = x + 2 + Random.n(0, w - 4);
		var yd = y + 2 + Random.n(0, h - 4);
		switch (Random.n(0,3)){
			case 0:
				yd = y;
				break;
			case 1:
				yd = y+h-1;
				break;
			case 2:
				xd = x;
				break;
			case 3:
				xd = x+w-1;
				break;
		}
		this.level.map[xd][yd] = Tiles.GYM_ENTRANCE;
		this.level.addExit(xd, yd, feature.toId);
		this.level.gymInfo = feature;
	},
	buildGym: function(level, specs){
		for (var x = 0; x < specs.width; x++){
			level.map[x] = [];
			for (var y = 0; y < specs.height; y++){
				level.map[x][y] = Tiles.FLOOR;
			}
		}
		var trainer = new Being(level.game, level, specs.trainer.race);
		level.addBeing(trainer, Math.floor(specs.width/2), 3);
		trainer.intent = 'TRAINER';
		trainer.isTrainer = true;
		trainer.monsters = specs.trainer.monsters.map(function(monsterSpec){
			var being = new Being(level.game, level, monsterSpec.race, monsterSpec.level);
			being.isTame = true;
			being.owner = trainer;
			return being;
		}, this);
		trainer.prize = specs.badge;
		trainer.prizeMoney = specs.gymNumber * 1500;
	},

}
},{"./Being.class":1,"./Item.class":6,"./Items.enum":8,"./NPCRaces.enum":13,"./Random":15,"./Tiles.enum":18,"./ca/CA":21,"./ca/Rule.class":23,"./util/Direction":37}],11:[function(require,module,exports){
var Races = require('./monster/Races.enum');
var Items = require('./Items.enum');

module.exports = {
	cities: 4,
	towns: 1,
	startingMonsters: [
		Items.CHARMANDER_CATCHBALL,
		Items.BULBASAUR_CATCHBALL,
		Items.SQUIRTLE_CATCHBALL,
		Items.PIKACHU_CATCHBALL
	],
	items: [
		{
			item: Items.CATCHBALL,
			weight: 100,
			tier: 1
		},
		{
			item: Items.GREATBALL,
			weight: 20,
			tier: 2
		},
		{
			item: Items.ULTRABALL,
			weight: 20,
			tier: 3
		},
		{
			item: Items.POTION,
			weight: 100,
			tier: 1
		},
		{
			item: Items.SUPER_POTION,
			weight: 5,
			tier: 2
		},
		{
			item: Items.HYPER_POTION,
			weight: 5,
			tier: 3
		},
		{
			item: Items.MAX_POTION,
			weight: 5,
			tier: 4
		}
	],
	routeStereotypes: [
		{
			monsters: [
				{
					race: Races.RATTATA,
					weight: 45
				},
				{
					race: Races.PIDGEY,
					levelBoost: 1,
					weight: 55
				}
			]
		},
		{
			monsters: [
				{
					race: Races.CATERPIE,
					weight: 15
				},
				{
					race: Races.WEEDLE,
					weight: 15
				},
				{
					race: Races.PIDGEY,
					weight: 40
				},
				{
					race: Races.RATTATA,
					weight: 45
				}
			]
		},
		{
			monsters: [
				{
					race: Races.PIDGEY,
					levelBoost: 1,
					weight: 50
				},
				{
					race: Races.SPEAROW,
					levelBoost: 1,
					weight: 40
				},
				{
					race: Races.JIGGLYPUFF,
					weight: 10
				}
			]
		},
		{
			monsters: [
				{
					race: Races.RATTATA,
					levelBoost: 1,
					weight: 45
				},
				{
					race: Races.SPEAROW,
					levelBoost: 1,
					weight: 30
				},
				{
					race: Races.EKANS,
					weight: 25
				},
				{
					race: Races.SANDSHREW,
					weight: 25
				}
			]
		},
		{
			monsters: [
				{
					race: Races.RATTATA,
					weight: 45
				},
				{
					race: Races.SPEAROW,
					weight: 30
				},
				{
					race: Races.EKANS,
					weight: 25
				},
				{
					race: Races.SANDSHREW,
					weight: 25
				}
			]
		},
		{
			monsters: [
				{
					race: Races.PIDGEY,
					weight: 35
				},
				{
					race: Races.ODDISH,
					weight: 40
				},
				{
					race: Races.MEOWTH,
					weight: 25
				},
				{
					race: Races.MANKEY,
					weight: 25
				},
				{
					race: Races.BELLSPROUT,
					weight: 40
				}
			]
		},
		{
			monsters: [
				{
					race: Races.PIDGEY,
					weight: 35
				},
				{
					race: Races.VULPIX,
					weight: 10
				},
				{
					race: Races.ODDISH,
					weight: 25
				},
				{
					race: Races.MEOWTH,
					weight: 30
				},
				{
					race: Races.MANKEY,
					weight: 30
				},
				{
					race: Races.GROWLITHE,
					weight: 30
				},
				{
					race: Races.BELLSPROUT,
					weight: 25
				}
			]
		},
		{
			monsters: [
				{
					race: Races.PIDGEY,
					weight: 35
				},
				{
					race: Races.EKANS,
					weight: 20
				},
				{
					race: Races.SANDSHREW,
					weight: 20
				},
				{
					race: Races.VULPIX,
					weight: 20
				},
				{
					race: Races.MEOWTH,
					weight: 25
				},
				{
					race: Races.GROWLITHE,
					weight: 20
				},
				{
					race: Races.MANKEY,
					weight: 25
				}
			]
		},
		{
			monsters: [
				{
					race: Races.SPEAROW,
					weight: 30
				},
				{
					race: Races.EKANS,
					weight: 25
				},
				{
					race: Races.SANDSHREW,
					weight: 25
				},
				{
					race: Races.VOLTORB,
					weight: 45
				}
			]
		},
		{
			monsters: [
				{
					race: Races.SPEAROW,
					weight: 30
				},
				{
					race: Races.EKANS,
					weight: 45
				},
				{
					race: Races.SANDSHREW,
					weight: 45
				},
				{
					race: Races.DROWZEE,
					weight: 25
				}
			]
		},
		{
			monsters: [
				{
					race: Races.PIDGEY,
					weight: 35
				},
				{
					race: Races.ODDISH,
					weight: 40
				},
				{
					race: Races.GLOOM,
					weight: 5
				},
				{
					race: Races.VENONAT,
					weight: 20
				},
				{
					race: Races.BELLSPROUT,
					weight: 40
				},
				{
					race: Races.WEEPINBELL,
					weight: 5
				}
			]
		},
	],
	gymStereotypes: {
		ROCK: {
			monsters: [
				{
					race: Races.ONIX,
					levelBoost: 5,
					weight: 60
				},
				{
					race: Races.GEODUDE,
					weight: 60
				},
				{
					race: Races.GRAVELER,
					weight: 20
				}
			],
			badge: Items.BOULDER_BADGE
		},
		WATER: {
			monsters: [
				{
					race: Races.STARMIE,
					levelBoost: 5,
					weight: 60
				},
				{
					race: Races.STARYU,
					weight: 20
				}
			],
			badge: Items.CASCADE_BADGE
		},
		ELECTRIC: {
			monsters: [
				{
					race: Races.VOLTORB,
					weight: 20
				},
				{
					race: Races.PIKACHU,
					weight: 60
				},
				{
					race: Races.RAICHU,
					levelBoost: 5,
					weight: 60
				}
			],
			badge: Items.THUNDER_BADGE
		},
		GRASS: {
			monsters: [
				{
					race: Races.VOLTORB,
					weight: 20
				},
				{
					race: Races.PIKACHU,
					weight: 60
				},
				{
					race: Races.RAICHU,
					levelBoost: 5,
					weight: 60
				}
			],
			badge: Items.RAINBOW_BADGE
		},
		PSYCHIC: {
			monsters: [
				{
					race: Races.VOLTORB,
					weight: 20
				},
				{
					race: Races.PIKACHU,
					weight: 60
				},
				{
					race: Races.RAICHU,
					levelBoost: 5,
					weight: 60
				}
			],
			badge: Items.MARSH_BADGE
		}
	}
}
},{"./Items.enum":8,"./monster/Races.enum":29}],12:[function(require,module,exports){
var NPCRaces = require('./NPCRaces.enum');
var Items = require('./Items.enum');
var Direction = require('./util/Direction')
var Random = require('./Random');
var MasterPlans = require('./MasterPlans');
var TownNameGen = require('./procgen/TownNames');

module.exports = {
	plansComplete: function(){
		return this.remainingTowns === 0 && this.remainingCities === 0;
	},
	generateMetadata: function(){
		this.exits = [];
		this.metadata = {};
		this.currentRouteId = 0;
		this.currentTownId = 0;
		this.currentGymId = 0;
		this.masterPlans = MasterPlans;
		this.supermap = {
			x: 0,
			y: 0,
			minx: 0,
			miny: 0,
			maxx: 0,
			maxy: 0,
			map: []
		};

		if (Object.keys(this.masterPlans.gymStereotypes).length < this.masterPlans.cities){
			throw "Not enough gym stereotypes";
		}

		this.remainingTowns = this.masterPlans.towns;
		this.remainingCities = this.masterPlans.cities;
		this.placeTown({starting: true});
		while (!this.plansComplete()){
			if (Random.chance(50) && this.remainingTowns > 0){
				this.placeTown({});
				this.remainingTowns--;
			}
			if (Random.chance(50) && this.remainingCities > 0){
				this.placeTown({hasGym: true});
				this.remainingCities--;
			}
		}
		return this.metadata;
	},
	showSupermap: function(){
		// Normalize
		for (var y = this.supermap.miny; y <= this.supermap.maxy; y++){
			var str = "";
			for (var x = this.supermap.minx; x <= this.supermap.maxx; x++){
				if (this.supermap.map[x] && this.supermap.map[x][y]){
					str += (this.supermap.map[x][y]+"        ").substring(0,8);
				} else {
					str += "        ";
				}
			}
			console.log((y-this.supermap.miny)+":"+str);
		}
		console.log("---------");
	},
	addToSuperMap: function(id){
		if (!this.supermap.map[this.supermap.x]){
			this.supermap.map[this.supermap.x] = [];
		}
		this.supermap.map[this.supermap.x][this.supermap.y] = id;
		if (this.supermap.x < this.supermap.minx){
			this.supermap.minx = this.supermap.x;
		}
		if (this.supermap.y < this.supermap.miny){
			this.supermap.miny = this.supermap.y;
		}
		if (this.supermap.x > this.supermap.maxx){
			this.supermap.maxx = this.supermap.x;
		}
		if (this.supermap.y > this.supermap.maxy){
			this.supermap.maxy = this.supermap.y;
		}
	},
	isClear: function(x, y, dir){
		return !(this.supermap.map[x+dir.x] && this.supermap.map[x+dir.x][y+dir.y]) &&
			   !(this.supermap.map[x+dir.x*2] && this.supermap.map[x+dir.x*2][y+dir.y*2])
	},
	placeTown: function(specs){
		if (this.exits.length === 0){
			// First town
			this.supermap.x = 0;
			this.supermap.y = 0;
			var townId = this.createTown(specs);
			this.metadata._startingLevelId = townId;
			this.addToSuperMap(townId);
			
		} else {
			while (true){
				var exit = Random.from(this.exits);
				var dx = Direction.dxMap[exit.direction];
				if (this.isClear(exit.x, exit.y, dx)){
					break;
				}
			}

			this.exits.splice(this.exits.indexOf(exit), 1);

			this.supermap.x = exit.x;
			this.supermap.y = exit.y;

			var currentMetadata = this.metadata[exit.fromId];
			this.currentRouteId++;
			var routeId = "ROUTE_"+this.currentRouteId;
			currentMetadata.exits.push({
				dir: exit.direction,
				toId: routeId
			});
			var orientation = dx.x === 0 ? "VERTICAL" : "HORIZONTAL";
			this.supermap.x += dx.x;
			this.supermap.y += dx.y;
			this.addToSuperMap(routeId);

			var routeStereotype = Random.from(this.masterPlans.routeStereotypes, true);

			this.metadata[routeId] = {
				type: 'ROUTE',
				orientation: orientation,
				name: 'Route '+this.currentRouteId,
				width: orientation === "VERTICAL" ? 32 : 64,
				height: orientation === "VERTICAL" ? 64 : 32,
				initialPopulation: 5,
				wildMonsters: routeStereotype.monsters,
				exits: [
					{
						dir: Direction.opposite[exit.direction],
						toId: exit.fromId
					}
				]
			}
			this.metadata[routeId].wildMonsters = this.metadata[routeId].wildMonsters.map(function(spec){
				return {
					race: spec.race,
					level: this.currentRouteId * 3 + (spec.levelBoost ? spec.levelBoost : 0),
					weight: spec.weight
				}
			}, this);
			this.supermap.x += dx.x;
			this.supermap.y += dx.y;
			var townId = this.createTown(specs, Direction.opposite[exit.direction], routeId);
			this.metadata[routeId].exits.push({
				dir: exit.direction,
				toId: townId
			});
			this.addToSuperMap(townId);
		}
	},
	createTown: function(specs, fromDir, fromId){
		// Creates a town and puts this.exits
		this.currentTownId++;
		var townId = "TOWN_"+this.currentTownId;
		var townName = TownNameGen.generateName()+(specs.hasGym?" City":" Town");;
		var metadata = {
			type: 'TOWN',
			name: townName,
			width: 48,
			height: 48,
			exits: []
		}
		this.metadata[townId] = metadata;
		metadata.features = [];
		if (specs.starting){
			metadata.startPosition = {
				x: 16,
				y: 16
			};
			metadata.features.push(
				{ // Hero's house
					type: 'myHouse'
				}
			);
			metadata.features.push(
				{ // Oak's Lab
					type: 'lab',
					monsters: this.masterPlans.startingMonsters,
					x: 1,
					y: 1
				}
			);
			metadata.features.push(
				{
					// Rival's house (empty)
					type: 'house'
				}
			);
		}
		var houses = Random.n(0,3);
		for (var i = 0; i < houses; i++){
			metadata.features.push(
				{
					type: 'house'
				}
			);
		}
		if (specs.hasGym){ //TODO: Separate hasMart
			var maxTier = Math.floor(this.currentTownId / (this.masterPlans.cities+this.masterPlans.towns)) * 4;
			if (maxTier < 1)
				maxTier = 1;
			metadata.features.push(
				{
					type: 'mart',
					items: this.masterPlans.items.filter(function(itemDef){return itemDef.tier <= maxTier;})
				}
			);
			metadata.features.push(
				{
					type: 'hospital'
				}
			);
		}
		if (Random.chance(10)){
			metadata.features.push(
				{
					type: 'pond'
				}
			);
		}
		if (specs.starting){
			// A single exit for the starting town
			this.exits.push({
				x: this.supermap.x,
				y: this.supermap.y,
				direction: "UP",
				fromId: townId
			});
		} else {
			for (var i = 0; i < Direction.CARDINALS.length; i++){
				if (fromDir === Direction.CARDINALS[i]){
					continue;
				}
				this.exits.push({
					x: this.supermap.x,
					y: this.supermap.y,
					direction: Direction.CARDINALS[i],
					fromId: townId
				});
			}
		}
		if (fromDir){
			metadata.exits.push({
				dir: fromDir,
				toId: fromId
			});
		}

		if (specs.hasGym){
			this.currentGymId++;
			var gymId = "GYM" + this.currentGymId;
			metadata.features.push(
				{
					type: 'gym',
					name: townName+" Gym",
					toId: gymId
				}
			);
			var gymStereotype = Random.fromObject(this.masterPlans.gymStereotypes, true);
			var numberOfMonsters = Random.n(3,4);
			var gymMonsters = [];
			for (var i = 0; i < numberOfMonsters; i++){
				var monsterSpec = Random.fromWeighted(gymStereotype.monsters);
				var monsterRace = monsterSpec.race;
				var levelBoost = monsterSpec.levelBoost ? monsterSpec.levelBoost : 0;
				levelBoost += Random.n(0,3);
				gymMonsters.push({
					race: monsterRace,
					level: this.currentGymId * 5 + 5 + levelBoost
				});
			}
			
			var gymMetadata = {
				type: 'GYM',
				name: townName+" Gym",
				width: 24,
				height: 24,
				exits: [
					{
						dir: "DOWN",
						toId: townId
					}
				],
				trainer: {
					race: NPCRaces.GYM_LEADER,
					monsters: gymMonsters
				},
				gymNumber: this.currentGymId,
				badge: gymStereotype.badge
			}
			this.metadata[gymId] = gymMetadata;
		}
		return townId;
	}
}
},{"./Items.enum":8,"./MasterPlans":11,"./NPCRaces.enum":13,"./Random":15,"./procgen/TownNames":34,"./util/Direction":37}],13:[function(require,module,exports){
module.exports = {
	STORE_CLERK: {
		name: "Store Clerk",
		tile: new ut.Tile('@', 0, 255, 0),
		hp: 20,
		speed: 50,
		interact: function(player){
			player.game.display.message("Welcome! please grab the items you would be interested on!");
		}
	},
	NURSE: {
		name: "Nurse",
		tile: new ut.Tile('@', 255, 85, 255),
		hp: 20,
		speed: 50,
		interact: function(player){
			player.game.display.message("Would you like me to heal your monsters back to perfect health? [Y/N]");
			player.game.input.promptFunction = function(confirm){
				if (confirm){
					player.game.display.message("Ok!");
					player.healAll();
				} else {
					player.game.display.message("Ok.");
				}
				player.endTurn();
				player.game.input.mode = "MOVEMENT";
			}
			player.game.input.mode = "PROMPT";
		}
	},
	PROFFESSOR: {
		name: "Proffessor",
		tile: new ut.Tile('@', 0, 255, 255),
		hp: 20,
		speed: 50,
		trainer: true,
		interact: function(player){
			if (player.pickedStarter){
				player.game.display.message("Good luck in your quest!");
			} else {
				player.game.display.message("Pick one of the starter monsters.");
			}
		}
	},
	GYM_LEADER: {
		name: "Gym Leader",
		tile: new ut.Tile('@', 255, 255, 0),
		hp: 20,
		speed: 50,
		trainer: true
	}
}
},{}],14:[function(require,module,exports){
var Tiles = require('./Tiles.enum');
var Being = require('./Being.class');

module.exports = {
	badgesCount: 0,
	MAX_SIGHT_RANGE: 10,
	x: 20,
	y: 20,
	tile: new ut.Tile('@', 255, 255, 255),
	visible: [],
	memory: {},
	items: [],
	monsterSlots: [],
	observedMonsters: [],
	addMonster: function(being, slotNumber){
		if (slotNumber && this.monsterSlots[slotNumber]){
			this.game.display.message("Cannot put monster in that slot");
			return;
		}
		if (slotNumber === undefined){
			slotNumber = this.getAvailableSlotNumber();
		}
		if (slotNumber === undefined){
			this.game.display.message("No slots available.");
			return;
		}
		being.isFriendly = true;
		this.monsterSlots[slotNumber] = {
			being: being,
			onPocket: true
		}
		being.isTame = true;
		being.slotNumber = slotNumber;
	},
	getAvailableSlotNumber: function(){
		for (var i = 0; i < 6; i++){
			if (!this.game.player.monsterSlots[i]){
				return i;
			}
		}
		return false;
	},
	init: function(game){
		this.game = game;
		for (var j = -this.MAX_SIGHT_RANGE; j <= this.MAX_SIGHT_RANGE; j++){
			this.visible[j] = [];
		}
	},
	tryMove: function(dir){
		if (!this.game.world.level.canWalkTo(this.x+dir.x, this.y+dir.y)){
			// Check for NPCs
			var npc = this.game.world.level.getBeing(this.x+dir.x, this.y+dir.y);
			if (npc && npc.race.interact){
				this.game.input.inputEnabled = true;
				npc.race.interact(this);
				return;
			}
			// Check for counters
			var tile = this.game.world.level.getCell(this.x+dir.x, this.y+dir.y);
			if (tile && tile.isCounter){
				// Check for NPC further
				var npc = this.game.world.level.getBeing(this.x+dir.x*2, this.y+dir.y*2);
				if (npc && npc.race.interact){
					this.game.input.inputEnabled = true;
					npc.race.interact(this);
					return;
				}
			}
			this.game.input.inputEnabled = true;
			return;
		}
		this.x += dir.x;
		this.y += dir.y;
		this.land();
	},
	die: function(){
		this.game.display.message("You die!");
		this.game.input.mode = 'NONE';
	},
	land: function(){
		if (this.game.world.level.map[this.x][this.y] === Tiles.GYM_ENTRANCE && !this.game.world.level.gymComplete){
			this.game.display.message("Are you ready to challenge "+this.game.world.level.gymInfo.name+"? [Y/N]");
			this.game.input.mode = "PROMPT";
			this.game.input.promptFunction = this.confirmChallengeGym.bind(this);
			this.endTurn();
		} else if (!this.gymTown && this.game.world.level.exits[this.x] && this.game.world.level.exits[this.x][this.y]){
			this.game.world.loadLevel(this.game.world.level.exits[this.x][this.y]);
			this.endTurn();
		} else {
			this.endTurn();
		}
	},
	confirmChallengeGym: function(confirm){
		if (confirm){
			this.gymTown = this.game.world.level; 
			this.game.world.loadLevel(this.game.world.level.gymInfo.toId);
			this.endTurn();
		} else {
			this.game.display.message("Some other time.");
		}
		this.game.input.mode = "MOVEMENT";
	},
	endTurn: function(){
		this.game.display.textBox.checkFaint();
		this.updateFOV();
		this.game.display.refresh();
		for (var i = 0; i < this.monsterSlots.length; i++){
			var slot = this.monsterSlots[i];
			if (slot && slot.onPocket){
				slot.being.endTurn();
			}
		}
		this.game.world.level.beingsTurn();
	},
	remember: function(x, y){
		var memory = this.memory[this.game.world.level.id];
		if (!memory){
			memory = [];
			this.memory[this.game.world.level.id] = memory;
		}
		if (!memory[x]){
			memory[x] = [];
		}
		memory[x][y] = true;
	},
	remembers: function(x, y){
		var memory = this.memory[this.game.world.level.id];
		if (!memory){
			return false;
		}
		if (!memory[x]){
			return false;
		}
		return memory[x][y] === true;
	},
	canSee: function(dx, dy){
		try {
			return this.visible[dx][dy] === true;
		} catch(err) {
			// Catch OOB
			return false; 
		}
	},
	getSightRange: function(){
		return 15;
	},
	updateFOV: function(){
		/*
		 * This function uses simple raycasting, 
		 * use something better for longer ranges
		 * or increased performance
		 */
		for (var j = -this.MAX_SIGHT_RANGE; j <= this.MAX_SIGHT_RANGE; j++)
			for (var i = -this.MAX_SIGHT_RANGE; i <= this.MAX_SIGHT_RANGE; i++)
				this.visible[i][j] = false;
		this.observedMonsters.length = 0;
		var step = Math.PI * 2.0 / 1080;
		for (var a = 0; a < Math.PI * 2; a += step)
			this.shootRay(a);
	},
	shootRay: function (a) {
		var rayStrength = 2;
		var step = 0.3333;
		var maxdist = this.getSightRange() < this.MAX_SIGHT_RANGE ? this.getSightRange() : this.MAX_SIGHT_RANGE;
		maxdist /= step;
		rayStrength /= step;
		var dx = Math.cos(a) * step;
		var dy = -Math.sin(a) * step;
		var xx = this.x, yy = this.y;
		for (var i = 0; i < maxdist; ++i) {
			var testx = Math.round(xx);
			var testy = Math.round(yy);
			this.visible[testx-this.x][testy-this.y] = true;
			this.remember(testx, testy);
			var monster = this.game.world.level.getBeing(testx, testy);
			if (monster && !monster.isFriendly){
				if (this.observedMonsters.indexOf(monster) === -1){
					this.observedMonsters.push(monster);
				}
			}
			try { 
				if (this.game.world.level.map[testx][testy].opaque){
					return;
				} else if (this.game.world.level.map[testx][testy].semiopaque){
					rayStrength --;
					if (rayStrength < 0){
						return;
					}
				}
			} catch(err) {
				// Catch OOB
				return; 
			}
			xx += dx; yy += dy;
		}
	},
	canPick: function(){
		return this.items.length < 24;
	},
	addItem: function(item){
		if (this.items.length === 24){
			return;
		}
		this.items.push(item);
		this.items.sort(this.itemSorter);
	},
	removeItem: function(item){
		this.items.splice(this.items.indexOf(item), 1);
		this.items.sort(this.itemSorter);	
	},
	itemSorter: function(a, b){
		if (a.def.type.name === b.def.type.name){
			return a.def.name > b.def.name ? 1 : -1;
		} else {
			return a.def.type.name > b.def.type.name ? 1 : -1;
		}
	},
	tryPickup: function(){
		var item = this.game.world.level.getItem(this.x, this.y);
		if (item){
			if (item.forSale){
				this.game.display.message("This "+item.def.name+" costs "+item.def.cost+". Do you want to buy it? [Y/N]");
				this.game.input.mode = "PROMPT";
				this.buyingItem = item;
				this.game.input.promptFunction = this.confirmBuy.bind(this);
			} else if (item.def.type.pickupFunction){
				item.def.type.pickupFunction(this.game, item);
			} else if (!this.canPick()){
				this.game.display.message("You can't pickup the "+item.def.name);
			} else {
				this.game.display.message("You pickup the "+item.def.name);
				this.game.world.level.removeItem(this.x, this.y);
				this.addItem(item);
			}
		}
	},
	confirmBuy: function(confirm){
		if (confirm){
			if (!this.canPick())
				this.game.display.message("You can't pickup the "+this.buyingItem.def.name);
			else if (this.money >= this.buyingItem.def.cost){
				this.money -= this.buyingItem.def.cost;
				this.game.display.message("Thank you!");
				this.game.world.level.removeItem(this.x, this.y);
				this.addItem(this.buyingItem);
			} else {
				this.game.display.message("Sorry, you can't afford it.");
			}
		} else {
			this.game.display.message("Alright");
		}
		this.game.input.mode = "MOVEMENT";
		this.game.player.endTurn();
	},
	tryDrop: function(item){
		var underItem = this.game.world.level.items[this.x] && this.game.world.level.items[this.x][this.y];
		if (underItem){
			this.game.display.message("Cannot drop the "+item.def.name+" here.");
		} else {
			this.game.world.level.addItem(item, this.x, this.y);
			this.removeItem(item);
			this.game.display.message("You drop the "+item.def.name+".");
		}
	},
	tryUse: function(item, dx, dy){
		item.def.type.useFunction(this.game, item, dx, dy);
	},
	releaseMonster: function(dir){
		if (this.gymTown){
			if (this.releasedMonster){
				this.game.display.message("You are on a one on one duel.");
				return;
			} else {
				this.releasedMonster = true;
			}
		}
		var slot = this.monsterSlots[this.game.input.selectedMonsterSlot];
		if (this.game.world.level.canWalkTo(this.x + dir.x, this.y + dir.y) &&
			this.game.world.level.canWalkTo(this.x + dir.x * 2, this.y + dir.y * 2)){
			slot.onPocket = false;
			slot.being.level = this.game.world.level;
			this.game.world.level.addBeing(slot.being, this.x + dir.x * 2, this.y + dir.y * 2);
			this.game.display.message("Go "+slot.being.race.name+"!");
			this.endTurn();
		} else {
			this.game.display.message("No space!");
		}
	},
	pullBack: function(){
		if (this.gymTown){
			this.releasedMonster = false;
		}
		var slot = this.monsterSlots[this.game.input.selectedMonsterSlot];
		slot.onPocket = true;
		this.game.world.level.removeBeing(slot.being);
		this.game.display.message(slot.being.race.name+"... come back.");
		this.endTurn();
	},
	pullBackAll: function(){
		for (var i = 0; i < this.monsterSlots.length; i++){
			var slot = this.monsterSlots[i];
			if (slot && !slot.onPocket){
				slot.onPocket = true;
				this.game.world.level.removeBeing(slot.being);
			}
		}
	},
	healAll: function(){
		for (var i = 0; i < this.monsterSlots.length; i++){
			var slot = this.monsterSlots[i];
			if (slot && slot.being){
				slot.being.heal();
			}
		}
		this.hp.replenish();
	},
	getMonster: function(race){
		if (this.getAvailableSlotNumber() === false){
			this.game.display.message("You don't have any monster slots available");
			return;
		}
		if (this.pickedStarter){
			this.game.display.message("You already picked your starter monsters.");
			return;	
		}

		this.game.display.message("Do you want to pick "+race.name+"? [Y/N]");
		this.game.input.mode = "PROMPT";
		this.game.input.promptFunction = function(confirm){
			if (confirm){
				var monster = new Being(this.game, false, race, 5);
				this.addMonster(monster);
				this.game.display.message(race.name+" joins!");
				this.game.world.level.removeItem(this.x, this.y);
				this.game.input.selectAvailableMonsterSlot();
				this.pickedStarter = true;
			} else {
				this.game.display.message(" N.");
			}
			this.endTurn();
			this.game.input.mode = "MOVEMENT";
		}.bind(this);
	},
	giveUpGymBattle: function(){
		if (!this.gymTown){
			return;
		}
		this.game.display.message("Do you want to give up this gym battle? [Y/N] ");
		this.game.input.mode = "PROMPT";
		this.game.input.promptFunction = function(confirm){
			if (confirm){
				this.game.display.message("Better luck next time!");
				this.gymTown = false;
			} else {
				this.game.display.message("Keep fighting!");
			}
			this.endTurn();
			this.game.input.mode = "MOVEMENT";
		}.bind(this);
	}
}
},{"./Being.class":1,"./Tiles.enum":18}],15:[function(require,module,exports){
module.exports = {
	n: function(a, b){
		return Math.floor(Math.random() * (b - a + 1))+a;
	},
	chance: function(c){
		return this.n(0,100) <= c;
	},
	from: function(array, remove){
		var index = this.n(0, array.length-1);
		var value = array[index];
		if (remove){
			array.splice(index, 1);
		}
		return value;
	},
	fromObject: function(object, remove){
		var keys = Object.keys(object)
		var key = keys[this.n(0, keys.length-1)];
		var value = object[key];
		if (remove){
			delete object[key];
		}
		return value;
	},
	fromWeighted: function(array, totalWeight){
		var totalWeight = 0;
		for (var i = 0; i < array.length; i++){
			totalWeight += array[i].weight;
		}
		var pivot = this.n(0, totalWeight);
		var acum = 0;
		for (var i = 0; i < array.length; i++){
			acum += array[i].weight;
			if (pivot <= acum){
				return array[i];
			}
		}
		return false; // Should never happen
	}
}
},{}],16:[function(require,module,exports){
var Display = require('./Display');
var Races = require('./monster/Races.enum');
var Being = require('./Being.class');
var Item = require('./Item.class');
var Items = require('./Items.enum');
var Stat = require('./Stat.class');

module.exports = {
	start: function(game){
		game.player.hp = new Stat(20);
		game.player.money = 1000;
		/*var charmander = new Being(game, false, Races.CHARMANDER, 16);
		game.player.addMonster(charmander);
		charmander = new Being(game, false, Races.RATTATA, 2);
		game.player.addMonster(charmander);
		charmander = new Being(game, false, Races.RATTATA, 3);
		game.player.addMonster(charmander);
		charmander = new Being(game, false, Races.PIDGEY, 4);
		game.player.addMonster(charmander);
		charmander = new Being(game, false, Races.CHARMANDER, 2);
		game.player.addMonster(charmander);*/
		
		game.player.addItem(new Item(Items.CATCHBALL));
		game.player.addItem(new Item(Items.CATCHBALL));
		game.player.addItem(new Item(Items.GREATBALL));
		game.player.addItem(new Item(Items.GREATBALL));
		game.player.addItem(new Item(Items.POTION));
		game.player.addItem(new Item(Items.SUPER_POTION));
		game.player.addItem(new Item(Items.POTION));
		game.player.addItem(new Item(Items.SUPER_POTION));
	}
}
},{"./Being.class":1,"./Display":2,"./Item.class":6,"./Items.enum":8,"./Stat.class":17,"./monster/Races.enum":29}],17:[function(require,module,exports){
function Stat(max){
	this.max = max;
	this.current = max;
}

module.exports = Stat;

Stat.prototype.replenish = function(){
	this.current = this.max;
};

Stat.prototype.regenerate = function(){
	if (this.current < this.max)
		this.current++;
};

Stat.prototype.increase = function(value){
	if (this.current < this.max)
		this.current += value;
	if (this.current > this.max)
		this.current = this.max;
};

Stat.prototype.increaseOpenly = function(value){
	this.current += value;
};

Stat.prototype.recoverProportion = function(proportion){
	var missing = this.max - this.current;
	this.increase(Math.round(missing*proportion));
};

Stat.prototype.recoverProportionOfTotal = function(proportion){
	this.increase(Math.round(this.max*proportion));
};

Stat.prototype.reduce = function(value){
	if (this.current > 0)
		this.current-= value;
	if (this.current < 0)
		this.current = 0;
};

Stat.prototype.extend = function(value){
	this.max += value;
	this.current += value;
};

Stat.prototype.multiply = function(value){
	this.max *= value;
	this.current *= value;
};

Stat.prototype.contract = function(value){
	this.max -= value;
	if (this.max < 0)
		this.max = 0;
	if (this.current > this.max)
		this.current = this.max;
};

Stat.prototype.getText = function(){
	return this.current + "/" + this.max;
};

Stat.prototype.getProportion = function(){
	return this.current / this.max;
};

Stat.prototype.notFull = function(value){
	return this.current !== this.max;
};

Stat.prototype.empty = function(){
	return this.current <= 0;
};

Stat.prototype.getRemaining = function(){
	return this.max - this.current;
};
},{}],18:[function(require,module,exports){
module.exports = {
	FENCE: {
		tile: new ut.Tile('+', 255, 255, 85),
		darkTile: new ut.Tile('+', 128, 128, 128),
		solid: true,
		opaque: false
	},
	GRASS: {
		tile: new ut.Tile(',', 0, 128, 0),
		darkTile: new ut.Tile(',', 128, 128, 128),
		solid: false,
		opaque: false
	},
	STAIRS_DOWN: {
		tile: new ut.Tile('>', 255, 255, 255),
		darkTile: new ut.Tile('>', 128, 128, 128),
		solid: false,
		opaque: false
	},
	STAIRS_UP: {
		tile: new ut.Tile('<', 255, 255, 255),
		darkTile: new ut.Tile('<', 128, 128, 128),
		solid: false,
		opaque: false
	},
	BUSH: {
		tile: new ut.Tile('&', 0, 128, 0),
		darkTile: new ut.Tile('&', 128, 128, 128),
		solid: false,
		opaque: true
	},
	WATER: {
		tile: new ut.Tile('~', 0, 0, 255),
		darkTile: new ut.Tile('~', 128, 128, 128),
		solid: true,
		opaque: false
	},
	WALL: {
		tile: new ut.Tile('#', 128, 128, 128),
		darkTile: new ut.Tile('#', 128, 128, 128),
		solid: true,
		opaque: true
	},
	FLOOR: {
		tile: new ut.Tile('.', 0, 0, 255),
		darkTile: new ut.Tile('.', 128, 128, 128),
		solid: false,
		opaque: false
	},
	ROAD: {
		tile: new ut.Tile('.', 128, 128, 128),
		darkTile: new ut.Tile('.', 128, 128, 128),
		solid: false,
		opaque: false
	},
	TALL_GRASS: {
		tile: new ut.Tile('|', 0, 255, 128),
		darkTile: new ut.Tile('|', 128, 128, 128),
		semiopaque: true
	},
	H_COUNTER: {
		tile: new ut.Tile('=', 255, 255, 255),
		darkTile: new ut.Tile('=', 128, 128, 128),
		isCounter: true,
		solid: true
	},
	V_COUNTER: {
		tile: new ut.Tile('|', 255, 255, 255),
		darkTile: new ut.Tile('|', 128, 128, 128),
		isCounter: true,
		solid: true
	},
	GYM_ENTRANCE: {
		tile: new ut.Tile('/', 255, 255, 255),
		darkTile: new ut.Tile('/', 128, 128, 128)
	}
}
},{}],19:[function(require,module,exports){
var Level = require('./Level.class');
var MetadataGenerator = require('./MetadataGenerator');
var LevelGenerator = require('./LevelGenerator');

var Random = require('./Random');

module.exports = {
	levels: {},
	metadata: {},
	init: function(game){
		this.game = game;
		this.player = game.player;
		this.metadata = MetadataGenerator.generateMetadata();
		this.loadLevel(this.metadata._startingLevelId);
	},
	loadLevel: function(levelId){
		this.player.pullBackAll();
		var oldLevel = this.game.world.level;
		if (this.levels[levelId]){
			this.level = this.levels[levelId];
		} else {
			this.level = new Level(this.game, levelId);
			LevelGenerator.generateTestLevel(this.level, this.metadata[levelId]);
			this.levels[levelId] = this.level;
		}
		if (!this.metadata[levelId].startPosition){
			// Look for the exit from whence we came
			var exit = this.level.getExit(oldLevel.id);
			this.player.x = exit.x;
			this.player.y = exit.y;
		} else {
			this.metadata[levelId].startPosition = false;
		}
	}
}
},{"./Level.class":9,"./LevelGenerator":10,"./MetadataGenerator":12,"./Random":15}],20:[function(require,module,exports){
var Random = require('../Random');

module.exports = {
	act: function(being){
		this.being = being;
		if (being.monsters.length == 0){
			// Defeated!
			if (!being.gavePrize){
				being.givePrize();
			}
			// Stand by
			return;
		}
		if (!being.game.player.gymTown){
			// Player gave up
			if (being.monsterDeployed){
				being.pullBackMonster();
			}
			being.healAll();
			return;
		}
		if (being.monsterDeployed){
			if (this.pullBackMonster()){
				being.pullBackMonster();
			} else if (this.useItem()){
				being.useItem(this.selectItem());
			} else if (this.issuePositionalOrder()){
				being.issueOrder(this.selectPositionalOrder());
			} else if (this.issueSkillOrder()){
				being.issueOrder(this.selectSkillOrder());
			} else {
				//Stand by
			}
		} else {
			if (this.releaseMonster()){
				being.releaseMonster(this.selectMonster());
			} else {
				// Stand by
			}
		}
	},
	pullBackMonster: function(){
		// Define if should call back the current monster
		var hasMoreMonster = this.being.monsters.length > 1;
		var tooInjured = this.being.monsterDeployed.hp.getProportion() <= 0.3 && Random.chance(60);
		var whatever = Random.chance(1);
		return hasMoreMonster && (tooInjured || whatever);
	},
	useItem: function(){
		// Define if should use an item
		return false;
	},
	selectItem: function(){
		// Select an item to use from inventory
		return false;
	},
	issuePositionalOrder: function(){
		// Define if should issue a positional order
		return false;
	},
	selectPositionalOrder: function(){
		// Select what positional order to give
		return false;
	},
	issueSkillOrder: function(){
		// Define if should issue a skill order
		return false;
	},
	selectSkillOrder: function(){
		// Select what skill order to give
		return false;
	},
	releaseMonster: function(){
		// Define is should release a monster
		return this.being.monsters.length > 0 && Random.chance(30);
	},
	selectMonster: function(){
		// Define what monster to release
		if (this.being.enemyMonster){
			// Evaluate all available monsters to see which one is the best
			var evals = this.being.monsters.map(function(monster){
				return this.evaluate(monster);
			}, this);
			evals.sort();
			return evals[evals.length - 1];
		} else {
			// Select a random monster from available
			return Random.from(this.being.monsters);
		}
	},
	evaluate: function(monster){
		if (this.being.monsterDeployed.hp.getProportion() <= 0.3)
			return 1;
		return 5;
	}
}
},{"../Random":15}],21:[function(require,module,exports){
var Random = require('../Random');
var Matrix = require('./Matrix.class');

module.exports = {
	runCA: function(map, rules, generations, wrap){
		var matrix = new Matrix(map)
		for (var i = 0; i < generations; i++)
			this.step(matrix, rules, wrap);
	},
	step: function(matrix, rules, wrap){
		for (var x = 0; x < matrix.getWidth(); x++){
			for (var y = 0; y < matrix.getHeight(); y++){
				for (var i = 0; i < rules.length; i++){
					rules[i].apply(x,y, matrix, wrap);
				}
			}
		}
		matrix.advance();
	}
}
},{"../Random":15,"./Matrix.class":22}],22:[function(require,module,exports){
function Matrix(map, w, h){
	if (map){
		this.values = map;
		this.futureValues = map;	
	} else {
		this.values = [];
		this.futureValues = [];
	}
}

Matrix.prototype = {
	setFuture: function(value, x, y){
		this.futureValues[x][y] = value;
	},
	setPresent: function (value, x, y){
		this.values[x][y] = value;
	},
	get: function(x, y){
		return this.values[x][y];
	},
	getWidth: function(){
		return this.values.length;
	},
	getHeight: function(){
		return this.values[0].length;
	},
	advance: function(){
		for (var x = 0; x < this.values.length; x++){
			for (var y = 0; y < this.values[0].length; y++){
				this.values[x][y] = this.futureValues[x][y];
			}
		}
	},
	getSurroundingCount: function(x, y, type){
		var upIndex = (y == 0 ? this.getHeight()-1 : y-1);
		var downIndex = (y == this.getHeight()-1  ? 0 : y+1);
		var rightIndex = (x == this.getWidth()-1  ? 0 : x+1);
		var leftIndex = (x == 0 ? this.getWidth()-1 : x-1);
		var count =
		 		(this.values[leftIndex][upIndex] == type ? 1 : 0) +
		 		(this.values[leftIndex][y] == type ? 1 : 0) +
		 		(this.values[leftIndex][downIndex] == type ? 1 : 0) +
		 		(this.values[rightIndex][upIndex] == type ? 1 : 0) +
		 		(this.values[rightIndex][y] == type ? 1 : 0) +
		 		(this.values[rightIndex][downIndex] == type ? 1 : 0) +
		 		(this.values[x][downIndex] == type ? 1 : 0) +
		 		(this.values[x][upIndex] == type ? 1 : 0) ;
		 return count;
	},
	getSurroundingCountNoWrap: function(x, y, type){
		var count =
		 		(y==0||x==0?0:(this.values[x-1][y-1] == type ? 1 : 0)) +
		 		(x==0?0:(this.values[x-1][y] == type ? 1 : 0)) +
		 		(x==0||y==this.getHeight()-1?0:(this.values[x-1][y+1] == type ? 1 : 0)) +
		 		(y==0||x==this.getWidth()-1?0:(this.values[x+1][y-1] == type ? 1 : 0)) +
		 		(x==this.getWidth()-1?0:(this.values[x+1][y] == type ? 1 : 0)) +
		 		(x==this.getWidth()-1||y==this.getHeight()-1?0:(this.values[x+1][y+1] == type ? 1 : 0)) +
		 		(y==this.getHeight()-1?0:(this.values[x][y+1] == type ? 1 : 0)) +
		 		(y==0?0:(this.values[x][y-1] == type ? 1 : 0)) ;
		 return count;
	},
	clean: function(){
		this.values = [];
		this.futureValues = [];
	},
	getArrays: function(){
		return this.values;
	},
	addHotSpot: function(value, x, y){
		if (!x) x = Random.n(5,this.getWidth()-5);
		if (!y) y = Random.n(5,this.getHeight()-5);
		this.values[x][y] = value;
		this.futureValues[x][y] = value;
	},
	addShoweredHotSpot: function(value, shower, showers, maxDist, x, y){
		if (!x) x = Random.n(5,this.getWidth()-5);
		if (!y) y = Random.n(5,this.getHeight()-5);
		var xs = showers;
		for (var i = 0; i < xs; i++){
			var xdif = maxDist - Random.n(0,maxDist*2);
			var ydif = maxDist - Random.n(0,maxDist*2);
			if (this.isValid(x+xdif, y+ydif))
				this.futureValues[x+xdif][y+ydif] = shower;
		}
		this.futureValues[x][y] = value;
	},
	isValid: function(x, y){
		return x>=0 && y >= 0 && x < this.getWidth() && y < this.getHeight();
	}
}

module.exports = Matrix;
},{}],23:[function(require,module,exports){
var Random = require('../Random');

/** 
 * Stores a rule of the form:
 *  if {baseCell} has {condType} {cellQuant} {cellParam} around, turn into {destinationCell}
 *
 * Example
 *  when 1 has morethan 4 2 around turn into 0
 */

function Rule(baseCell, condType, cellQuant, cellParam, destinationCell, chance){
	this.baseCell = baseCell;
	this.condType = condType;
	this.cellQuant = cellQuant;
	this.cellParam = cellParam;
	this.destinationCell = destinationCell;
	this.chance = chance ? chance : 100;
}

Rule.prototype = {
	apply: function (x, y, m, wrap){
		if (m.get(x,y) == this.baseCell){
			var surroundingCount = 0;
			if (wrap)
				surroundingCount = m.getSurroundingCount(x,y,this.cellParam);
			else
				surroundingCount = m.getSurroundingCountNoWrap(x,y,this.cellParam);

			switch (this.condType){
				case Rule.HAS:
					if (surroundingCount === this.cellQuant && Random.chance(this.chance)){
						m.setFuture(this.destinationCell, x, y);
					}
					break;
				case Rule.MORE_THAN:
					if (surroundingCount > this.cellQuant && Random.chance(this.chance)){
						m.setFuture(this.destinationCell, x, y);
					}
					break;
				case Rule.LESS_THAN:
					if (surroundingCount < this.cellQuant && Random.chance(this.chance)){
						m.setFuture(this.destinationCell, x, y);
					}
					break;
			}

		}
	}
}

Rule.HAS = 0;
Rule.MORE_THAN = 1;
Rule.LESS_THAN = 2,

module.exports = Rule;
},{"../Random":15}],24:[function(require,module,exports){
var Status = require('./Status.enum');
var Random = require('../Random');
var Effectiveness = require('./Effectiveness');

module.exports = {
	hits: function(monster, enemy, skill){
		if (hitChance === 0){
			return true;
		}
		if (skill.params.alwaysHit)
			return true;
		var hitChance = skill.accuracy * (monster.getEffectiveAccuracy() / enemy.getEffectiveEvasion());
		return Random.chance(hitChance);
	},
	getCriticalHitChance: function(monster, skill){
		var t = monster.speed.current / 2; // This uses the base speed, not affected by modifiers
		if (skill.params.critBoost){
			t *= 8;
		}
		if (monster.hasStatus(Status.FOCUSED)){
			t *= 4;
		}
		return t / 256;
	},
	calculateDamage: function(monster, enemy, skill){
		if (skill.params.fixedDamage){
			if (skill.params.fixedDamage === "Level"){
				return monster.xpLevel;
			} else {
				return skill.params.fixedDamage;
			}
		} else if (skill.params.fixedDamagePercentage){
			var damage = Math.floor(enemy.hp.current * (skill.params.fixedDamagePercentage/100));
			if (damage === 0)
				damage = 1;
			return damage;
		} else if (skill.params.specialDamage){
			if (skill.params.specialDamage === "psywave"){
				return Random.n(1, Math.floor(monster.xpLevel * 1.5));
			}
		}
		var criticalHitChance = this.getCriticalHitChance(monster, skill) * 100;
		var criticalHit = Random.chance(criticalHitChance);
		if (criticalHit){
			monster.game.display.message("A Critical Hit!");
		}
		var level = criticalHit ? monster.xpLevel * 2 : monster.xpLevel;
		var a = skill.damageType = 'PHYS' ? monster.getEffectiveAttack() : monster.getEffectiveSpecialAttack();
		var d = skill.damageType = 'PHYS' ? enemy.getEffectiveDefense() : enemy.getEffectiveSpecialDefense();
		var power = skill.power;
		var targets = 1; // Changes if multitargets
		var weather = 1; // Changes based on environment
		var random = Random.n(85,100) / 100;
		var stab = skill.type === monster.type ? 1.5 : 1;
		var type = Effectiveness(skill, monster, enemy);
		switch(type){
			case 2:
				monster.game.display.message("It's super effective!");
				break;
			case 0.5:
				monster.game.display.message("It's not very effective...");
				break;
		}
		var modifier = targets * weather * random * stab * type;
		var damage = modifier * (
		(
			(
				(
					(
						(
							2 * level
						) / 5
					) + 2
				) * power * (a/d)
			)/50
		)+2);
		damage = Math.floor(damage);
		if (skill.params.undergroundBonus && enemy.isUnderground()){
			damage *= 2;
		}
		return damage;
	},
	effect: function(monster, skill){
		var enemy = monster.getNearestEnemy();
		monster.game.display.message(monster.race.name+" uses "+skill.name+" on the "+enemy.race.name+".");

		if (skill.params.suicide){
			monster.game.display.message("The "+monster.race.name+" sacrifices himself!");
		}
		
		if (!this.hits(monster, enemy, skill)){
			monster.game.display.message("The "+monster.race.name+" misses.");
			// Missed??
			if (skill.params.damageOnMiss){
				monster.game.display.message("The "+monster.race.name+" takes "+skill.params.damageOnMiss+" miss damage.");
				monster.takeDamage(skill.params.damageOnMiss);
			}
			return;
		}

		if (enemy.intent === 'STILL'){
			// No longer!!!
			monster.game.display.message("The "+enemy.race.name+" becomes hostile!");
			enemy.intent = 'CHASE';
		}

		var damage = this.calculateDamage(monster, enemy, skill);

		
		if (damage > 0){
			monster.game.display.message("The "+enemy.race.name+" is hit for "+damage+" damage.");
			enemy.recordHitBy(monster);
			enemy.takeDamage(damage);
			if (skill.params.absorbHPPercentage){
				var absorbedHP = Math.floor(damage * (skill.params.absorbHPPercentage / 100));
				if (absorbedHP === 0){
					absorbedHP = 1;
				}
				monster.game.display.message("The "+monster.race.name+" absorbs "+absorbedHP+" damage.");
				monster.recoverHP(absorbedHP);
			}
			if (skill.params.recoil){
				var recoilDamage = Math.floor(damage * (skill.params.recoil / 100));
				monster.game.display.message("The "+monster.race.name+" takes "+recoilDamage+" recoil damage.");
				monster.takeDamage(recoilDamage);
			}

			if (skill.params.burnChance && Random.chance(skill.params.burnChance)){
				monster.game.display.message("The "+enemy.race.name+" is burned!");
				enemy.inflictStatus(Status.BURN, 5);
			}

			if (skill.params.confuseChance && Random.chance(skill.params.confuseChance)){
				monster.game.display.message("The "+enemy.race.name+" is confused!");
				enemy.inflictStatus(Status.CONFUSION, 5);
			}

			if (skill.params.flinchChance && Random.chance(skill.params.flinchChance)){
				monster.game.display.message("The "+enemy.race.name+" flinches!");
				enemy.inflictStatus(Status.FLINCH, 1);
			}

			if (skill.params.freezeChance && Random.chance(skill.params.freezeChance)){
				monster.game.display.message("The "+enemy.race.name+" is frozen!");
				enemy.inflictStatus(Status.FREEZE, 20);
			}

			if (skill.params.paralyzeChance && Random.chance(skill.params.paralyzeChance)){
				monster.game.display.message("The "+enemy.race.name+" is paralyzed!");
				enemy.inflictStatus(Status.PARALYZE, 5);
			}

			if (skill.params.poisonChance && Random.chance(skill.params.poisonChance)){
				monster.game.display.message("The "+enemy.race.name+" is poisoned!");
				enemy.inflictStatus(Status.POISON, 10);
			}

			if (skill.params.lowerChance && Random.chance(skill.params.lowerChance)){
				monster.game.display.message("The "+enemy.race.name+"'s "+skill.params.lowerStat.name+" is lowered!");
				enemy.changeStat(skill.params.lowerStat.id, 5, -1);
			}

			if (skill.params.suicide){
				monster.die();
			}

			// afterHits - Status to set after ALL hits (when multiHit)
			// assault - not here but previous, make the monster get next to enemy
			// buildUpTurns - not here? turns required to execute the move
			// rageTurns - Add a counter which would repeat the same skill until over.
			  // raiseAttackWhileRaging - not here, if current skill has this param and monster is raging, raise attack temporarily.
			// dropCoins - Drop money when hits
			// hideTurns - not here? hide for x turns before executing
			// multihit - not here? execute attack multiple times
			
			// recoverTurns - not here? Counter during which cannot do anything
			// requireStatus - Validation, target should have this status for the attack to be done
			// splashRange - not here, affect multiple targets
			// trap - target can't move (nor attack? for 4-5 turns), damage is caused every turn
		} else {
			monster.game.display.message("The "+enemy.race.name+" is not affected.");
		}
	}
}
},{"../Random":15,"./Effectiveness":25,"./Status.enum":32}],25:[function(require,module,exports){
module.exports = function(skill, monster, target){
	if (modifiers[skill.type.id]){
		var modifier = 1;
		if (modifiers[skill.type.id][target.race.type.id] !== undefined){
			if (modifiers[skill.type.id][target.race.type.id] === 0){
				return 0;
			}
			modifier *= modifiers[skill.type.id][target.race.type.id];
		}
		if (target.race.typeb && modifiers[skill.type.id][target.race.typeb.id] !== undefined){
			if (modifiers[skill.type.id][target.race.typeb.id] === 0){
				return 0;
			}
			modifier *= modifiers[skill.type.id][target.race.typeb.id];
		}
		return modifier;
	} else {
		return 1;
	}
}

var modifiers = {
	NORMAL: {
		ROCK: 0.5,
		GHOST: 0
	},
	FIGHTING: {
		NORMAL: 2,
		FLYING: 0.5,
		POISON: 0.5,
		ROCK: 2,
		BUG: 0.5,
		GHOST: 0,
		PSYCHIC: 0.5,
		ICE: 2
	},
	FLYING: {
		FIGHTING: 2,
		ROCK: 0.5,
		BUG: 2,
		GRASS: 2,
		ELECTRIC: 0.5
	},
	POISON: {
		POISON: 0.5,
		GROUND: 0.5,
		ROCK: 0.5,
		BUG: 2,
		GHOST: 0.5,
		GRASS: 2
	},
	GROUND: {
		FLYING: 0,
		POISON: 2,
		ROCK: 2,
		BUG: 0.5,
		FIRE: 2,
		GRASS: 0.5,
		ELECTRIC: 2
	},
	ROCK: {
		FIGHTING: 0.5,
		FLYING: 2,
		GROUND: 0.5,
		BUG: 2,
		FIRE: 2,
		ICE: 2
	},
	BUG: {
		FIGHTING: 0.5,
		FLYING: 0.5,
		POISON: 2,
		GHOST: 0.5,
		FIRE: 0.5,
		GRASS: 2,
		PSYCHIC: 2
	},
	GHOST: {
		NORMAL: 0,
		GHOST: 2,
		PSYCHIC: 0
	},
	FIRE: {
		ROCK: 0.5,
		BUG: 2,
		FIRE: 0.5, 
		WATER: 0.5,
		GRASS: 2,
		ICE: 2,
		DRAGON: 0.5
	},
	WATER: {
		GROUND: 2,
		ROCK: 2,
		FIRE: 2,
		WATER: 0.5,
		GRASS: 0.5,
		DRAGON: 0.5
	},
	GRASS: {
		FLYING: 0.5,
		POISON: 0.5,
		GROUND: 2,
		ROCK: 2,
		BUG: 0.5,
		FIRE: 0.5,
		WATER: 2,
		GRASS: 0.5,
		DRAGON: 0.5
	},
	ELECTRIC: {
		FLYING: 2,
		GROUND: 0,
		WATER: 2,
		GRASS: 0.5,
		ELECTRIC: 0.5,
		DRAGON: 0.5
	},
	PSYCHIC: {
		FIGHTING: 2,
		POISON: 2,
		PSYCHIC: 0.5,
	},
	ICE: {
		FLYING: 2,
		GROUND: 2,
		WATER: 0.5,
		GRASS: 2,
		ICE: 0.5,
		DRAGON: 2
	},
	DRAGON: {
		DRAGON: 2
	}
}
},{}],26:[function(require,module,exports){
var Random = require('../Random');
var DamageEffect = require('./DamageEffect');
var ModifyStatEffect = require('./ModifyStatEffect');
var Status = require('./Status.enum');

module.exports = {
	DAMAGE: function(monster, skill){
		return DamageEffect.effect(monster, skill);
	},
	LOWER_STAT: function(monster, skill){
		ModifyStatEffect.effect(monster, skill, -1);
	},
	RAISE_STAT: function(monster, skill){
		ModifyStatEffect.effect(monster, skill, 1);
	},
	NOTHING: function(monster, skill){
		monster.game.display.message(monster.race.name+" uses "+skill.name);
		monster.game.display.message("Nothing happens");
	},
	SET_STATUS: function(monster, skill){
		monster.game.display.message(monster.race.name+" uses "+skill.name);
		var status = Status[skill.params.status];
		monster.inflictStatus(status, 5);
		monster.game.display.message(monster.race.name+" "+status.onSetMessage);

	},
	skipTarget: function(skill){
		return skill.effect === this.RAISE_STAT || skill.effect === this.NOTHING || skill.effect === this.SET_STATUS;
	}
}
},{"../Random":15,"./DamageEffect":24,"./ModifyStatEffect":27,"./Status.enum":32}],27:[function(require,module,exports){
var Stats = require('./Stats.enum');

var MODIFIER_MESSAGES = {
	"-2": "greatly fell!",
	"-1": "fell!",	
	"1": "rose!",
	"2": "greatly rose!",
};

module.exports = {
	effect: function(monster, skill, sign){
		var level = skill.params.level ? skill.params.level : 1;
		if (sign > 0){
			monster.game.display.message(monster.race.name+" uses "+skill.name);
			target = monster;
		} else {
			var enemy = monster.getNearestEnemy();
			monster.game.display.message(monster.race.name+" uses "+skill.name+" on the "+enemy.race.name+".");
			target = enemy;
		}
		monster.game.display.message("The "+target.race.name+" "+Stats[skill.params.stat].name+" "+MODIFIER_MESSAGES[(level*sign)]);
		target.changeStat(skill.params.stat, 5, level * sign);
	}
}
},{"./Stats.enum":31}],28:[function(require,module,exports){
function Race(name, chara, r, g, b, aggressive, type, typeb, hp, attack, defense, spAttack, spDefense, speed, xp){
	this.name = name;
	this.tile = new ut.Tile(chara, r, g, b);
	this.aggressive = aggressive;
	this.type = type;
	this.typeb = typeb;
	this.hp = hp;
	this.attack = attack;
	this.defense = defense;
	this.spAttack = spAttack;
	this.spDefense = spDefense;
	this.speed = speed;
	this.xp = xp;

	this.skills = [];
}

Race.prototype = {
	setMainEvolution: function(level, race){
		this.evolution = {minLevel: level, race: race};
		race.setPreevolution(level, this);
	},
	setPreevolution: function(level, race){
		// Add the skills from the preevolution
		var originalSkills = this.skills;
		this.skills = this.skills.concat(race.skills.filter((skill) => {
			if (originalSkills.find((originalSkill) => { return originalSkill.skill === skill.skill }))
				return false;
			return skill.level <= level;
		}));
	},
	setStoneEvolution: function(itemId, fromRace){
		this.parentRace = fromRace;
	}
}

module.exports = Race;
},{}],29:[function(require,module,exports){
var Skills = require('./Skills.enum');
var Types = require('./Types.enum');
var Race = require('./Race.class');

var Races = {
BULBASAUR: new Race('Saurbulba', 'b', 85, 255, 85, true, Types.GRASS, Types.POISON, 45, 49, 49, 65, 65, 45, 64),
IVYSAUR: new Race('Saurivy', 'i', 85, 255, 85, true, Types.GRASS, Types.POISON, 60, 62, 63, 80, 80, 60, 141),
VENUSAUR: new Race('Saurvenu', 'V', 85, 255, 85, true, Types.GRASS, Types.POISON, 80, 82, 83, 100, 100, 80, 208),
CHARMANDER: new Race('Manderchar', 'c', 255, 85, 85, true, Types.FIRE, null, 39, 52, 43, 60, 50, 65, 65),
CHARMELEON: new Race('Meleonchar', 'c', 255, 85, 85, true, Types.FIRE, null, 58, 64, 58, 80, 65, 80, 142),
CHARIZARD: new Race('Zardchari', 'C', 255, 85, 85, true, Types.FIRE, Types.FLYING, 78, 84, 78, 109, 85, 100, 209),
SQUIRTLE: new Race('Tlesquir', 's', 85, 85, 255, true, Types.WATER, null, 44, 48, 65, 50, 64, 43, 66),
WARTORTLE: new Race('Tlewartor', 'w', 85, 85, 255, true, Types.WATER, null, 59, 63, 80, 65, 80, 58, 143),
BLASTOISE: new Race('Toiseblas', 'B', 85, 85, 255, true, Types.WATER, null, 79, 83, 100, 85, 105, 78, 210),
CATERPIE: new Race('Piecater', 'c', 85, 255, 85, false, Types.BUG, null, 45, 30, 35, 20, 20, 45, 53),
METAPOD: new Race('Podmeta', 'm', 85, 255, 85, false, Types.BUG, null, 50, 20, 55, 25, 25, 30, 72),
BUTERFREE: new Race('Freebutter', 'b', 255, 255, 255, false, Types.BUG, Types.FLYING, 60, 45, 50, 80, 80, 70, 160),
WEEDLE: new Race('Dlewee', 'w', 170, 85, 0, false, Types.BUG, Types.POISON, 40, 35, 30, 20, 20, 50, 52),
KAKUNA: new Race('Kunaka', 'k', 255, 255, 85, false, Types.BUG, Types.POISON, 45, 25, 50, 25, 25, 35, 71),
BEEDRILL: new Race('Drillbee', 'b', 255, 255, 85, true, Types.BUG, Types.POISON, 65, 80, 40, 45, 80, 75, 159),
PIDGEY: new Race('Geypi', 'p', 170, 85, 0, false, Types.NORMAL, Types.FLYING, 40, 45, 40, 35, 35, 56, 55),
PIDGEOTTO: new Race('Geottopi', 'p', 170, 85, 0, true, Types.NORMAL, Types.FLYING, 63, 60, 55, 50, 50, 71, 113),
PIDGEOT: new Race('Geotpi', 'P', 170, 85, 0, true, Types.NORMAL, Types.FLYING, 83, 80, 75, 70, 70, 91, 172),
RATTATA: new Race('Tatarat', 'r', 170, 0, 170, true, Types.NORMAL, null, 30, 56, 35, 25, 35, 72, 57),
RATICATE: new Race('Caterati', 'R', 170, 85, 0, true, Types.NORMAL, null, 55, 81, 60, 50, 70, 97, 116),
SPEAROW: new Race('Rowspea', 's', 170, 85, 0, true, Types.NORMAL, Types.FLYING, 40, 60, 30, 31, 31, 70, 58),
FEAROW: new Race('Rowfea', 'F', 170, 85, 0, true, Types.NORMAL, Types.FLYING, 65, 90, 65, 61, 61, 100, 162),
EKANS: new Race('Ansek', 'e', 170, 0, 170, true, Types.POISON, null, 30, 60, 44, 40, 54, 55, 62),
ARBOK: new Race('Bokar', 'a', 170, 0, 170, true, Types.POISON, null, 60, 85, 69, 65, 79, 80, 147),
PIKACHU: new Race('Chupika', 'p', 255, 255, 85, true, Types.ELECTRIC, null, 35, 55, 30, 50, 40, 90, 82),
RAICHU: new Race('Churai', 'R', 255, 255, 85, true, Types.ELECTRIC, null, 60, 90, 55, 90, 80, 100, 122),
SANDSHREW: new Race('Shrewsand', 's', 255, 255, 85, true, Types.GROUND, null, 50, 75, 85, 20, 30, 40, 93),
SANDSLASH: new Race('Slashsand', 'S', 255, 255, 85, true, Types.GROUND, null, 75, 100, 110, 45, 55, 65, 163),
NIDORAN_F: new Race('Rannido♀', 'n', 85, 85, 255, false, Types.POISON, null, 55, 47, 52, 40, 40, 41, 59),
NIDORINA: new Race('Rinanido', 'n', 85, 85, 255, true, Types.POISON, null, 70, 62, 67, 55, 55, 56, 117),
NIDOQUEEN: new Race('Quennido', 'N', 85, 85, 255, true, Types.POISON, Types.GROUND, 90, 82, 87, 75, 85, 76, 194),
NIDORAN_M: new Race('Rannido♂', 'n', 170, 0, 170, false, Types.POISON, null, 46, 57, 40, 40, 40, 50, 60),
NIDORINO: new Race('Rinonido', 'n', 170, 0, 170, true, Types.POISON, null, 61, 72, 57, 55, 55, 65, 118),
NIDOKING: new Race('Kingnido', 'N', 170, 0, 170, true, Types.POISON, Types.GROUND, 81, 92, 77, 85, 75, 85, 195),
CLEFAIRY: new Race('Fairycle', 'c', 255, 85, 255, false, Types.NORMAL, null, 70, 45, 48, 60, 65, 35, 68),
CLEFABLE: new Race('Fablecle', 'C', 255, 85, 255, false, Types.NORMAL, null, 95, 70, 73, 85, 90, 60, 129),
VULPIX: new Race('Pixvul', 'v', 170, 85, 0, false, Types.FIRE, null, 38, 41, 40, 50, 65, 65, 63),
NINETALES: new Race('Talesnine', 'N', 255, 255, 85, true, Types.FIRE, null, 73, 76, 75, 81, 100, 100, 178),
JIGGLYPUFF: new Race('Puffjiggly', 'j', 255, 85, 255, false, Types.NORMAL, null, 115, 45, 20, 45, 25, 20, 76),
WIGGLYTUFF: new Race('Tuffwiggly', 'w', 255, 85, 255, true, Types.NORMAL, null, 140, 70, 45, 75, 50, 45, 109),
ZUBAT: new Race('Batzu', 'z', 170, 0, 170, false, Types.POISON, Types.FLYING, 40, 45, 35, 30, 40, 55, 54),
GOLBAT: new Race('Batgol', 'G', 170, 0, 170, true, Types.POISON, Types.FLYING, 75, 80, 70, 65, 75, 90, 171),
ODDISH: new Race('Shoddi', 'o', 85, 85, 255, false, Types.GRASS, Types.POISON, 45, 50, 55, 75, 65, 30, 78),
GLOOM: new Race('Mgloo', 'g', 85, 85, 255, false, Types.GRASS, Types.POISON, 60, 65, 70, 85, 75, 40, 132),
VILEPLUME: new Race('Plumevile', 'V', 255, 85, 85, false, Types.GRASS, Types.POISON, 75, 80, 85, 100, 90, 50, 184),
PARAS: new Race('Raspa', 'p', 255, 85, 85, false, Types.BUG, Types.GRASS, 35, 70, 55, 45, 55, 25, 70),
PARASECT: new Race('Rasectpa', 'P', 255, 85, 85, true, Types.BUG, Types.GRASS, 60, 95, 80, 60, 80, 30, 128),
VENONAT: new Race('Natveno', 'v', 170, 0, 170, true, Types.BUG, Types.POISON, 60, 55, 50, 40, 55, 45, 75),
VENOMOTH: new Race('Mothveno', 'v', 170, 0, 170, true, Types.BUG, Types.POISON, 70, 65, 60, 90, 75, 90, 138),
DIGLETT: new Race('Glettdi', 'd', 170, 85, 0, true, Types.GROUND, null, 10, 55, 25, 35, 45, 95, 81),
DUGTRIO: new Race('Triodug', 'd', 170, 85, 0, true, Types.GROUND, null, 35, 80, 50, 50, 70, 120, 153),
MEOWTH: new Race('Owthme', 'm', 255, 255, 85, true, Types.NORMAL, null, 40, 45, 35, 40, 40, 90, 69),
PERSIAN: new Race('Sianper', 'p', 255, 255, 85, true, Types.NORMAL, null, 65, 70, 60, 65, 65, 115, 148),
PSYDUCK: new Race('Duckpsy', 'p', 255, 255, 85, false, Types.WATER, null, 50, 52, 48, 65, 50, 55, 80),
GOLDUCK: new Race('Duckgold', 'g', 85, 85, 255, true, Types.WATER, null, 80, 82, 78, 95, 80, 85, 174),
MANKEY: new Race('Keyman', 'm', 170, 85, 0, true, Types.FIGHTING, null, 40, 80, 35, 35, 45, 70, 74),
PRIMEAPE: new Race('Apeprime', 'p', 170, 85, 0, true, Types.FIGHTING, null, 65, 105, 60, 60, 70, 95, 149),
GROWLITHE: new Race('Lithegrow', 'g', 170, 85, 0, true, Types.FIRE, null, 55, 70, 45, 70, 50, 60, 91),
ARCANINE: new Race('Ninearca', 'A', 170, 85, 0, true, Types.FIRE, null, 90, 110, 80, 100, 80, 95, 213),
POLIWAG: new Race('Wagpoli', 'p', 85, 85, 255, false, Types.WATER, null, 40, 50, 40, 40, 40, 90, 77),
POLIWHIRL: new Race('Whirlpoli', 'p', 85, 85, 255, true, Types.WATER, null, 65, 65, 65, 50, 50, 90, 131),
POLIWRATH: new Race('Wrathpoli', 'P', 85, 85, 255, true, Types.WATER, Types.FIGHTING, 90, 85, 95, 70, 90, 70, 185),
ABRA: new Race('Arba', 'a', 170, 85, 0, false, Types.PSYCHIC, null, 25, 20, 15, 105, 55, 90, 73),
KADABRA: new Race('Abrakad', 'k', 170, 85, 0, true, Types.PSYCHIC, null, 40, 35, 30, 120, 70, 105, 145),
ALAKAZAM: new Race('Zamalaka', 'A', 170, 85, 0, true, Types.PSYCHIC, null, 55, 50, 45, 135, 85, 120, 186),
MACHOP: new Race('Chopma', 'm', 170, 170, 170, true, Types.FIGHTING, null, 70, 80, 50, 35, 35, 35, 88),
MACHOKE: new Race('Chokema', 'm', 170, 170, 170, true, Types.FIGHTING, null, 80, 100, 70, 50, 60, 45, 146),
MACHAMP: new Race('Champma', 'M', 170, 170, 170, true, Types.FIGHTING, null, 90, 130, 80, 65, 85, 55, 193),
BELLSPROUT: new Race('Sproutbell', 'b', 85, 255, 85, false, Types.GRASS, Types.POISON, 50, 75, 35, 70, 30, 40, 84),
WEEPINBELL: new Race('Bellweepin', 'w', 85, 255, 85, false, Types.GRASS, Types.POISON, 65, 90, 50, 85, 45, 55, 151),
VICTREEBEL: new Race('Treebelvic', 'V', 85, 255, 85, true, Types.GRASS, Types.POISON, 80, 105, 65, 100, 60, 70, 191),
TENTACOOL: new Race('Cooltenta', 't', 85, 85, 255, true, Types.WATER, Types.POISON, 40, 40, 35, 50, 100, 70, 105),
TENTACRUEL: new Race('Crueltenta', 't', 85, 85, 255, true, Types.WATER, Types.POISON, 80, 70, 65, 80, 120, 100, 205),
GEODUDE: new Race('Dudegeo', 'g', 170, 85, 0, true, Types.ROCK, Types.GROUND, 40, 80, 100, 30, 30, 20, 86),
GRAVELER: new Race('Velergra', 'G', 170, 85, 0, true, Types.ROCK, Types.GROUND, 55, 95, 115, 45, 45, 35, 134),
GOLEM: new Race('Lemgo', 'G', 170, 85, 0, true, Types.ROCK, Types.GROUND, 80, 110, 130, 55, 65, 45, 177),
PONYTA: new Race('Tapony', 'p', 255, 255, 85, false, Types.FIRE, null, 50, 85, 55, 65, 65, 90, 152),
RAPIDASH: new Race('Dashrapi', 'R', 255, 255, 85, false, Types.FIRE, null, 65, 100, 70, 80, 80, 105, 192),
SLOWPOKE: new Race('Pokeslow', 's', 255, 85, 255, false, Types.WATER, Types.PSYCHIC, 90, 65, 65, 40, 40, 15, 99),
SLOWBRO: new Race('Broslow', 's', 255, 85, 255, false, Types.WATER, Types.PSYCHIC, 95, 75, 110, 100, 80, 30, 164),
MAGNEMITE: new Race('Mitemagne', 'm', 170, 170, 170, true, Types.ELECTRIC, Types.STEEL, 25, 35, 70, 95, 55, 45, 89),
MAGNETON: new Race('Tonmagne', 'm', 170, 170, 170, true, Types.ELECTRIC, Types.STEEL, 50, 60, 95, 120, 70, 70, 161),
FARFETCHD: new Race('Fetfarch\'d', 'f', 170, 85, 0, true, Types.NORMAL, Types.FLYING, 52, 65, 55, 58, 62, 60, 94),
DODUO: new Race('Duodo', 'd', 170, 85, 0, true, Types.NORMAL, Types.FLYING, 35, 85, 45, 35, 35, 75, 96),
DODRIO: new Race('Driodo', 'd', 170, 85, 0, true, Types.NORMAL, Types.FLYING, 60, 110, 70, 60, 60, 100, 158),
SEEL: new Race('Lees', 's', 255, 255, 255, false, Types.WATER, null, 65, 45, 55, 45, 70, 45, 100),
DEWGONG: new Race('Gongdew', 'd', 255, 255, 255, true, Types.WATER, Types.ICE, 90, 70, 80, 70, 95, 70, 176),
GRIMER: new Race('Mergri', 'g', 170, 0, 170, true, Types.POISON, null, 80, 80, 50, 40, 50, 25, 90),
MUK: new Race('Kum', 'm', 170, 0, 170, true, Types.POISON, null, 105, 105, 75, 65, 100, 50, 157),
SHELLDER: new Race('Dershell', 's', 170, 0, 170, false, Types.WATER, null, 30, 65, 100, 45, 25, 40, 97),
CLOYSTER: new Race('Stercloy', 'c', 170, 0, 170, true, Types.WATER, Types.ICE, 50, 90, 180, 85, 45, 70, 203),
GASTLY: new Race('Tlygas', 'g', 170, 0, 170, true, Types.GHOST, Types.POISON, 30, 35, 30, 100, 35, 80, 95),
HAUNTER: new Race('Terhaun', 'h', 170, 0, 170, true, Types.GHOST, Types.POISON, 45, 50, 45, 115, 55, 95, 126),
GENGAR: new Race('Gargen', 'G', 170, 0, 170, true, Types.GHOST, Types.POISON, 60, 65, 60, 130, 75, 110, 190),
ONIX: new Race('Nixo', 'O', 170, 170, 170, true, Types.ROCK, Types.GROUND, 35, 45, 160, 30, 45, 70, 108),
DROWZEE: new Race('Zeedrow', 'd', 255, 255, 85, false, Types.PSYCHIC, null, 60, 48, 45, 43, 90, 42, 102),
HYPNO: new Race('Nohyp', 'h', 255, 255, 85, false, Types.PSYCHIC, null, 85, 73, 70, 73, 115, 67, 165),
KRABBY: new Race('Bykrab', 'k', 255, 85, 85, false, Types.WATER, null, 30, 105, 90, 25, 25, 50, 115),
KINGLER: new Race('Glerking', 'K', 255, 85, 85, true, Types.WATER, null, 55, 130, 115, 50, 50, 75, 206),
VOLTORB: new Race('Orbvolt', 'v', 255, 85, 85, true, Types.ELECTRIC, null, 40, 30, 50, 55, 55, 100, 103),
ELECTRODE: new Race('Trodelect', 'E', 255, 85, 85, true, Types.ELECTRIC, null, 60, 50, 70, 80, 80, 140, 150),
EXEGGCUTE: new Race('Cutexegg', 'e', 255, 85, 255, true, Types.GRASS, Types.PSYCHIC, 60, 40, 80, 60, 45, 40, 98),
EXEGGUTOR: new Race('Gutorexegg', 'E', 255, 255, 85, true, Types.GRASS, Types.PSYCHIC, 95, 95, 85, 125, 65, 55, 212),
CUBONE: new Race('Bonecu', 'c', 170, 85, 0, true, Types.GROUND, null, 50, 50, 95, 40, 50, 35, 87),
MAROWAK: new Race('Wakmaro', 'm', 170, 85, 0, true, Types.GROUND, null, 60, 80, 110, 50, 80, 45, 124),
HITMONLEE: new Race('Leehitmon', 'h', 170, 85, 0, true, Types.FIGHTING, null, 50, 120, 53, 35, 110, 87, 139),
HITMONCHAN: new Race('Chanhitmon', 'h', 170, 85, 0, true, Types.FIGHTING, null, 50, 105, 79, 35, 110, 76, 140),
LICKITUNG: new Race('Tunglicki', 'l', 255, 85, 255, true, Types.NORMAL, null, 90, 55, 75, 60, 75, 30, 127),
KOFFING: new Race('Fingkof', 'k', 170, 0, 170, true, Types.POISON, null, 40, 65, 95, 60, 45, 35, 114),
WEEZING: new Race('Zingwee', 'w', 170, 0, 170, true, Types.POISON, null, 65, 90, 120, 85, 70, 60, 173),
RHYHORN: new Race('Hornrhy', 'R', 170, 170, 170, true, Types.GROUND, Types.ROCK, 80, 85, 95, 30, 30, 25, 135),
RHYDON: new Race('Donrhy', 'R', 170, 170, 170, true, Types.GROUND, Types.ROCK, 105, 130, 120, 45, 45, 40, 204),
CHANSEY: new Race('Seychan', 'c', 255, 85, 255, false, Types.NORMAL, null, 250, 5, 5, 35, 105, 50, 255),
TANGELA: new Race('Gelatan', 't', 85, 85, 255, false, Types.GRASS, null, 65, 55, 115, 100, 40, 60, 166),
KANGASKHAN: new Race('Khankangas', 'K', 170, 85, 0, true, Types.NORMAL, null, 105, 95, 80, 40, 80, 90, 175),
HORSEA: new Race('Seahor', 'h', 85, 85, 255, false, Types.WATER, null, 30, 40, 70, 70, 25, 60, 83),
SEADRA: new Race('Drasea', 's', 85, 85, 255, true, Types.WATER, null, 55, 65, 95, 95, 45, 85, 155),
GOLDEEN: new Race('Deengol', 'g', 255, 85, 85, false, Types.WATER, null, 45, 67, 60, 35, 50, 63, 111),
SEAKING: new Race('Kingsea', 'S', 255, 85, 85, true, Types.WATER, null, 80, 92, 65, 65, 80, 68, 170),
STARYU: new Race('Yustar', 's', 170, 85, 0, true, Types.WATER, null, 30, 45, 55, 70, 55, 85, 106),
STARMIE: new Race('Miestar', 's', 170, 0, 170, true, Types.WATER, Types.PSYCHIC, 60, 75, 85, 100, 85, 115, 207),
MR_MIME: new Race('Mr. Memi', 'm', 255, 85, 255, false, Types.PSYCHIC, null, 40, 45, 65, 100, 120, 90, 136),
SCYTHER: new Race('Therscy', 's', 85, 255, 85, true, Types.BUG, Types.FLYING, 70, 110, 80, 55, 80, 105, 187),
JYNX: new Race('Icycool', 'j', 255, 85, 85, false, Types.ICE, Types.PSYCHIC, 65, 50, 35, 115, 95, 95, 137),
ELECTABUZZ: new Race('Buzzelecta', 'e', 255, 255, 85, true, Types.ELECTRIC, null, 65, 83, 57, 95, 85, 105, 156),
MAGMAR: new Race('Marmag', 'm', 255, 85, 85, true, Types.FIRE, null, 65, 95, 57, 100, 85, 93, 167),
PINSIR: new Race('Sirpin', 'p', 170, 85, 0, true, Types.BUG, null, 65, 125, 100, 55, 70, 85, 200),
TAUROS: new Race('Rostau', 'T', 170, 85, 0, true, Types.NORMAL, null, 75, 100, 95, 40, 70, 110, 211),
MAGIKARP: new Race('Karpmagi', 'm', 255, 85, 85, false, Types.WATER, null, 20, 10, 55, 15, 20, 80, 20),
GYARADOS: new Race('Radosgya', 'G', 85, 85, 255, true, Types.WATER, Types.FLYING, 95, 125, 79, 60, 100, 81, 214),
LAPRAS: new Race('Prasla', 'L', 85, 85, 255, true, Types.WATER, Types.ICE, 130, 85, 80, 85, 95, 60, 219),
DITTO: new Race('Todit', 'd', 170, 0, 170, true, Types.NORMAL, null, 48, 48, 48, 48, 48, 48, 61),
EEVEE: new Race('Eon', 'e', 170, 85, 0, true, Types.NORMAL, null, 55, 55, 50, 45, 65, 55, 92),
VAPOREON: new Race('Eonvapor', 'v', 85, 85, 255, true, Types.WATER, null, 130, 65, 60, 110, 95, 65, 196),
JOLTEON: new Race('Eonjolt', 'j', 255, 255, 85, true, Types.ELECTRIC, null, 65, 65, 60, 110, 95, 130, 197),
FLAREON: new Race('Eonflar', 'f', 255, 85, 85, true, Types.FIRE, null, 65, 130, 60, 95, 110, 65, 198),
PORYGON: new Race('Gonpory', 'p', 255, 85, 255, true, Types.NORMAL, null, 65, 60, 70, 85, 75, 40, 130),
OMANYTE: new Race('Nyteoma', 'o', 85, 85, 255, true, Types.ROCK, Types.WATER, 35, 40, 100, 90, 55, 35, 120),
OMASTAR: new Race('Staroma', 'o', 85, 85, 255, true, Types.ROCK, Types.WATER, 70, 60, 125, 115, 70, 55, 199),
KABUTO: new Race('Butoka', 'k', 170, 85, 0, true, Types.ROCK, Types.WATER, 30, 80, 90, 55, 45, 55, 119),
KABUTOPS: new Race('Butopska', 'K', 170, 85, 0, true, Types.ROCK, Types.WATER, 60, 115, 105, 65, 70, 80, 201),
AERODACTYL: new Race('Dactylaero', 'A', 170, 0, 170, true, Types.ROCK, Types.FLYING, 80, 105, 65, 60, 75, 130, 202),
SNORLAX: new Race('Laxsnor', 'S', 85, 85, 85, false, Types.NORMAL, null, 160, 110, 65, 65, 110, 30, 154),
ARTICUNO: new Race('Cunoarti', 'A', 85, 85, 255, true, Types.ICE, Types.FLYING, 90, 85, 100, 95, 125, 85, 215),
ZAPDOS: new Race('Doszap', 'Z', 255, 255, 85, true, Types.ELECTRIC, Types.FLYING, 90, 90, 85, 125, 90, 100, 216),
MOLTRES: new Race('Tresmol', 'M', 255, 255, 85, true, Types.FIRE, Types.FLYING, 90, 100, 90, 125, 85, 90, 217),
DRATINI: new Race('Trinidra', 'd', 85, 85, 255, true, Types.DRAGON, null, 41, 64, 45, 50, 50, 50, 67),
DRAGONAIR: new Race('Gonairdra', 'd', 85, 85, 255, true, Types.DRAGON, null, 61, 84, 65, 70, 70, 70, 144),
DRAGONITE: new Race('Gonitedra', 'D', 170, 85, 0, true, Types.DRAGON, Types.FLYING, 91, 134, 95, 100, 100, 80, 218),
MEWTWO: new Race('Twomew', 'M', 170, 0, 170, true, Types.PSYCHIC, null, 106, 110, 90, 154, 90, 130, 220),
MEW: new Race('Wem', 'm', 255, 85, 255, true, Types.PSYCHIC, null, 100, 100, 100, 100, 100, 100, 64)
};

Races.BULBASAUR.skills.push({skill: Skills.TACKLE, level: 1});
Races.BULBASAUR.skills.push({skill: Skills.GROWL, level: 1});
Races.BULBASAUR.skills.push({skill: Skills.LEECH_SEED, level: 7});
Races.BULBASAUR.skills.push({skill: Skills.VINE_WHIP, level: 13});
Races.BULBASAUR.skills.push({skill: Skills.POISON_POWDER, level: 20});
Races.BULBASAUR.skills.push({skill: Skills.RAZOR_LEAF, level: 27});
Races.BULBASAUR.skills.push({skill: Skills.GROWTH, level: 34});
Races.BULBASAUR.skills.push({skill: Skills.SLEEP_POWDER, level: 41});
Races.BULBASAUR.skills.push({skill: Skills.SOLAR_BEAM, level: 48});
Races.IVYSAUR.skills.push({skill: Skills.VINE_WHIP, level: 13});
Races.IVYSAUR.skills.push({skill: Skills.POISON_POWDER, level: 22});
Races.IVYSAUR.skills.push({skill: Skills.RAZOR_LEAF, level: 30});
Races.IVYSAUR.skills.push({skill: Skills.GROWTH, level: 38});
Races.IVYSAUR.skills.push({skill: Skills.SLEEP_POWDER, level: 46});
Races.IVYSAUR.skills.push({skill: Skills.SOLAR_BEAM, level: 54});
Races.VENUSAUR.skills.push({skill: Skills.GROWTH, level: 43});
Races.VENUSAUR.skills.push({skill: Skills.SLEEP_POWDER, level: 55});
Races.VENUSAUR.skills.push({skill: Skills.SOLAR_BEAM, level: 65});
Races.CHARMANDER.skills.push({skill: Skills.SCRATCH, level: 1});
Races.CHARMANDER.skills.push({skill: Skills.GROWL, level: 1});
Races.CHARMANDER.skills.push({skill: Skills.EMBER, level: 9});
Races.CHARMANDER.skills.push({skill: Skills.LEER, level: 15});
Races.CHARMANDER.skills.push({skill: Skills.RAGE, level: 22});
Races.CHARMANDER.skills.push({skill: Skills.SLASH, level: 30});
Races.CHARMANDER.skills.push({skill: Skills.FLAMETHROWER, level: 38});
Races.CHARMANDER.skills.push({skill: Skills.FIRE_SPIN, level: 46});
Races.CHARMELEON.skills.push({skill: Skills.LEER, level: 15});
Races.CHARMELEON.skills.push({skill: Skills.RAGE, level: 24});
Races.CHARMELEON.skills.push({skill: Skills.SLASH, level: 33});
Races.CHARMELEON.skills.push({skill: Skills.FLAMETHROWER, level: 42});
Races.CHARMELEON.skills.push({skill: Skills.FIRE_SPIN, level: 56});
Races.CHARIZARD.skills.push({skill: Skills.SLASH, level: 36});
Races.CHARIZARD.skills.push({skill: Skills.FLAMETHROWER, level: 46});
Races.CHARIZARD.skills.push({skill: Skills.FIRE_SPIN, level: 55});
Races.SQUIRTLE.skills.push({skill: Skills.TACKLE, level: 1});
Races.SQUIRTLE.skills.push({skill: Skills.TAIL_WHIP, level: 1});
Races.SQUIRTLE.skills.push({skill: Skills.BUBBLE, level: 8});
Races.SQUIRTLE.skills.push({skill: Skills.WATER_GUN, level: 15});
Races.SQUIRTLE.skills.push({skill: Skills.BITE, level: 22});
Races.SQUIRTLE.skills.push({skill: Skills.WITHDRAW, level: 28});
Races.SQUIRTLE.skills.push({skill: Skills.SKULL_BASH, level: 35});
Races.SQUIRTLE.skills.push({skill: Skills.HYDRO_PUMP, level: 42});
Races.WARTORTLE.skills.push({skill: Skills.WATER_GUN, level: 15});
Races.WARTORTLE.skills.push({skill: Skills.BITE, level: 24});
Races.WARTORTLE.skills.push({skill: Skills.WITHDRAW, level: 31});
Races.WARTORTLE.skills.push({skill: Skills.SKULL_BASH, level: 39});
Races.WARTORTLE.skills.push({skill: Skills.HYDRO_PUMP, level: 47});
Races.BLASTOISE.skills.push({skill: Skills.BITE, level: 24});
Races.BLASTOISE.skills.push({skill: Skills.WITHDRAW, level: 31});
Races.BLASTOISE.skills.push({skill: Skills.SKULL_BASH, level: 42});
Races.BLASTOISE.skills.push({skill: Skills.HYDRO_PUMP, level: 52});
Races.CATERPIE.skills.push({skill: Skills.TACKLE, level: 1});
Races.CATERPIE.skills.push({skill: Skills.STRING_SHOT, level: 1});
Races.METAPOD.skills.push({skill: Skills.HARDEN, level: 1});
Races.BUTERFREE.skills.push({skill: Skills.CONFUSION, level: 12});
Races.BUTERFREE.skills.push({skill: Skills.POISON_POWDER, level: 15});
Races.BUTERFREE.skills.push({skill: Skills.STUN_SPORE, level: 16});
Races.BUTERFREE.skills.push({skill: Skills.SLEEP_POWDER, level: 17});
Races.BUTERFREE.skills.push({skill: Skills.SUPERSONIC, level: 21});
Races.BUTERFREE.skills.push({skill: Skills.WHIRLWIND, level: 26});
Races.BUTERFREE.skills.push({skill: Skills.PSYBEAM, level: 32});
Races.WEEDLE.skills.push({skill: Skills.POISON_STING, level: 1});
Races.WEEDLE.skills.push({skill: Skills.STRING_SHOT, level: 1});
Races.KAKUNA.skills.push({skill: Skills.HARDEN, level: 1});
Races.BEEDRILL.skills.push({skill: Skills.FURY_ATTACK, level: 12});
Races.BEEDRILL.skills.push({skill: Skills.FOCUS_ENERGY, level: 16});
Races.BEEDRILL.skills.push({skill: Skills.TWINEEDLE, level: 20});
Races.BEEDRILL.skills.push({skill: Skills.RAGE, level: 25});
Races.BEEDRILL.skills.push({skill: Skills.PIN_MISSILE, level: 30});
Races.BEEDRILL.skills.push({skill: Skills.AGILITY, level: 35});
Races.PIDGEY.skills.push({skill: Skills.GUST, level: 1});
Races.PIDGEY.skills.push({skill: Skills.SAND_ATTACK, level: 5});
Races.PIDGEY.skills.push({skill: Skills.QUICK_ATTACK, level: 12});
Races.PIDGEY.skills.push({skill: Skills.WHIRLWIND, level: 19});
Races.PIDGEY.skills.push({skill: Skills.WING_ATTACK, level: 28});
Races.PIDGEY.skills.push({skill: Skills.AGILITY, level: 36});
Races.PIDGEY.skills.push({skill: Skills.MIRROR_MOVE, level: 44});
Races.PIDGEOTTO.skills.push({skill: Skills.WHIRLWIND, level: 21});
Races.PIDGEOTTO.skills.push({skill: Skills.WING_ATTACK, level: 31});
Races.PIDGEOTTO.skills.push({skill: Skills.AGILITY, level: 40});
Races.PIDGEOTTO.skills.push({skill: Skills.MIRROR_MOVE, level: 49});
Races.PIDGEOT.skills.push({skill: Skills.AGILITY, level: 44});
Races.PIDGEOT.skills.push({skill: Skills.MIRROR_MOVE, level: 54});
Races.RATTATA.skills.push({skill: Skills.TACKLE, level: 1});
Races.RATTATA.skills.push({skill: Skills.TAIL_WHIP, level: 1});
Races.RATTATA.skills.push({skill: Skills.QUICK_ATTACK, level: 7});
Races.RATTATA.skills.push({skill: Skills.HYPER_FANG, level: 14});
Races.RATTATA.skills.push({skill: Skills.FOCUS_ENERGY, level: 23});
Races.RATTATA.skills.push({skill: Skills.SUPER_FANG, level: 34});
Races.RATICATE.skills.push({skill: Skills.HYPER_FANG, level: 14});
Races.RATICATE.skills.push({skill: Skills.FOCUS_ENERGY, level: 27});
Races.RATICATE.skills.push({skill: Skills.SUPER_FANG, level: 41});
Races.SPEAROW.skills.push({skill: Skills.PECK, level: 1});
Races.SPEAROW.skills.push({skill: Skills.GROWL, level: 1});
Races.SPEAROW.skills.push({skill: Skills.LEER, level: 9});
Races.SPEAROW.skills.push({skill: Skills.FURY_ATTACK, level: 15});
Races.SPEAROW.skills.push({skill: Skills.MIRROR_MOVE, level: 22});
Races.SPEAROW.skills.push({skill: Skills.DRILL_PECK, level: 29});
Races.SPEAROW.skills.push({skill: Skills.AGILITY, level: 36});
Races.FEAROW.skills.push({skill: Skills.MIRROR_MOVE, level: 25});
Races.FEAROW.skills.push({skill: Skills.DRILL_PECK, level: 34});
Races.FEAROW.skills.push({skill: Skills.AGILITY, level: 43});
Races.EKANS.skills.push({skill: Skills.WRAP, level: 1});
Races.EKANS.skills.push({skill: Skills.LEER, level: 1});
Races.EKANS.skills.push({skill: Skills.POISON_STING, level: 10});
Races.EKANS.skills.push({skill: Skills.BITE, level: 17});
Races.EKANS.skills.push({skill: Skills.GLARE, level: 24});
Races.EKANS.skills.push({skill: Skills.SCREECH, level: 31});
Races.EKANS.skills.push({skill: Skills.ACID, level: 38});
Races.ARBOK.skills.push({skill: Skills.BITE, level: 17});
Races.ARBOK.skills.push({skill: Skills.GLARE, level: 27});
Races.ARBOK.skills.push({skill: Skills.SCREECH, level: 36});
Races.ARBOK.skills.push({skill: Skills.ACID, level: 47});
Races.PIKACHU.skills.push({skill: Skills.THUNDER_SHOCK, level: 1});
Races.PIKACHU.skills.push({skill: Skills.GROWL, level: 1});
Races.PIKACHU.skills.push({skill: Skills.THUNDER_WAVE, level: 9});
Races.PIKACHU.skills.push({skill: Skills.QUICK_ATTACK, level: 16});
Races.PIKACHU.skills.push({skill: Skills.SWIFT, level: 26});
Races.PIKACHU.skills.push({skill: Skills.AGILITY, level: 33});
Races.PIKACHU.skills.push({skill: Skills.THUNDER, level: 43});
Races.SANDSHREW.skills.push({skill: Skills.SCRATCH, level: 1});
Races.SANDSHREW.skills.push({skill: Skills.SAND_ATTACK, level: 10});
Races.SANDSHREW.skills.push({skill: Skills.SLASH, level: 17});
Races.SANDSHREW.skills.push({skill: Skills.POISON_STING, level: 24});
Races.SANDSHREW.skills.push({skill: Skills.SWIFT, level: 31});
Races.SANDSHREW.skills.push({skill: Skills.FURY_SWIPES, level: 38});
Races.SANDSLASH.skills.push({skill: Skills.POISON_STING, level: 27});
Races.SANDSLASH.skills.push({skill: Skills.SWIFT, level: 36});
Races.SANDSLASH.skills.push({skill: Skills.FURY_SWIPES, level: 47});
Races.NIDORAN_F.skills.push({skill: Skills.GROWL, level: 1});
Races.NIDORAN_F.skills.push({skill: Skills.TACKLE, level: 1});
Races.NIDORAN_F.skills.push({skill: Skills.SCRATCH, level: 8});
Races.NIDORAN_F.skills.push({skill: Skills.POISON_STING, level: 14});
Races.NIDORAN_F.skills.push({skill: Skills.TAIL_WHIP, level: 21});
Races.NIDORAN_F.skills.push({skill: Skills.BITE, level: 29});
Races.NIDORAN_F.skills.push({skill: Skills.FURY_SWIPES, level: 36});
Races.NIDORAN_F.skills.push({skill: Skills.DOUBLE_KICK, level: 43});
Races.NIDORINA.skills.push({skill: Skills.POISON_STING, level: 14});
Races.NIDORINA.skills.push({skill: Skills.TAIL_WHIP, level: 23});
Races.NIDORINA.skills.push({skill: Skills.BITE, level: 32});
Races.NIDORINA.skills.push({skill: Skills.FURY_SWIPES, level: 41});
Races.NIDORINA.skills.push({skill: Skills.DOUBLE_KICK, level: 50});
Races.NIDOQUEEN.skills.push({skill: Skills.POISON_STING, level: 14});
Races.NIDOQUEEN.skills.push({skill: Skills.BODY_SLAM, level: 23});
Races.NIDORAN_M.skills.push({skill: Skills.LEER, level: 1});
Races.NIDORAN_M.skills.push({skill: Skills.TACKLE, level: 1});
Races.NIDORAN_M.skills.push({skill: Skills.HORN_ATTACK, level: 8});
Races.NIDORAN_M.skills.push({skill: Skills.POISON_STING, level: 14});
Races.NIDORAN_M.skills.push({skill: Skills.FOCUS_ENERGY, level: 21});
Races.NIDORAN_M.skills.push({skill: Skills.FURY_ATTACK, level: 29});
Races.NIDORAN_M.skills.push({skill: Skills.HORN_DRILL, level: 36});
Races.NIDORAN_M.skills.push({skill: Skills.DOUBLE_KICK, level: 43});
Races.NIDORINO.skills.push({skill: Skills.POUND, level: 1});
Races.NIDORINO.skills.push({skill: Skills.GROWL, level: 1});
Races.NIDORINO.skills.push({skill: Skills.SING, level: 13});
Races.NIDORINO.skills.push({skill: Skills.DOUBLE_SLAP, level: 18});
Races.NIDORINO.skills.push({skill: Skills.FOCUS_ENERGY, level: 23});
Races.NIDORINO.skills.push({skill: Skills.MINIMIZE, level: 24});
Races.NIDORINO.skills.push({skill: Skills.METRONOME, level: 31});
Races.NIDORINO.skills.push({skill: Skills.FURY_ATTACK, level: 32});
Races.NIDORINO.skills.push({skill: Skills.DEFENSE_CURL, level: 39});
Races.NIDORINO.skills.push({skill: Skills.HORN_DRILL, level: 41});
Races.NIDORINO.skills.push({skill: Skills.LIGHT_SCREEN, level: 48});
Races.NIDORINO.skills.push({skill: Skills.DOUBLE_KICK, level: 50});
Races.NIDOKING.skills.push({skill: Skills.THRASH, level: 23});
Races.CLEFAIRY.skills.push({skill: Skills.POUND, level: 1});
Races.CLEFAIRY.skills.push({skill: Skills.GROWL, level: 1});
Races.CLEFAIRY.skills.push({skill: Skills.SING, level: 13});
Races.CLEFAIRY.skills.push({skill: Skills.DOUBLE_SLAP, level: 18});
Races.CLEFAIRY.skills.push({skill: Skills.MINIMIZE, level: 24});
Races.CLEFAIRY.skills.push({skill: Skills.METRONOME, level: 31});
Races.CLEFAIRY.skills.push({skill: Skills.DEFENSE_CURL, level: 39});
Races.CLEFAIRY.skills.push({skill: Skills.LIGHT_SCREEN, level: 48});
Races.VULPIX.skills.push({skill: Skills.EMBER, level: 1});
Races.VULPIX.skills.push({skill: Skills.TAIL_WHIP, level: 1});
Races.VULPIX.skills.push({skill: Skills.QUICK_ATTACK, level: 16});
Races.VULPIX.skills.push({skill: Skills.ROAR, level: 21});
Races.VULPIX.skills.push({skill: Skills.CONFUSE_RAY, level: 28});
Races.VULPIX.skills.push({skill: Skills.FLAMETHROWER, level: 35});
Races.VULPIX.skills.push({skill: Skills.FIRE_SPIN, level: 42});
Races.JIGGLYPUFF.skills.push({skill: Skills.SING, level: 1});
Races.JIGGLYPUFF.skills.push({skill: Skills.POUND, level: 9});
Races.JIGGLYPUFF.skills.push({skill: Skills.DISABLE, level: 14});
Races.JIGGLYPUFF.skills.push({skill: Skills.DEFENSE_CURL, level: 19});
Races.JIGGLYPUFF.skills.push({skill: Skills.DOUBLE_SLAP, level: 24});
Races.JIGGLYPUFF.skills.push({skill: Skills.REST, level: 29});
Races.JIGGLYPUFF.skills.push({skill: Skills.BODY_SLAM, level: 34});
Races.JIGGLYPUFF.skills.push({skill: Skills.DOUBLE_EDGE, level: 39});
Races.ZUBAT.skills.push({skill: Skills.LEECH_LIFE, level: 1});
Races.ZUBAT.skills.push({skill: Skills.SUPERSONIC, level: 10});
Races.ZUBAT.skills.push({skill: Skills.BITE, level: 15});
Races.ZUBAT.skills.push({skill: Skills.CONFUSE_RAY, level: 21});
Races.ZUBAT.skills.push({skill: Skills.WING_ATTACK, level: 28});
Races.ZUBAT.skills.push({skill: Skills.HAZE, level: 36});
Races.GOLBAT.skills.push({skill: Skills.WING_ATTACK, level: 32});
Races.GOLBAT.skills.push({skill: Skills.HAZE, level: 43});
Races.ODDISH.skills.push({skill: Skills.ABSORB, level: 1});
Races.ODDISH.skills.push({skill: Skills.POISON_POWDER, level: 15});
Races.ODDISH.skills.push({skill: Skills.STUN_SPORE, level: 17});
Races.ODDISH.skills.push({skill: Skills.SLEEP_POWDER, level: 19});
Races.ODDISH.skills.push({skill: Skills.ACID, level: 24});
Races.ODDISH.skills.push({skill: Skills.PETAL_DANCE, level: 33});
Races.ODDISH.skills.push({skill: Skills.SOLAR_BEAM, level: 46});
Races.GLOOM.skills.push({skill: Skills.ACID, level: 28});
Races.GLOOM.skills.push({skill: Skills.PETAL_DANCE, level: 38});
Races.GLOOM.skills.push({skill: Skills.SOLAR_BEAM, level: 52});
Races.PARAS.skills.push({skill: Skills.SCRATCH, level: 1});
Races.PARAS.skills.push({skill: Skills.STUN_SPORE, level: 13});
Races.PARAS.skills.push({skill: Skills.LEECH_LIFE, level: 20});
Races.PARAS.skills.push({skill: Skills.SPORE, level: 27});
Races.PARAS.skills.push({skill: Skills.SLASH, level: 34});
Races.PARAS.skills.push({skill: Skills.GROWTH, level: 41});
Races.PARASECT.skills.push({skill: Skills.SPORE, level: 30});
Races.PARASECT.skills.push({skill: Skills.SLASH, level: 39});
Races.PARASECT.skills.push({skill: Skills.GROWTH, level: 48});
Races.VENONAT.skills.push({skill: Skills.TACKLE, level: 1});
Races.VENONAT.skills.push({skill: Skills.DISABLE, level: 1});
Races.VENONAT.skills.push({skill: Skills.POISON_POWDER, level: 24});
Races.VENONAT.skills.push({skill: Skills.LEECH_LIFE, level: 27});
Races.VENONAT.skills.push({skill: Skills.STUN_SPORE, level: 30});
Races.VENONAT.skills.push({skill: Skills.PSYBEAM, level: 35});
Races.VENONAT.skills.push({skill: Skills.SLEEP_POWDER, level: 38});
Races.VENONAT.skills.push({skill: Skills.PSYCHIC, level: 43});
Races.VENOMOTH.skills.push({skill: Skills.PSYBEAM, level: 38});
Races.VENOMOTH.skills.push({skill: Skills.SLEEP_POWDER, level: 43});
Races.VENOMOTH.skills.push({skill: Skills.PSYCHIC, level: 50});
Races.DIGLETT.skills.push({skill: Skills.SCRATCH, level: 1});
Races.DIGLETT.skills.push({skill: Skills.GROWL, level: 15});
Races.DIGLETT.skills.push({skill: Skills.DIG, level: 19});
Races.DIGLETT.skills.push({skill: Skills.SAND_ATTACK, level: 24});
Races.DIGLETT.skills.push({skill: Skills.SLASH, level: 31});
Races.DIGLETT.skills.push({skill: Skills.EARTHQUAKE, level: 40});
Races.DUGTRIO.skills.push({skill: Skills.SLASH, level: 35});
Races.DUGTRIO.skills.push({skill: Skills.EARTHQUAKE, level: 47});
Races.MEOWTH.skills.push({skill: Skills.SCRATCH, level: 1});
Races.MEOWTH.skills.push({skill: Skills.GROWL, level: 1});
Races.MEOWTH.skills.push({skill: Skills.BITE, level: 12});
Races.MEOWTH.skills.push({skill: Skills.PAY_DAY, level: 17});
Races.MEOWTH.skills.push({skill: Skills.SCREECH, level: 24});
Races.MEOWTH.skills.push({skill: Skills.FURY_SWIPES, level: 33});
Races.MEOWTH.skills.push({skill: Skills.SLASH, level: 44});
Races.PERSIAN.skills.push({skill: Skills.FURY_SWIPES, level: 37});
Races.PERSIAN.skills.push({skill: Skills.SLASH, level: 51});
Races.PSYDUCK.skills.push({skill: Skills.SCRATCH, level: 1});
Races.PSYDUCK.skills.push({skill: Skills.TAIL_WHIP, level: 28});
Races.PSYDUCK.skills.push({skill: Skills.DISABLE, level: 31});
Races.PSYDUCK.skills.push({skill: Skills.CONFUSION, level: 36});
Races.PSYDUCK.skills.push({skill: Skills.FURY_SWIPES, level: 43});
Races.PSYDUCK.skills.push({skill: Skills.HYDRO_PUMP, level: 52});
Races.GOLDUCK.skills.push({skill: Skills.CONFUSION, level: 39});
Races.GOLDUCK.skills.push({skill: Skills.FURY_SWIPES, level: 48});
Races.GOLDUCK.skills.push({skill: Skills.HYDRO_PUMP, level: 59});
Races.MANKEY.skills.push({skill: Skills.SCRATCH, level: 1});
Races.MANKEY.skills.push({skill: Skills.LEER, level: 1});
Races.MANKEY.skills.push({skill: Skills.KARATE_CHOP, level: 15});
Races.MANKEY.skills.push({skill: Skills.FURY_ATTACK, level: 21});
Races.MANKEY.skills.push({skill: Skills.FOCUS_ENERGY, level: 27});
Races.MANKEY.skills.push({skill: Skills.SEISMIC_TOSS, level: 33});
Races.MANKEY.skills.push({skill: Skills.THRASH, level: 39});
Races.PRIMEAPE.skills.push({skill: Skills.SEISMIC_TOSS, level: 37});
Races.PRIMEAPE.skills.push({skill: Skills.THRASH, level: 46});
Races.GROWLITHE.skills.push({skill: Skills.BITE, level: 1});
Races.GROWLITHE.skills.push({skill: Skills.ROAR, level: 1});
Races.GROWLITHE.skills.push({skill: Skills.EMBER, level: 18});
Races.GROWLITHE.skills.push({skill: Skills.LEER, level: 23});
Races.GROWLITHE.skills.push({skill: Skills.TAKE_DOWN, level: 30});
Races.GROWLITHE.skills.push({skill: Skills.AGILITY, level: 39});
Races.GROWLITHE.skills.push({skill: Skills.FLAMETHROWER, level: 50});
Races.POLIWAG.skills.push({skill: Skills.BUBBLE, level: 1});
Races.POLIWAG.skills.push({skill: Skills.HYPNOSIS, level: 16});
Races.POLIWAG.skills.push({skill: Skills.WATER_GUN, level: 19});
Races.POLIWAG.skills.push({skill: Skills.DOUBLE_SLAP, level: 25});
Races.POLIWAG.skills.push({skill: Skills.BODY_SLAM, level: 31});
Races.POLIWAG.skills.push({skill: Skills.AMNESIA, level: 38});
Races.POLIWAG.skills.push({skill: Skills.HYDRO_PUMP, level: 45});
Races.POLIWHIRL.skills.push({skill: Skills.DOUBLE_SLAP, level: 26});
Races.POLIWHIRL.skills.push({skill: Skills.BODY_SLAM, level: 33});
Races.POLIWHIRL.skills.push({skill: Skills.AMNESIA, level: 41});
Races.POLIWHIRL.skills.push({skill: Skills.HYDRO_PUMP, level: 49});
Races.ABRA.skills.push({skill: Skills.TELEPORT, level: 1});
Races.KADABRA.skills.push({skill: Skills.TELEPORT, level: 1});
Races.KADABRA.skills.push({skill: Skills.CONFUSION, level: 1});
Races.KADABRA.skills.push({skill: Skills.DISABLE, level: 20});
Races.KADABRA.skills.push({skill: Skills.PSYBEAM, level: 27});
Races.KADABRA.skills.push({skill: Skills.RECOVER, level: 31});
Races.KADABRA.skills.push({skill: Skills.PSYCHIC, level: 38});
Races.KADABRA.skills.push({skill: Skills.REFLECT, level: 42});
Races.ALAKAZAM.skills.push({skill: Skills.DISABLE, level: 20});
Races.ALAKAZAM.skills.push({skill: Skills.PSYBEAM, level: 27});
Races.ALAKAZAM.skills.push({skill: Skills.RECOVER, level: 31});
Races.ALAKAZAM.skills.push({skill: Skills.PSYCHIC, level: 38});
Races.ALAKAZAM.skills.push({skill: Skills.REFLECT, level: 42});
Races.MACHOP.skills.push({skill: Skills.KARATE_CHOP, level: 1});
Races.MACHOP.skills.push({skill: Skills.LOW_KICK, level: 20});
Races.MACHOP.skills.push({skill: Skills.LEER, level: 25});
Races.MACHOP.skills.push({skill: Skills.FOCUS_ENERGY, level: 32});
Races.MACHOP.skills.push({skill: Skills.SEISMIC_TOSS, level: 39});
Races.MACHOP.skills.push({skill: Skills.SUBMISSION, level: 46});
Races.MACHOKE.skills.push({skill: Skills.FOCUS_ENERGY, level: 36});
Races.MACHOKE.skills.push({skill: Skills.SEISMIC_TOSS, level: 44});
Races.MACHOKE.skills.push({skill: Skills.SUBMISSION, level: 52});
Races.MACHAMP.skills.push({skill: Skills.FOCUS_ENERGY, level: 36});
Races.MACHAMP.skills.push({skill: Skills.SEISMIC_TOSS, level: 44});
Races.MACHAMP.skills.push({skill: Skills.SUBMISSION, level: 52});
Races.BELLSPROUT.skills.push({skill: Skills.VINE_WHIP, level: 1});
Races.BELLSPROUT.skills.push({skill: Skills.GROWTH, level: 1});
Races.BELLSPROUT.skills.push({skill: Skills.WRAP, level: 13});
Races.BELLSPROUT.skills.push({skill: Skills.POISON_POWDER, level: 15});
Races.BELLSPROUT.skills.push({skill: Skills.SLEEP_POWDER, level: 18});
Races.BELLSPROUT.skills.push({skill: Skills.STUN_SPORE, level: 21});
Races.BELLSPROUT.skills.push({skill: Skills.ACID, level: 26});
Races.BELLSPROUT.skills.push({skill: Skills.RAZOR_LEAF, level: 33});
Races.BELLSPROUT.skills.push({skill: Skills.SLAM, level: 42});
Races.WEEPINBELL.skills.push({skill: Skills.STUN_SPORE, level: 23});
Races.WEEPINBELL.skills.push({skill: Skills.ACID, level: 29});
Races.WEEPINBELL.skills.push({skill: Skills.RAZOR_LEAF, level: 38});
Races.WEEPINBELL.skills.push({skill: Skills.SLAM, level: 49});
Races.TENTACOOL.skills.push({skill: Skills.ACID, level: 1});
Races.TENTACOOL.skills.push({skill: Skills.SUPERSONIC, level: 7});
Races.TENTACOOL.skills.push({skill: Skills.WRAP, level: 13});
Races.TENTACOOL.skills.push({skill: Skills.POISON_STING, level: 18});
Races.TENTACOOL.skills.push({skill: Skills.WATER_GUN, level: 22});
Races.TENTACOOL.skills.push({skill: Skills.CONSTRICT, level: 27});
Races.TENTACOOL.skills.push({skill: Skills.BARRIER, level: 33});
Races.TENTACOOL.skills.push({skill: Skills.SCREECH, level: 40});
Races.TENTACOOL.skills.push({skill: Skills.HYDRO_PUMP, level: 48});
Races.TENTACRUEL.skills.push({skill: Skills.BARRIER, level: 35});
Races.TENTACRUEL.skills.push({skill: Skills.SCREECH, level: 43});
Races.TENTACRUEL.skills.push({skill: Skills.HYDRO_PUMP, level: 50});
Races.GEODUDE.skills.push({skill: Skills.TACKLE, level: 1});
Races.GEODUDE.skills.push({skill: Skills.DEFENSE_CURL, level: 11});
Races.GEODUDE.skills.push({skill: Skills.ROCK_THROW, level: 16});
Races.GEODUDE.skills.push({skill: Skills.SELF_DESTRUCT, level: 21});
Races.GEODUDE.skills.push({skill: Skills.HARDEN, level: 26});
Races.GEODUDE.skills.push({skill: Skills.EARTHQUAKE, level: 31});
Races.GEODUDE.skills.push({skill: Skills.EXPLOSION, level: 36});
Races.GRAVELER.skills.push({skill: Skills.HARDEN, level: 29});
Races.GRAVELER.skills.push({skill: Skills.EARTHQUAKE, level: 36});
Races.GRAVELER.skills.push({skill: Skills.EXPLOSION, level: 43});
Races.GOLEM.skills.push({skill: Skills.HARDEN, level: 29});
Races.GOLEM.skills.push({skill: Skills.EARTHQUAKE, level: 36});
Races.GOLEM.skills.push({skill: Skills.EXPLOSION, level: 43});
Races.PONYTA.skills.push({skill: Skills.EMBER, level: 1});
Races.PONYTA.skills.push({skill: Skills.TAIL_WHIP, level: 30});
Races.PONYTA.skills.push({skill: Skills.STOMP, level: 32});
Races.PONYTA.skills.push({skill: Skills.GROWL, level: 35});
Races.PONYTA.skills.push({skill: Skills.FIRE_SPIN, level: 39});
Races.PONYTA.skills.push({skill: Skills.TAKE_DOWN, level: 43});
Races.PONYTA.skills.push({skill: Skills.AGILITY, level: 48});
Races.RAPIDASH.skills.push({skill: Skills.TAKE_DOWN, level: 47});
Races.RAPIDASH.skills.push({skill: Skills.AGILITY, level: 55});
Races.SLOWPOKE.skills.push({skill: Skills.CONFUSION, level: 1});
Races.SLOWPOKE.skills.push({skill: Skills.DISABLE, level: 18});
Races.SLOWPOKE.skills.push({skill: Skills.HEADBUTT, level: 22});
Races.SLOWPOKE.skills.push({skill: Skills.GROWL, level: 27});
Races.SLOWPOKE.skills.push({skill: Skills.WATER_GUN, level: 33});
Races.SLOWPOKE.skills.push({skill: Skills.AMNESIA, level: 40});
Races.SLOWPOKE.skills.push({skill: Skills.PSYCHIC, level: 48});
Races.SLOWBRO.skills.push({skill: Skills.AMNESIA, level: 44});
Races.SLOWBRO.skills.push({skill: Skills.PSYCHIC, level: 55});
Races.MAGNEMITE.skills.push({skill: Skills.TACKLE, level: 1});
Races.MAGNEMITE.skills.push({skill: Skills.SONIC_BOOM, level: 21});
Races.MAGNEMITE.skills.push({skill: Skills.THUNDER_SHOCK, level: 25});
Races.MAGNEMITE.skills.push({skill: Skills.SUPERSONIC, level: 29});
Races.MAGNEMITE.skills.push({skill: Skills.THUNDER_WAVE, level: 35});
Races.MAGNEMITE.skills.push({skill: Skills.SWIFT, level: 41});
Races.MAGNEMITE.skills.push({skill: Skills.SCREECH, level: 47});
Races.MAGNETON.skills.push({skill: Skills.THUNDER_WAVE, level: 38});
Races.MAGNETON.skills.push({skill: Skills.SWIFT, level: 46});
Races.MAGNETON.skills.push({skill: Skills.SCREECH, level: 54});
Races.FARFETCHD.skills.push({skill: Skills.PECK, level: 1});
Races.FARFETCHD.skills.push({skill: Skills.SAND_ATTACK, level: 1});
Races.FARFETCHD.skills.push({skill: Skills.LEER, level: 7});
Races.FARFETCHD.skills.push({skill: Skills.FURY_ATTACK, level: 15});
Races.FARFETCHD.skills.push({skill: Skills.SWORDS_DANCE, level: 23});
Races.FARFETCHD.skills.push({skill: Skills.AGILITY, level: 31});
Races.FARFETCHD.skills.push({skill: Skills.SLASH, level: 39});
Races.DODUO.skills.push({skill: Skills.PECK, level: 1});
Races.DODUO.skills.push({skill: Skills.GROWL, level: 20});
Races.DODUO.skills.push({skill: Skills.FURY_ATTACK, level: 24});
Races.DODUO.skills.push({skill: Skills.DRILL_PECK, level: 30});
Races.DODUO.skills.push({skill: Skills.RAGE, level: 36});
Races.DODUO.skills.push({skill: Skills.TRI_ATTACK, level: 40});
Races.DODUO.skills.push({skill: Skills.AGILITY, level: 44});
Races.DODRIO.skills.push({skill: Skills.RAGE, level: 39});
Races.DODRIO.skills.push({skill: Skills.TRI_ATTACK, level: 45});
Races.DODRIO.skills.push({skill: Skills.AGILITY, level: 51});
Races.SEEL.skills.push({skill: Skills.HEADBUTT, level: 1});
Races.SEEL.skills.push({skill: Skills.GROWL, level: 30});
Races.SEEL.skills.push({skill: Skills.AURORA_BEAM, level: 35});
Races.SEEL.skills.push({skill: Skills.REST, level: 40});
Races.SEEL.skills.push({skill: Skills.TAKE_DOWN, level: 45});
Races.SEEL.skills.push({skill: Skills.ICE_BEAM, level: 50});
Races.DEWGONG.skills.push({skill: Skills.AURORA_BEAM, level: 35});
Races.DEWGONG.skills.push({skill: Skills.REST, level: 44});
Races.DEWGONG.skills.push({skill: Skills.TAKE_DOWN, level: 50});
Races.DEWGONG.skills.push({skill: Skills.ICE_BEAM, level: 56});
Races.GRIMER.skills.push({skill: Skills.POUND, level: 1});
Races.GRIMER.skills.push({skill: Skills.DISABLE, level: 1});
Races.GRIMER.skills.push({skill: Skills.POISON_GAS, level: 30});
Races.GRIMER.skills.push({skill: Skills.MINIMIZE, level: 33});
Races.GRIMER.skills.push({skill: Skills.SLUDGE, level: 37});
Races.GRIMER.skills.push({skill: Skills.HARDEN, level: 42});
Races.GRIMER.skills.push({skill: Skills.SCREECH, level: 48});
Races.GRIMER.skills.push({skill: Skills.ACID_ARMOR, level: 55});
Races.MUK.skills.push({skill: Skills.HARDEN, level: 45});
Races.MUK.skills.push({skill: Skills.SCREECH, level: 53});
Races.MUK.skills.push({skill: Skills.ACID_ARMOR, level: 60});
Races.SHELLDER.skills.push({skill: Skills.TACKLE, level: 1});
Races.SHELLDER.skills.push({skill: Skills.WITHDRAW, level: 1});
Races.SHELLDER.skills.push({skill: Skills.SUPERSONIC, level: 18});
Races.SHELLDER.skills.push({skill: Skills.CLAMP, level: 23});
Races.SHELLDER.skills.push({skill: Skills.AURORA_BEAM, level: 30});
Races.SHELLDER.skills.push({skill: Skills.LEER, level: 39});
Races.SHELLDER.skills.push({skill: Skills.ICE_BEAM, level: 50});
Races.CLOYSTER.skills.push({skill: Skills.SPIKE_CANNON, level: 50});
Races.GASTLY.skills.push({skill: Skills.LICK, level: 1});
Races.GASTLY.skills.push({skill: Skills.CONFUSE_RAY, level: 1});
Races.GASTLY.skills.push({skill: Skills.NIGHT_SHADE, level: 1});
Races.GASTLY.skills.push({skill: Skills.HYPNOSIS, level: 27});
Races.GASTLY.skills.push({skill: Skills.DREAM_EATER, level: 35});
Races.HAUNTER.skills.push({skill: Skills.HYPNOSIS, level: 29});
Races.HAUNTER.skills.push({skill: Skills.DREAM_EATER, level: 38});
Races.GENGAR.skills.push({skill: Skills.HYPNOSIS, level: 29});
Races.GENGAR.skills.push({skill: Skills.DREAM_EATER, level: 38});
Races.ONIX.skills.push({skill: Skills.TACKLE, level: 1});
Races.ONIX.skills.push({skill: Skills.SCREECH, level: 1});
Races.ONIX.skills.push({skill: Skills.BIND, level: 15});
Races.ONIX.skills.push({skill: Skills.ROCK_THROW, level: 19});
Races.ONIX.skills.push({skill: Skills.RAGE, level: 25});
Races.ONIX.skills.push({skill: Skills.SLAM, level: 33});
Races.ONIX.skills.push({skill: Skills.HARDEN, level: 43});
Races.DROWZEE.skills.push({skill: Skills.POUND, level: 1});
Races.DROWZEE.skills.push({skill: Skills.HYPNOSIS, level: 1});
Races.DROWZEE.skills.push({skill: Skills.DISABLE, level: 12});
Races.DROWZEE.skills.push({skill: Skills.CONFUSION, level: 17});
Races.DROWZEE.skills.push({skill: Skills.HEADBUTT, level: 24});
Races.DROWZEE.skills.push({skill: Skills.POISON_GAS, level: 29});
Races.DROWZEE.skills.push({skill: Skills.PSYCHIC, level: 32});
Races.DROWZEE.skills.push({skill: Skills.MEDITATE, level: 37});
Races.HYPNO.skills.push({skill: Skills.POISON_GAS, level: 33});
Races.HYPNO.skills.push({skill: Skills.PSYCHIC, level: 37});
Races.HYPNO.skills.push({skill: Skills.MEDITATE, level: 43});
Races.KRABBY.skills.push({skill: Skills.BUBBLE, level: 1});
Races.KRABBY.skills.push({skill: Skills.LEER, level: 1});
Races.KRABBY.skills.push({skill: Skills.VICE_GRIP, level: 20});
Races.KRABBY.skills.push({skill: Skills.GUILLOTINE, level: 25});
Races.KRABBY.skills.push({skill: Skills.STOMP, level: 30});
Races.KRABBY.skills.push({skill: Skills.CRABHAMMER, level: 35});
Races.KRABBY.skills.push({skill: Skills.HARDEN, level: 40});
Races.KINGLER.skills.push({skill: Skills.STOMP, level: 34});
Races.KINGLER.skills.push({skill: Skills.CRABHAMMER, level: 42});
Races.KINGLER.skills.push({skill: Skills.HARDEN, level: 49});
Races.VOLTORB.skills.push({skill: Skills.TACKLE, level: 1});
Races.VOLTORB.skills.push({skill: Skills.SCREECH, level: 1});
Races.VOLTORB.skills.push({skill: Skills.SONIC_BOOM, level: 17});
Races.VOLTORB.skills.push({skill: Skills.SELF_DESTRUCT, level: 22});
Races.VOLTORB.skills.push({skill: Skills.LIGHT_SCREEN, level: 29});
Races.VOLTORB.skills.push({skill: Skills.SWIFT, level: 36});
Races.VOLTORB.skills.push({skill: Skills.EXPLOSION, level: 43});
Races.ELECTRODE.skills.push({skill: Skills.SWIFT, level: 40});
Races.ELECTRODE.skills.push({skill: Skills.EXPLOSION, level: 50});
Races.EXEGGCUTE.skills.push({skill: Skills.BARRAGE, level: 1});
Races.EXEGGCUTE.skills.push({skill: Skills.HYPNOSIS, level: 1});
Races.EXEGGCUTE.skills.push({skill: Skills.REFLECT, level: 25});
Races.EXEGGCUTE.skills.push({skill: Skills.LEECH_SEED, level: 28});
Races.EXEGGCUTE.skills.push({skill: Skills.STUN_SPORE, level: 32});
Races.EXEGGCUTE.skills.push({skill: Skills.POISON_POWDER, level: 37});
Races.EXEGGCUTE.skills.push({skill: Skills.SOLAR_BEAM, level: 42});
Races.EXEGGCUTE.skills.push({skill: Skills.SLEEP_POWDER, level: 48});
Races.EXEGGUTOR.skills.push({skill: Skills.STOMP, level: 28});
Races.CUBONE.skills.push({skill: Skills.BONE_CLUB, level: 1});
Races.CUBONE.skills.push({skill: Skills.GROWL, level: 1});
Races.CUBONE.skills.push({skill: Skills.LEER, level: 25});
Races.CUBONE.skills.push({skill: Skills.FOCUS_ENERGY, level: 31});
Races.CUBONE.skills.push({skill: Skills.THRASH, level: 38});
Races.CUBONE.skills.push({skill: Skills.BONEMERANG, level: 43});
Races.CUBONE.skills.push({skill: Skills.RAGE, level: 46});
Races.MAROWAK.skills.push({skill: Skills.FOCUS_ENERGY, level: 33});
Races.MAROWAK.skills.push({skill: Skills.THRASH, level: 41});
Races.MAROWAK.skills.push({skill: Skills.BONEMERANG, level: 48});
Races.MAROWAK.skills.push({skill: Skills.RAGE, level: 55});
Races.HITMONLEE.skills.push({skill: Skills.DOUBLE_KICK, level: 1});
Races.HITMONLEE.skills.push({skill: Skills.MEDITATE, level: 1});
Races.HITMONLEE.skills.push({skill: Skills.ROLLING_KICK, level: 33});
Races.HITMONLEE.skills.push({skill: Skills.JUMP_KICK, level: 38});
Races.HITMONLEE.skills.push({skill: Skills.FOCUS_ENERGY, level: 43});
Races.HITMONLEE.skills.push({skill: Skills.HIGH_JUMP_KICK, level: 48});
Races.HITMONLEE.skills.push({skill: Skills.MEGA_KICK, level: 53});
Races.HITMONCHAN.skills.push({skill: Skills.COMET_PUNCH, level: 1});
Races.HITMONCHAN.skills.push({skill: Skills.AGILITY, level: 1});
Races.HITMONCHAN.skills.push({skill: Skills.FIRE_PUNCH, level: 33});
Races.HITMONCHAN.skills.push({skill: Skills.ICE_PUNCH, level: 38});
Races.HITMONCHAN.skills.push({skill: Skills.THUNDER_PUNCH, level: 43});
Races.HITMONCHAN.skills.push({skill: Skills.MEGA_PUNCH, level: 48});
Races.HITMONCHAN.skills.push({skill: Skills.COUNTER, level: 53});
Races.LICKITUNG.skills.push({skill: Skills.WRAP, level: 1});
Races.LICKITUNG.skills.push({skill: Skills.SUPERSONIC, level: 1});
Races.LICKITUNG.skills.push({skill: Skills.STOMP, level: 7});
Races.LICKITUNG.skills.push({skill: Skills.DISABLE, level: 15});
Races.LICKITUNG.skills.push({skill: Skills.DEFENSE_CURL, level: 23});
Races.LICKITUNG.skills.push({skill: Skills.SLAM, level: 31});
Races.LICKITUNG.skills.push({skill: Skills.SCREECH, level: 39});
Races.KOFFING.skills.push({skill: Skills.TACKLE, level: 1});
Races.KOFFING.skills.push({skill: Skills.SMOG, level: 1});
Races.KOFFING.skills.push({skill: Skills.SLUDGE, level: 32});
Races.KOFFING.skills.push({skill: Skills.SMOKESCREEN, level: 37});
Races.KOFFING.skills.push({skill: Skills.SELF_DESTRUCT, level: 40});
Races.KOFFING.skills.push({skill: Skills.HAZE, level: 45});
Races.KOFFING.skills.push({skill: Skills.EXPLOSION, level: 48});
Races.WEEZING.skills.push({skill: Skills.SMOKESCREEN, level: 39});
Races.WEEZING.skills.push({skill: Skills.SELF_DESTRUCT, level: 43});
Races.WEEZING.skills.push({skill: Skills.HAZE, level: 49});
Races.WEEZING.skills.push({skill: Skills.EXPLOSION, level: 53});
Races.RHYHORN.skills.push({skill: Skills.HORN_ATTACK, level: 1});
Races.RHYHORN.skills.push({skill: Skills.STOMP, level: 30});
Races.RHYHORN.skills.push({skill: Skills.TAIL_WHIP, level: 35});
Races.RHYHORN.skills.push({skill: Skills.FURY_ATTACK, level: 40});
Races.RHYHORN.skills.push({skill: Skills.HORN_DRILL, level: 45});
Races.RHYHORN.skills.push({skill: Skills.LEER, level: 50});
Races.RHYHORN.skills.push({skill: Skills.TAKE_DOWN, level: 55});
Races.RHYDON.skills.push({skill: Skills.HORN_DRILL, level: 48});
Races.RHYDON.skills.push({skill: Skills.LEER, level: 55});
Races.RHYDON.skills.push({skill: Skills.TAKE_DOWN, level: 64});
Races.CHANSEY.skills.push({skill: Skills.POUND, level: 1});
Races.CHANSEY.skills.push({skill: Skills.DOUBLE_SLAP, level: 1});
Races.CHANSEY.skills.push({skill: Skills.SING, level: 24});
Races.CHANSEY.skills.push({skill: Skills.GROWL, level: 30});
Races.CHANSEY.skills.push({skill: Skills.MINIMIZE, level: 38});
Races.CHANSEY.skills.push({skill: Skills.DEFENSE_CURL, level: 44});
Races.CHANSEY.skills.push({skill: Skills.LIGHT_SCREEN, level: 48});
Races.CHANSEY.skills.push({skill: Skills.DOUBLE_EDGE, level: 54});
Races.TANGELA.skills.push({skill: Skills.CONSTRICT, level: 1});
Races.TANGELA.skills.push({skill: Skills.BIND, level: 1});
Races.TANGELA.skills.push({skill: Skills.ABSORB, level: 29});
Races.TANGELA.skills.push({skill: Skills.POISON_POWDER, level: 32});
Races.TANGELA.skills.push({skill: Skills.STUN_SPORE, level: 36});
Races.TANGELA.skills.push({skill: Skills.SLEEP_POWDER, level: 39});
Races.TANGELA.skills.push({skill: Skills.SLAM, level: 45});
Races.TANGELA.skills.push({skill: Skills.GROWTH, level: 49});
Races.KANGASKHAN.skills.push({skill: Skills.COMET_PUNCH, level: 1});
Races.KANGASKHAN.skills.push({skill: Skills.RAGE, level: 1});
Races.KANGASKHAN.skills.push({skill: Skills.BITE, level: 26});
Races.KANGASKHAN.skills.push({skill: Skills.TAIL_WHIP, level: 31});
Races.KANGASKHAN.skills.push({skill: Skills.MEGA_PUNCH, level: 36});
Races.KANGASKHAN.skills.push({skill: Skills.LEER, level: 41});
Races.KANGASKHAN.skills.push({skill: Skills.DIZZY_PUNCH, level: 46});
Races.HORSEA.skills.push({skill: Skills.BUBBLE, level: 1});
Races.HORSEA.skills.push({skill: Skills.SMOKESCREEN, level: 19});
Races.HORSEA.skills.push({skill: Skills.LEER, level: 24});
Races.HORSEA.skills.push({skill: Skills.WATER_GUN, level: 30});
Races.HORSEA.skills.push({skill: Skills.AGILITY, level: 37});
Races.HORSEA.skills.push({skill: Skills.HYDRO_PUMP, level: 45});
Races.SEADRA.skills.push({skill: Skills.AGILITY, level: 41});
Races.SEADRA.skills.push({skill: Skills.HYDRO_PUMP, level: 52});
Races.GOLDEEN.skills.push({skill: Skills.PECK, level: 1});
Races.GOLDEEN.skills.push({skill: Skills.TAIL_WHIP, level: 1});
Races.GOLDEEN.skills.push({skill: Skills.SUPERSONIC, level: 19});
Races.GOLDEEN.skills.push({skill: Skills.HORN_ATTACK, level: 24});
Races.GOLDEEN.skills.push({skill: Skills.FURY_ATTACK, level: 30});
Races.GOLDEEN.skills.push({skill: Skills.WATERFALL, level: 37});
Races.GOLDEEN.skills.push({skill: Skills.HORN_DRILL, level: 45});
Races.GOLDEEN.skills.push({skill: Skills.AGILITY, level: 54});
Races.SEAKING.skills.push({skill: Skills.WATERFALL, level: 39});
Races.SEAKING.skills.push({skill: Skills.HORN_DRILL, level: 48});
Races.SEAKING.skills.push({skill: Skills.AGILITY, level: 54});
Races.STARYU.skills.push({skill: Skills.TACKLE, level: 1});
Races.STARYU.skills.push({skill: Skills.WATER_GUN, level: 17});
Races.STARYU.skills.push({skill: Skills.HARDEN, level: 22});
Races.STARYU.skills.push({skill: Skills.RECOVER, level: 27});
Races.STARYU.skills.push({skill: Skills.SWIFT, level: 32});
Races.STARYU.skills.push({skill: Skills.MINIMIZE, level: 37});
Races.STARYU.skills.push({skill: Skills.LIGHT_SCREEN, level: 42});
Races.STARYU.skills.push({skill: Skills.HYDRO_PUMP, level: 47});
Races.MR_MIME.skills.push({skill: Skills.CONFUSION, level: 1});
Races.MR_MIME.skills.push({skill: Skills.BARRIER, level: 1});
Races.MR_MIME.skills.push({skill: Skills.LIGHT_SCREEN, level: 23});
Races.MR_MIME.skills.push({skill: Skills.DOUBLE_SLAP, level: 31});
Races.MR_MIME.skills.push({skill: Skills.MEDITATE, level: 39});
Races.MR_MIME.skills.push({skill: Skills.SUBSTITUTE, level: 47});
Races.SCYTHER.skills.push({skill: Skills.QUICK_ATTACK, level: 1});
Races.SCYTHER.skills.push({skill: Skills.LEER, level: 17});
Races.SCYTHER.skills.push({skill: Skills.FOCUS_ENERGY, level: 20});
Races.SCYTHER.skills.push({skill: Skills.DOUBLE_TEAM, level: 24});
Races.SCYTHER.skills.push({skill: Skills.SLASH, level: 29});
Races.SCYTHER.skills.push({skill: Skills.SWORDS_DANCE, level: 35});
Races.SCYTHER.skills.push({skill: Skills.AGILITY, level: 42});
Races.JYNX.skills.push({skill: Skills.POUND, level: 1});
Races.JYNX.skills.push({skill: Skills.LOVELY_KISS, level: 1});
Races.JYNX.skills.push({skill: Skills.SING, level: 15});
Races.JYNX.skills.push({skill: Skills.DOUBLE_SLAP, level: 23});
Races.JYNX.skills.push({skill: Skills.ICE_PUNCH, level: 31});
Races.JYNX.skills.push({skill: Skills.MEDITATE, level: 39});
Races.JYNX.skills.push({skill: Skills.BLIZZARD, level: 47});
Races.ELECTABUZZ.skills.push({skill: Skills.QUICK_ATTACK, level: 1});
Races.ELECTABUZZ.skills.push({skill: Skills.LEER, level: 1});
Races.ELECTABUZZ.skills.push({skill: Skills.THUNDER_SHOCK, level: 34});
Races.ELECTABUZZ.skills.push({skill: Skills.SCREECH, level: 37});
Races.ELECTABUZZ.skills.push({skill: Skills.THUNDER_PUNCH, level: 42});
Races.ELECTABUZZ.skills.push({skill: Skills.LIGHT_SCREEN, level: 49});
Races.ELECTABUZZ.skills.push({skill: Skills.THUNDER, level: 54});
Races.MAGMAR.skills.push({skill: Skills.EMBER, level: 1});
Races.MAGMAR.skills.push({skill: Skills.LEER, level: 36});
Races.MAGMAR.skills.push({skill: Skills.CONFUSE_RAY, level: 39});
Races.MAGMAR.skills.push({skill: Skills.FIRE_PUNCH, level: 43});
Races.MAGMAR.skills.push({skill: Skills.SMOKESCREEN, level: 48});
Races.MAGMAR.skills.push({skill: Skills.SMOG, level: 52});
Races.MAGMAR.skills.push({skill: Skills.FLAMETHROWER, level: 55});
Races.PINSIR.skills.push({skill: Skills.VICE_GRIP, level: 1});
Races.PINSIR.skills.push({skill: Skills.SEISMIC_TOSS, level: 25});
Races.PINSIR.skills.push({skill: Skills.GUILLOTINE, level: 30});
Races.PINSIR.skills.push({skill: Skills.FOCUS_ENERGY, level: 36});
Races.PINSIR.skills.push({skill: Skills.HARDEN, level: 43});
Races.PINSIR.skills.push({skill: Skills.SLASH, level: 49});
Races.PINSIR.skills.push({skill: Skills.SWORDS_DANCE, level: 54});
Races.TAUROS.skills.push({skill: Skills.TACKLE, level: 1});
Races.TAUROS.skills.push({skill: Skills.STOMP, level: 21});
Races.TAUROS.skills.push({skill: Skills.TAIL_WHIP, level: 28});
Races.TAUROS.skills.push({skill: Skills.LEER, level: 35});
Races.TAUROS.skills.push({skill: Skills.RAGE, level: 44});
Races.TAUROS.skills.push({skill: Skills.TAKE_DOWN, level: 51});
Races.MAGIKARP.skills.push({skill: Skills.SPLASH, level: 1});
Races.MAGIKARP.skills.push({skill: Skills.TACKLE, level: 15});
Races.GYARADOS.skills.push({skill: Skills.BITE, level: 20});
Races.GYARADOS.skills.push({skill: Skills.DRAGON_RAGE, level: 25});
Races.GYARADOS.skills.push({skill: Skills.LEER, level: 32});
Races.GYARADOS.skills.push({skill: Skills.HYDRO_PUMP, level: 41});
Races.GYARADOS.skills.push({skill: Skills.HYPER_BEAM, level: 52});
Races.LAPRAS.skills.push({skill: Skills.WATER_GUN, level: 1});
Races.LAPRAS.skills.push({skill: Skills.GROWL, level: 1});
Races.LAPRAS.skills.push({skill: Skills.SING, level: 16});
Races.LAPRAS.skills.push({skill: Skills.MIST, level: 20});
Races.LAPRAS.skills.push({skill: Skills.BODY_SLAM, level: 25});
Races.LAPRAS.skills.push({skill: Skills.CONFUSE_RAY, level: 31});
Races.LAPRAS.skills.push({skill: Skills.ICE_BEAM, level: 38});
Races.LAPRAS.skills.push({skill: Skills.HYDRO_PUMP, level: 46});
Races.DITTO.skills.push({skill: Skills.TRANSFORM, level: 1});
Races.EEVEE.skills.push({skill: Skills.TACKLE, level: 1});
Races.EEVEE.skills.push({skill: Skills.SAND_ATTACK, level: 1});
Races.EEVEE.skills.push({skill: Skills.QUICK_ATTACK, level: 27});
Races.EEVEE.skills.push({skill: Skills.TAIL_WHIP, level: 31});
Races.EEVEE.skills.push({skill: Skills.BITE, level: 37});
Races.EEVEE.skills.push({skill: Skills.TAKE_DOWN, level: 45});
Races.VAPOREON.skills.push({skill: Skills.QUICK_ATTACK, level: 27});
Races.VAPOREON.skills.push({skill: Skills.WATER_GUN, level: 31});
Races.VAPOREON.skills.push({skill: Skills.TAIL_WHIP, level: 37});
Races.VAPOREON.skills.push({skill: Skills.BITE, level: 40});
Races.VAPOREON.skills.push({skill: Skills.ACID_ARMOR, level: 42});
Races.VAPOREON.skills.push({skill: Skills.HAZE, level: 44});
Races.VAPOREON.skills.push({skill: Skills.MIST, level: 48});
Races.VAPOREON.skills.push({skill: Skills.HYDRO_PUMP, level: 54});
Races.JOLTEON.skills.push({skill: Skills.QUICK_ATTACK, level: 27});
Races.JOLTEON.skills.push({skill: Skills.THUNDER_SHOCK, level: 31});
Races.JOLTEON.skills.push({skill: Skills.TAIL_WHIP, level: 37});
Races.JOLTEON.skills.push({skill: Skills.THUNDER_WAVE, level: 40});
Races.JOLTEON.skills.push({skill: Skills.DOUBLE_KICK, level: 42});
Races.JOLTEON.skills.push({skill: Skills.AGILITY, level: 44});
Races.JOLTEON.skills.push({skill: Skills.PIN_MISSILE, level: 48});
Races.JOLTEON.skills.push({skill: Skills.THUNDER, level: 54});
Races.FLAREON.skills.push({skill: Skills.QUICK_ATTACK, level: 27});
Races.FLAREON.skills.push({skill: Skills.EMBER, level: 31});
Races.FLAREON.skills.push({skill: Skills.TAIL_WHIP, level: 37});
Races.FLAREON.skills.push({skill: Skills.BITE, level: 40});
Races.FLAREON.skills.push({skill: Skills.LEER, level: 42});
Races.FLAREON.skills.push({skill: Skills.FIRE_SPIN, level: 44});
Races.FLAREON.skills.push({skill: Skills.RAGE, level: 48});
Races.FLAREON.skills.push({skill: Skills.FLAMETHROWER, level: 54});
Races.PORYGON.skills.push({skill: Skills.TACKLE, level: 1});
Races.PORYGON.skills.push({skill: Skills.SHARPEN, level: 1});
Races.PORYGON.skills.push({skill: Skills.CONVERSION, level: 1});
Races.PORYGON.skills.push({skill: Skills.PSYBEAM, level: 23});
Races.PORYGON.skills.push({skill: Skills.RECOVER, level: 28});
Races.PORYGON.skills.push({skill: Skills.AGILITY, level: 35});
Races.PORYGON.skills.push({skill: Skills.TRI_ATTACK, level: 42});
Races.OMANYTE.skills.push({skill: Skills.WATER_GUN, level: 1});
Races.OMANYTE.skills.push({skill: Skills.WITHDRAW, level: 1});
Races.OMANYTE.skills.push({skill: Skills.HORN_ATTACK, level: 34});
Races.OMANYTE.skills.push({skill: Skills.LEER, level: 39});
Races.OMANYTE.skills.push({skill: Skills.SPIKE_CANNON, level: 46});
Races.OMANYTE.skills.push({skill: Skills.HYDRO_PUMP, level: 53});
Races.OMASTAR.skills.push({skill: Skills.SPIKE_CANNON, level: 44});
Races.OMASTAR.skills.push({skill: Skills.HYDRO_PUMP, level: 49});
Races.KABUTO.skills.push({skill: Skills.SCRATCH, level: 1});
Races.KABUTO.skills.push({skill: Skills.HARDEN, level: 1});
Races.KABUTO.skills.push({skill: Skills.ABSORB, level: 34});
Races.KABUTO.skills.push({skill: Skills.SLASH, level: 39});
Races.KABUTO.skills.push({skill: Skills.LEER, level: 44});
Races.KABUTO.skills.push({skill: Skills.HYDRO_PUMP, level: 49});
Races.KABUTOPS.skills.push({skill: Skills.LEER, level: 46});
Races.KABUTOPS.skills.push({skill: Skills.HYDRO_PUMP, level: 53});
Races.AERODACTYL.skills.push({skill: Skills.WING_ATTACK, level: 1});
Races.AERODACTYL.skills.push({skill: Skills.AGILITY, level: 1});
Races.AERODACTYL.skills.push({skill: Skills.SUPERSONIC, level: 33});
Races.AERODACTYL.skills.push({skill: Skills.BITE, level: 38});
Races.AERODACTYL.skills.push({skill: Skills.TAKE_DOWN, level: 45});
Races.AERODACTYL.skills.push({skill: Skills.HYPER_BEAM, level: 54});
Races.SNORLAX.skills.push({skill: Skills.HEADBUTT, level: 1});
Races.SNORLAX.skills.push({skill: Skills.AMNESIA, level: 1});
Races.SNORLAX.skills.push({skill: Skills.REST, level: 1});
Races.SNORLAX.skills.push({skill: Skills.BODY_SLAM, level: 35});
Races.SNORLAX.skills.push({skill: Skills.HARDEN, level: 41});
Races.SNORLAX.skills.push({skill: Skills.DOUBLE_EDGE, level: 48});
Races.SNORLAX.skills.push({skill: Skills.HYPER_BEAM, level: 56});
Races.ARTICUNO.skills.push({skill: Skills.PECK, level: 1});
Races.ARTICUNO.skills.push({skill: Skills.ICE_BEAM, level: 1});
Races.ARTICUNO.skills.push({skill: Skills.BLIZZARD, level: 51});
Races.ARTICUNO.skills.push({skill: Skills.AGILITY, level: 55});
Races.ARTICUNO.skills.push({skill: Skills.MIST, level: 60});
Races.ZAPDOS.skills.push({skill: Skills.THUNDER_SHOCK, level: 1});
Races.ZAPDOS.skills.push({skill: Skills.DRILL_PECK, level: 1});
Races.ZAPDOS.skills.push({skill: Skills.THUNDER, level: 51});
Races.ZAPDOS.skills.push({skill: Skills.AGILITY, level: 55});
Races.ZAPDOS.skills.push({skill: Skills.LIGHT_SCREEN, level: 60});
Races.MOLTRES.skills.push({skill: Skills.PECK, level: 1});
Races.MOLTRES.skills.push({skill: Skills.FIRE_SPIN, level: 1});
Races.MOLTRES.skills.push({skill: Skills.LEER, level: 51});
Races.MOLTRES.skills.push({skill: Skills.AGILITY, level: 55});
Races.MOLTRES.skills.push({skill: Skills.SKY_ATTACK, level: 60});
Races.DRATINI.skills.push({skill: Skills.WRAP, level: 1});
Races.DRATINI.skills.push({skill: Skills.LEER, level: 1});
Races.DRATINI.skills.push({skill: Skills.THUNDER_WAVE, level: 10});
Races.DRATINI.skills.push({skill: Skills.AGILITY, level: 20});
Races.DRATINI.skills.push({skill: Skills.SLAM, level: 30});
Races.DRATINI.skills.push({skill: Skills.DRAGON_RAGE, level: 40});
Races.DRATINI.skills.push({skill: Skills.HYPER_BEAM, level: 50});
Races.DRAGONAIR.skills.push({skill: Skills.SLAM, level: 35});
Races.DRAGONAIR.skills.push({skill: Skills.DRAGON_RAGE, level: 45});
Races.DRAGONAIR.skills.push({skill: Skills.HYPER_BEAM, level: 55});
Races.DRAGONITE.skills.push({skill: Skills.HYPER_BEAM, level: 60});
Races.MEWTWO.skills.push({skill: Skills.CONFUSION, level: 1});
Races.MEWTWO.skills.push({skill: Skills.DISABLE, level: 1});
Races.MEWTWO.skills.push({skill: Skills.SWIFT, level: 1});
Races.MEWTWO.skills.push({skill: Skills.BARRIER, level: 63});
Races.MEWTWO.skills.push({skill: Skills.PSYCHIC, level: 66});
Races.MEWTWO.skills.push({skill: Skills.RECOVER, level: 70});
Races.MEWTWO.skills.push({skill: Skills.MIST, level: 75});
Races.MEWTWO.skills.push({skill: Skills.AMNESIA, level: 81});
Races.MEW.skills.push({skill: Skills.POUND, level: 1});
Races.MEW.skills.push({skill: Skills.TRANSFORM, level: 10});
Races.MEW.skills.push({skill: Skills.MEGA_PUNCH, level: 20});
Races.MEW.skills.push({skill: Skills.METRONOME, level: 30});
Races.MEW.skills.push({skill: Skills.PSYCHIC, level: 40});

Races.BULBASAUR.setMainEvolution(16, Races.IVYSAUR); 
Races.IVYSAUR.setMainEvolution(32, Races.VENUSAUR); 

Races.CHARMANDER.setMainEvolution(16, Races.CHARMELEON); 
Races.CHARMELEON.setMainEvolution(36, Races.CHARIZARD); 

Races.SQUIRTLE.setMainEvolution(16, Races.WARTORTLE); 
Races.WARTORTLE.setMainEvolution(36, Races.BLASTOISE); 

Races.CATERPIE.setMainEvolution(7, Races.METAPOD); 
Races.METAPOD.setMainEvolution(10, Races.BUTERFREE); 

Races.WEEDLE.setMainEvolution(7, Races.KAKUNA); 
Races.KAKUNA.setMainEvolution(10, Races.BEEDRILL); 

Races.PIDGEY.setMainEvolution(18, Races.PIDGEOTTO); 
Races.PIDGEOTTO.setMainEvolution(36, Races.PIDGEOT); 

Races.RATTATA.setMainEvolution(20, Races.RATICATE); 

Races.SPEAROW.setMainEvolution(20, Races.FEAROW); 

Races.EKANS.setMainEvolution(22, Races.ARBOK); 



Races.SANDSHREW.setMainEvolution(22, Races.SANDSLASH); 

Races.NIDORAN_F.setMainEvolution(16, Races.NIDORINA); 


Races.NIDORAN_M.setMainEvolution(16, Races.NIDORINO); 








Races.ZUBAT.setMainEvolution(22, Races.GOLBAT); 

Races.ODDISH.setMainEvolution(21, Races.GLOOM); 


Races.PARAS.setMainEvolution(24, Races.PARASECT); 

Races.VENONAT.setMainEvolution(31, Races.VENOMOTH); 

Races.DIGLETT.setMainEvolution(26, Races.DUGTRIO); 

Races.MEOWTH.setMainEvolution(28, Races.PERSIAN); 

Races.PSYDUCK.setMainEvolution(33, Races.GOLDUCK); 

Races.MANKEY.setMainEvolution(28, Races.PRIMEAPE); 



Races.POLIWAG.setMainEvolution(25, Races.POLIWHIRL); 


Races.ABRA.setMainEvolution(16, Races.KADABRA); 


Races.MACHOP.setMainEvolution(28, Races.MACHOKE); 


Races.BELLSPROUT.setMainEvolution(21, Races.WEEPINBELL); 


Races.TENTACOOL.setMainEvolution(30, Races.TENTACRUEL); 

Races.GEODUDE.setMainEvolution(25, Races.GRAVELER); 


Races.PONYTA.setMainEvolution(40, Races.RAPIDASH); 

Races.SLOWPOKE.setMainEvolution(37, Races.SLOWBRO); 

Races.MAGNEMITE.setMainEvolution(30, Races.MAGNETON); 


Races.DODUO.setMainEvolution(31, Races.DODRIO); 

Races.SEEL.setMainEvolution(34, Races.DEWGONG); 

Races.GRIMER.setMainEvolution(38, Races.MUK); 



Races.GASTLY.setMainEvolution(25, Races.HAUNTER); 



Races.DROWZEE.setMainEvolution(26, Races.HYPNO); 

Races.KRABBY.setMainEvolution(28, Races.KINGLER); 

Races.VOLTORB.setMainEvolution(30, Races.ELECTRODE); 



Races.CUBONE.setMainEvolution(28, Races.MAROWAK); 




Races.KOFFING.setMainEvolution(35, Races.WEEZING); 

Races.RHYHORN.setMainEvolution(42, Races.RHYDON); 




Races.HORSEA.setMainEvolution(32, Races.SEADRA); 

Races.GOLDEEN.setMainEvolution(33, Races.SEAKING); 










Races.MAGIKARP.setMainEvolution(20, Races.GYARADOS); 








Races.OMANYTE.setMainEvolution(40, Races.OMASTAR); 

Races.KABUTO.setMainEvolution(40, Races.KABUTOPS); 






Races.DRATINI.setMainEvolution(30, Races.DRAGONAIR); 
Races.DRAGONAIR.setMainEvolution(55, Races.DRAGONITE); 


Races.RAICHU.setStoneEvolution("THUNDER_STONE", Races.PIKACHU); 
Races.NIDOQUEEN.setStoneEvolution("MOON_STONE", Races.NIDORINA); 
Races.NIDOKING.setStoneEvolution("MOON_STONE", Races.NIDORINO); 
Races.CLEFABLE.setStoneEvolution("MOON_STONE", Races.CLEFAIRY); 
Races.NINETALES.setStoneEvolution("FIRE_STONE", Races.VULPIX); 
Races.WIGGLYTUFF.setStoneEvolution("MOON_STONE", Races.JIGGLYPUFF); 
Races.VILEPLUME.setStoneEvolution("LEAF_STONE", Races.GLOOM); 
Races.ARCANINE.setStoneEvolution("FIRE_STONE", Races.GROWLITHE); 
Races.POLIWRATH.setStoneEvolution("WATER_STONE", Races.POLIWHIRL); 
Races.VICTREEBEL.setStoneEvolution("LEAF_STONE", Races.WEEPINBELL); 
Races.CLOYSTER.setStoneEvolution("WATER_STONE", Races.SHELLDER); 
Races.EXEGGUTOR.setStoneEvolution("LEAF_STONE", Races.EXEGGCUTE); 
Races.STARMIE.setStoneEvolution("WATER_STONE", Races.STARYU); 
Races.VAPOREON.setStoneEvolution("WATER_STONE", Races.EEVEE); 
Races.JOLTEON.setStoneEvolution("THUNDER_STONE", Races.EEVEE); 
Races.FLAREON.setStoneEvolution("FIRE_STONE", Races.EEVEE); 

Races.ALAKAZAM.setStoneEvolution("TRADING", Races.KADABRA); 
Races.MACHAMP.setStoneEvolution("TRADING", Races.MACHOKE); 
Races.GOLEM.setStoneEvolution("TRADING", Races.GRAVELER); 
Races.GENGAR.setStoneEvolution("TRADING", Races.HAUNTER); 


module.exports = Races;

},{"./Race.class":28,"./Skills.enum":30,"./Types.enum":33}],30:[function(require,module,exports){
var Types = require('./Types.enum');
var Effects = require('./Effects.enum');
var Stats = require('./Stats.enum');
var Status = require('./Status.enum');

module.exports = {
MIMIC: {name: 'Mimic', type: Types.NORMAL, power: 0, accuracy: 0, effect: Effects.COPY_MOVE, pp: 10, damagetype: 'STAT', params: {}},
MIRROR_MOVE: {name: 'Mirror Move', type: Types.FLYING, power: 0, accuracy: 0, effect: Effects.COPY_MOVE, pp: 20, damagetype: 'STAT', params: {}},
CONVERSION: {name: 'Conversion', type: Types.NORMAL, power: 0, accuracy: 0, effect: Effects.COPY_TYPE, pp: 30, damagetype: 'STAT', params: {}},
SUBSTITUTE: {name: 'Substitute', type: Types.NORMAL, power: 0, accuracy: 0, effect: Effects.CREATE_DECOY, pp: 10, damagetype: 'STAT', params: {}},
BARRAGE: {name: 'Barrage', type: Types.NORMAL, power: 15, accuracy: 85, effect: Effects.DAMAGE, pp: 20, damagetype: 'PHYS', params: {multihit: 5}},
BIND: {name: 'Bind', type: Types.NORMAL, power: 15, accuracy: 85, effect: Effects.DAMAGE, pp: 20, damagetype: 'PHYS', params: {multihit: 5, trap: true}},
BITE: {name: 'Bite', type: Types.NORMAL, power: 60, accuracy: 100, effect: Effects.DAMAGE, pp: 25, damagetype: 'PHYS', params: {flinchChance: 10}},
BODY_SLAM: {name: 'Body Slam', type: Types.NORMAL, power: 85, accuracy: 100, effect: Effects.DAMAGE, pp: 15, damagetype: 'PHYS', range: 2, params: {assault: true, paralyzeChance: 30}},
BONE_CLUB: {name: 'Bone Club', type: Types.GROUND, power: 65, accuracy: 85, effect: Effects.DAMAGE, pp: 20, damagetype: 'PHYS', params: {flinchChance: 10}},
BONEMERANG: {name: 'Bonemerang', type: Types.GROUND, power: 50, accuracy: 90, effect: Effects.DAMAGE, pp: 10, damagetype: 'PHYS', range: 3, params: {multihit: 2}},
CLAMP: {name: 'Clamp', type: Types.WATER, power: 35, accuracy: 85, effect: Effects.DAMAGE, pp: 10, damagetype: 'PHYS', params: {multihit: 5, trap: true}},
COMET_PUNCH: {name: 'Comet Punch', type: Types.NORMAL, power: 18, accuracy: 85, effect: Effects.DAMAGE, pp: 15, damagetype: 'PHYS', params: {multihit: 5}},
CONSTRICT: {name: 'Constrict', type: Types.NORMAL, power: 10, accuracy: 100, effect: Effects.DAMAGE, pp: 35, damagetype: 'PHYS', params: {lowerChance: 10, lowerStat: Stats.SPD}},
CRABHAMMER: {name: 'Crabhammer', type: Types.WATER, power: 100, accuracy: 90, effect: Effects.DAMAGE, pp: 10, damagetype: 'PHYS', params: {critBoost: true}},
CUT: {name: 'Cut', type: Types.NORMAL, power: 50, accuracy: 95, effect: Effects.DAMAGE, pp: 30, damagetype: 'PHYS', params: {}},
DIZZY_PUNCH: {name: 'Dizzy Punch', type: Types.NORMAL, power: 70, accuracy: 100, effect: Effects.DAMAGE, pp: 10, damagetype: 'PHYS', params: {}},
DOUBLE_KICK: {name: 'Double Kick', type: Types.FIGHTING, power: 30, accuracy: 100, effect: Effects.DAMAGE, pp: 30, damagetype: 'PHYS', params: {multihit: 2}},
DOUBLE_SLAP: {name: 'Double Slap', type: Types.NORMAL, power: 15, accuracy: 85, effect: Effects.DAMAGE, pp: 10, damagetype: 'PHYS', params: {multihit: 5}},
DOUBLE_EDGE: {name: 'Double-Edge', type: Types.NORMAL, power: 120, accuracy: 100, effect: Effects.DAMAGE, pp: 15, damagetype: 'PHYS', params: {recoil: 25}},
DRILL_PECK: {name: 'Drill Peck', type: Types.FLYING, power: 80, accuracy: 100, effect: Effects.DAMAGE, pp: 20, damagetype: 'PHYS', params: {}},
EARTHQUAKE: {name: 'Earthquake', type: Types.GROUND, power: 100, accuracy: 100, effect: Effects.DAMAGE, pp: 10, damagetype: 'PHYS', range: 5, params: {undergroundBonus: 2, splashRange: 4}},
EGG_BOMB: {name: 'Egg Bomb', type: Types.NORMAL, power: 100, accuracy: 75, effect: Effects.DAMAGE, pp: 10, damagetype: 'PHYS', range: 3, params: {}},
EXPLOSION: {name: 'Explosion', type: Types.NORMAL, power: 250, accuracy: 100, effect: Effects.DAMAGE, pp: 5, damagetype: 'PHYS', params: {suicide: true, splashRange: 3}},
FIRE_PUNCH: {name: 'Fire Punch', type: Types.FIRE, power: 75, accuracy: 100, effect: Effects.DAMAGE, pp: 15, damagetype: 'PHYS', params: {burnChance: 10}},
FURY_ATTACK: {name: 'Fury Attack', type: Types.NORMAL, power: 15, accuracy: 85, effect: Effects.DAMAGE, pp: 20, damagetype: 'PHYS', params: {multihit: 5}},
FURY_SWIPES: {name: 'Fury Swipes', type: Types.NORMAL, power: 18, accuracy: 80, effect: Effects.DAMAGE, pp: 15, damagetype: 'PHYS', params: {multihit: 5}},
HEADBUTT: {name: 'Headbutt', type: Types.NORMAL, power: 70, accuracy: 100, effect: Effects.DAMAGE, pp: 15, damagetype: 'PHYS', params: {flinchChance: 30}},
HIGH_JUMP_KICK: {name: 'High Jump Kick', type: Types.FIGHTING, power: 130, accuracy: 90, effect: Effects.DAMAGE, pp: 10, damagetype: 'PHYS', range: 2, params: {damageOnMiss: 1}},
HORN_ATTACK: {name: 'Horn Attack', type: Types.NORMAL, power: 65, accuracy: 100, effect: Effects.DAMAGE, pp: 25, damagetype: 'PHYS', params: {}},
HYPER_FANG: {name: 'Hyper Fang', type: Types.NORMAL, power: 80, accuracy: 90, effect: Effects.DAMAGE, pp: 15, damagetype: 'PHYS', params: {flinchChance: 10}},
ICE_PUNCH: {name: 'Ice Punch', type: Types.ICE, power: 75, accuracy: 100, effect: Effects.DAMAGE, pp: 15, damagetype: 'PHYS', params: {freezeChance: 10}},
JUMP_KICK: {name: 'Jump Kick', type: Types.FIGHTING, power: 100, accuracy: 95, effect: Effects.DAMAGE, pp: 10, damagetype: 'PHYS', range: 2, params: {damageOnMiss: 1}},
KARATE_CHOP: {name: 'Karate Chop', type: Types.FIGHTING, power: 50, accuracy: 100, effect: Effects.DAMAGE, pp: 25, damagetype: 'PHYS', params: {critBoost: true}},
LEECH_LIFE: {name: 'Leech Life', type: Types.BUG, power: 80, accuracy: 100, effect: Effects.DAMAGE, pp: 10, damagetype: 'PHYS', params: {absorbHPPercentage: 50}},
LICK: {name: 'Lick', type: Types.GHOST, power: 30, accuracy: 100, effect: Effects.DAMAGE, pp: 30, damagetype: 'PHYS', params: {paralyzeChance: 30}},
LOW_KICK: {name: 'Low Kick', type: Types.FIGHTING, power: 50, accuracy: 90, effect: Effects.DAMAGE, pp: 20, damagetype: 'PHYS', params: {flinchChance: 30}},
MEGA_KICK: {name: 'Mega Kick', type: Types.NORMAL, power: 120, accuracy: 75, effect: Effects.DAMAGE, pp: 5, damagetype: 'PHYS', params: {}},
MEGA_PUNCH: {name: 'Mega Punch', type: Types.NORMAL, power: 80, accuracy: 85, effect: Effects.DAMAGE, pp: 20, damagetype: 'PHYS', params: {}},
PAY_DAY: {name: 'Pay Day', type: Types.NORMAL, power: 40, accuracy: 100, effect: Effects.DAMAGE, pp: 20, damagetype: 'PHYS', params: {dropCoins: true}},
PECK: {name: 'Peck', type: Types.FLYING, power: 35, accuracy: 100, effect: Effects.DAMAGE, pp: 35, damagetype: 'PHYS', params: {}},
PIN_MISSILE: {name: 'Pin Missile', type: Types.BUG, power: 25, accuracy: 95, effect: Effects.DAMAGE, pp: 20, damagetype: 'PHYS', range: 3, params: {multihit: 5}},
POISON_STING: {name: 'Poison Sting', type: Types.POISON, power: 15, accuracy: 100, effect: Effects.DAMAGE, pp: 35, damagetype: 'PHYS', range: 2, params: {poisonChance: 30}},
POUND: {name: 'Pound', type: Types.NORMAL, power: 40, accuracy: 100, effect: Effects.DAMAGE, pp: 35, damagetype: 'PHYS', params: {}},
QUICK_ATTACK: {name: 'Quick Attack', type: Types.NORMAL, power: 40, accuracy: 100, effect: Effects.DAMAGE, pp: 30, damagetype: 'PHYS', range: 2, params: {assault: true}},
RAGE: {name: 'Rage', type: Types.NORMAL, power: 20, accuracy: 100, effect: Effects.DAMAGE, pp: 20, damagetype: 'PHYS', params: {rageTurns: 50, raiseAttackWhileRaging: true}},
RAZOR_LEAF: {name: 'Razor Leaf', type: Types.GRASS, power: 55, accuracy: 95, effect: Effects.DAMAGE, pp: 25, damagetype: 'PHYS', range: 3, params: {critBoost: true, splashRange: 2}},
ROCK_SLIDE: {name: 'Rock Slide', type: Types.ROCK, power: 75, accuracy: 90, effect: Effects.DAMAGE, pp: 10, damagetype: 'PHYS', range: 2, params: {}},
ROCK_THROW: {name: 'Rock Throw', type: Types.ROCK, power: 50, accuracy: 90, effect: Effects.DAMAGE, pp: 15, damagetype: 'PHYS', range: 3, params: {}},
ROLLING_KICK: {name: 'Rolling Kick', type: Types.FIGHTING, power: 60, accuracy: 85, effect: Effects.DAMAGE, pp: 15, damagetype: 'PHYS', range: 2, params: {flinchChance: 30}},
SCRATCH: {name: 'Scratch', type: Types.NORMAL, power: 40, accuracy: 100, effect: Effects.DAMAGE, pp: 35, damagetype: 'PHYS', params: {}},
SEISMIC_TOSS: {name: 'Seismic Toss', type: Types.FIGHTING, power: 0, accuracy: 100, effect: Effects.DAMAGE, pp: 20, damagetype: 'PHYS', params: { fixedDamage: "Level"}},
SELF_DESTRUCT: {name: 'Self-Destruct', type: Types.NORMAL, power: 200, accuracy: 100, effect: Effects.DAMAGE, pp: 5, damagetype: 'PHYS', params: {suicide: true}},
SKULL_BASH: {name: 'Skull Bash', type: Types.NORMAL, power: 130, accuracy: 100, effect: Effects.DAMAGE, pp: 10, damagetype: 'PHYS', params: { buildUpTurns: 1 }},
SKY_ATTACK: {name: 'Sky Attack', type: Types.FLYING, power: 140, accuracy: 90, effect: Effects.DAMAGE, pp: 5, damagetype: 'PHYS', range: 3, params: { buildUpTurns: 1 }},
SLAM: {name: 'Slam', type: Types.NORMAL, power: 80, accuracy: 75, effect: Effects.DAMAGE, pp: 20, damagetype: 'PHYS', params: {}},
SLASH: {name: 'Slash', type: Types.NORMAL, power: 70, accuracy: 100, effect: Effects.DAMAGE, pp: 20, damagetype: 'PHYS', params: {critBoost: true}},
SPIKE_CANNON: {name: 'Spike Cannon', type: Types.NORMAL, power: 20, accuracy: 100, effect: Effects.DAMAGE, pp: 15, damagetype: 'PHYS', range: 3, params: {multihit: 5}},
STOMP: {name: 'Stomp', type: Types.NORMAL, power: 65, accuracy: 100, effect: Effects.DAMAGE, pp: 20, damagetype: 'PHYS', params: {flinchChance: 30}},
STRENGTH: {name: 'Strength', type: Types.NORMAL, power: 80, accuracy: 100, effect: Effects.DAMAGE, pp: 15, damagetype: 'PHYS', params: {}},
STRUGGLE: {name: 'Struggle', type: Types.NORMAL, power: 50, accuracy: 100, effect: Effects.DAMAGE, pp: 0, damagetype: 'PHYS', params: {recoil: 50}},
SUBMISSION: {name: 'Submission', type: Types.FIGHTING, power: 80, accuracy: 80, effect: Effects.DAMAGE, pp: 20, damagetype: 'PHYS', params: {}},
SUPER_FANG: {name: 'Super Fang', type: Types.NORMAL, power: 0, accuracy: 90, effect: Effects.DAMAGE, pp: 10, damagetype: 'PHYS', params: {fixedDamagePercentage: 50}},
TACKLE: {name: 'Tackle', type: Types.NORMAL, power: 40, accuracy: 100, effect: Effects.DAMAGE, pp: 35, damagetype: 'PHYS', params: {}},
TAKE_DOWN: {name: 'Take Down', type: Types.NORMAL, power: 90, accuracy: 85, effect: Effects.DAMAGE, pp: 20, damagetype: 'PHYS', params: {recoil: 25}},
THRASH: {name: 'Thrash', type: Types.NORMAL, power: 120, accuracy: 100, effect: Effects.DAMAGE, pp: 10, damagetype: 'PHYS', params: {rageTurns: 3}},
THUNDER_PUNCH: {name: 'Thunder Punch', type: Types.ELECTRIC, power: 75, accuracy: 100, effect: Effects.DAMAGE, pp: 15, damagetype: 'PHYS', params: {paralyzeChance: 10}},
TWINEEDLE: {name: 'Twineedle', type: Types.BUG, power: 25, accuracy: 100, effect: Effects.DAMAGE, pp: 20, damagetype: 'PHYS', params: {multihit: 2, poisonChance: 20}},
VICE_GRIP: {name: 'Vice Grip', type: Types.NORMAL, power: 55, accuracy: 100, effect: Effects.DAMAGE, pp: 30, damagetype: 'PHYS', params: {}},
VINE_WHIP: {name: 'Vine Whip', type: Types.GRASS, power: 45, accuracy: 100, effect: Effects.DAMAGE, pp: 25, damagetype: 'PHYS', params: {}},
WATERFALL: {name: 'Waterfall', type: Types.WATER, power: 80, accuracy: 100, effect: Effects.DAMAGE, pp: 15, damagetype: 'PHYS', params: {}},
WING_ATTACK: {name: 'Wing Attack', type: Types.FLYING, power: 60, accuracy: 100, effect: Effects.DAMAGE, pp: 35, damagetype: 'PHYS', params: {}},
WRAP: {name: 'Wrap', type: Types.NORMAL, power: 15, accuracy: 90, effect: Effects.DAMAGE, pp: 20, damagetype: 'PHYS', params: {multihit: 5, trap: true}},
ABSORB: {name: 'Absorb', type: Types.GRASS, power: 20, accuracy: 100, effect: Effects.DAMAGE, pp: 25, damagetype: 'SPEC', params: {absorbHPPercentage: 50}},
ACID: {name: 'Acid', type: Types.POISON, power: 40, accuracy: 100, effect: Effects.DAMAGE, pp: 30, damagetype: 'SPEC', range: 2, params: {lowerChance: 10, lowerStat: Stats.DEF, splashRange: 2}},
AURORA_BEAM: {name: 'Aurora Beam', type: Types.ICE, power: 65, accuracy: 100, effect: Effects.DAMAGE, pp: 20, damagetype: 'SPEC', range: 5, params: {lowerChance: 10, lowerStat: Stats.ATK}},
BLIZZARD: {name: 'Blizzard', type: Types.ICE, power: 110, accuracy: 70, effect: Effects.DAMAGE, pp: 5, damagetype: 'SPEC', range: 5, params: {freezeChance: 10}},
BUBBLE: {name: 'Bubble', type: Types.WATER, power: 40, accuracy: 100, effect: Effects.DAMAGE, pp: 30, damagetype: 'SPEC', range: 2, params: {lowerChance: 10, lowerStat: Stats.SPD, splashRange: 2}},
BUBBLE_BEAM: {name: 'Bubble Beam', type: Types.WATER, power: 65, accuracy: 100, effect: Effects.DAMAGE, pp: 20, damagetype: 'SPEC', range: 4, params: {lowerChance: 10, lowerStat: Stats.SPD}},
CONFUSION: {name: 'Confusion', type: Types.PSYCHIC, power: 50, accuracy: 100, effect: Effects.DAMAGE, pp: 25, damagetype: 'SPEC', params: {confuseChance: 10}},
DRAGON_RAGE: {name: 'Dragon Rage', type: Types.DRAGON, power: 0, accuracy: 100, effect: Effects.DAMAGE, pp: 10, damagetype: 'SPEC', range: 3, params: {fixedDamage: 40}},
DREAM_EATER: {name: 'Dream Eater', type: Types.PSYCHIC, power: 100, accuracy: 100, effect: Effects.DAMAGE, pp: 15, damagetype: 'SPEC', range: 3, params: {requireStatus: "SLEEP", absorbHPPercentage: 50}},
EMBER: {name: 'Ember', type: Types.FIRE, power: 40, accuracy: 100, effect: Effects.DAMAGE, pp: 25, damagetype: 'SPEC', range: 2, params: {burnChance: 10}},
FIRE_BLAST: {name: 'Fire Blast', type: Types.FIRE, power: 110, accuracy: 85, effect: Effects.DAMAGE, pp: 5, damagetype: 'SPEC', range: 4, params: {burnChance: 30}},
FIRE_SPIN: {name: 'Fire Spin', type: Types.FIRE, power: 35, accuracy: 85, effect: Effects.DAMAGE, pp: 15, damagetype: 'SPEC', range: 3, params: {multihit: 5, trap: true}},
FLAMETHROWER: {name: 'Flamethrower', type: Types.FIRE, power: 90, accuracy: 100, effect: Effects.DAMAGE, pp: 15, damagetype: 'SPEC', range: 3, params: {burnChance: 10}},
GUST: {name: 'Gust', type: Types.NORMAL, power: 40, accuracy: 100, effect: Effects.DAMAGE, pp: 35, damagetype: 'SPEC', range: 2, params: {}},
HYDRO_PUMP: {name: 'Hydro Pump', type: Types.WATER, power: 110, accuracy: 80, effect: Effects.DAMAGE, pp: 5, damagetype: 'SPEC', range: 5, params: {}},
HYPER_BEAM: {name: 'Hyper Beam', type: Types.NORMAL, power: 150, accuracy: 90, effect: Effects.DAMAGE, pp: 5, damagetype: 'SPEC', range: 5, params: { recoverTurns: 1 }},
ICE_BEAM: {name: 'Ice Beam', type: Types.ICE, power: 90, accuracy: 100, effect: Effects.DAMAGE, pp: 10, damagetype: 'SPEC', range: 5, params: {freezeChance: 10}},
MEGA_DRAIN: {name: 'Mega Drain', type: Types.GRASS, power: 40, accuracy: 100, effect: Effects.DAMAGE, pp: 15, damagetype: 'SPEC', range: 2, params: {absorbHPPercentage: 50}},
NIGHT_SHADE: {name: 'Night Shade', type: Types.GHOST, power: 0, accuracy: 100, effect: Effects.DAMAGE, pp: 15, damagetype: 'SPEC', params: {fixedDamage: "Level"}},
PETAL_DANCE: {name: 'Petal Dance', type: Types.GRASS, power: 120, accuracy: 100, effect: Effects.DAMAGE, pp: 10, damagetype: 'SPEC', params: {multihit: 3, afterHits: "CONFUSED"}},
PSYBEAM: {name: 'Psybeam', type: Types.PSYCHIC, power: 65, accuracy: 100, effect: Effects.DAMAGE, pp: 20, damagetype: 'SPEC', range: 5, params: {confuseChance: 10}},
PSYCHIC: {name: 'Psychic', type: Types.PSYCHIC, power: 90, accuracy: 100, effect: Effects.DAMAGE, pp: 10, damagetype: 'SPEC', range: 2, params: {lowerChance: 33, lowerStat: Stats.SP_ATK}},
PSYWAVE: {name: 'Psywave', type: Types.PSYCHIC, power: 0, accuracy: 80, effect: Effects.DAMAGE, pp: 15, damagetype: 'SPEC', range: 2, params: {specialDamage: "psywave"}},
RAZOR_WIND: {name: 'Razor Wind', type: Types.NORMAL, power: 80, accuracy: 100, effect: Effects.DAMAGE, pp: 10, damagetype: 'SPEC', range: 2, params: {critBoost: true, buildUpTurns: 1}},
SLUDGE: {name: 'Sludge', type: Types.POISON, power: 65, accuracy: 100, effect: Effects.DAMAGE, pp: 20, damagetype: 'SPEC', range: 2, params: {poisonChance: 30}},
SMOG: {name: 'Smog', type: Types.POISON, power: 30, accuracy: 70, effect: Effects.DAMAGE, pp: 20, damagetype: 'SPEC', range: 3, params: {poisonChance: 40, splashRange: 2}},
SOLAR_BEAM: {name: 'Solar Beam', type: Types.GRASS, power: 120, accuracy: 100, effect: Effects.DAMAGE, pp: 10, damagetype: 'SPEC', range: 5, params: {buildUpTurns: 1}},
SONIC_BOOM: {name: 'Sonic Boom', type: Types.NORMAL, power: 0, accuracy: 90, effect: Effects.DAMAGE, pp: 20, damagetype: 'SPEC', range: 2, params: {fixedDamage: 20}},
SURF: {name: 'Surf', type: Types.WATER, power: 90, accuracy: 100, effect: Effects.DAMAGE, pp: 15, damagetype: 'SPEC', params: {splashRange: 3}},
SWIFT: {name: 'Swift', type: Types.NORMAL, power: 60, accuracy: 100, effect: Effects.DAMAGE, pp: 20, damagetype: 'SPEC', params: {alwaysHit: true}},
THUNDER: {name: 'Thunder', type: Types.ELECTRIC, power: 110, accuracy: 70, effect: Effects.DAMAGE, pp: 10, damagetype: 'SPEC', range: 5, params: {paralyzeChance: 10}},
THUNDER_SHOCK: {name: 'Thunder Shock', type: Types.ELECTRIC, power: 40, accuracy: 100, effect: Effects.DAMAGE, pp: 30, damagetype: 'SPEC', range: 2, params: {paralyzeChance: 10}},
THUNDERBOLT: {name: 'Thunderbolt', type: Types.ELECTRIC, power: 90, accuracy: 100, effect: Effects.DAMAGE, pp: 15, damagetype: 'SPEC', range: 4, params: {paralyzeChance: 10}},
TRI_ATTACK: {name: 'Tri Attack', type: Types.NORMAL, power: 80, accuracy: 100, effect: Effects.DAMAGE, pp: 10, damagetype: 'SPEC', params: {}},
WATER_GUN: {name: 'Water Gun', type: Types.WATER, power: 40, accuracy: 100, effect: Effects.DAMAGE, pp: 25, damagetype: 'SPEC', params: {}},
DIG: {name: 'Dig', type: Types.GROUND, power: 80, accuracy: 100, effect: Effects.DAMAGE, pp: 10, damagetype: 'PHYS', params: {hideTurns: 1}},
FLY: {name: 'Fly', type: Types.FLYING, power: 90, accuracy: 95, effect: Effects.DAMAGE, pp: 15, damagetype: 'PHYS', params: {hideTurns: 1}},
DISABLE: {name: 'Disable', type: Types.NORMAL, power: 0, accuracy: 100, effect: Effects.DISABLE_MOVE, pp: 20, damagetype: 'STAT', params: {}},
CONFUSE_RAY: {name: 'Confuse Ray', type: Types.GHOST, power: 0, accuracy: 100, effect: Effects.INFLICT_STATUS, pp: 10, damagetype: 'STAT', range: 5, params: {status: "CONFUSION"}},
GLARE: {name: 'Glare', type: Types.NORMAL, power: 0, accuracy: 100, effect: Effects.INFLICT_STATUS, pp: 30, damagetype: 'STAT', range: 4, params: {status: "PARALYSIS"}},
HYPNOSIS: {name: 'Hypnosis', type: Types.PSYCHIC, power: 0, accuracy: 60, effect: Effects.INFLICT_STATUS, pp: 20, damagetype: 'STAT', range: 3, params: {status: "SLEEP"}},
LOVELY_KISS: {name: 'Lovely Kiss', type: Types.NORMAL, power: 0, accuracy: 75, effect: Effects.INFLICT_STATUS, pp: 10, damagetype: 'STAT', range: 1, params: {status: "SLEEP"}},
POISON_GAS: {name: 'Poison Gas', type: Types.POISON, power: 0, accuracy: 90, effect: Effects.INFLICT_STATUS, pp: 40, damagetype: 'STAT', range: 2, params: {status: "POISON"}},
POISON_POWDER: {name: 'Poison Powder', type: Types.POISON, power: 0, accuracy: 75, effect: Effects.INFLICT_STATUS, pp: 35, damagetype: 'STAT', range: 1, params: {status: "POISON"}},
SING: {name: 'Sing', type: Types.NORMAL, power: 0, accuracy: 55, effect: Effects.INFLICT_STATUS, pp: 15, damagetype: 'STAT', range: 5, params: {status: "SLEEP"}},
SLEEP_POWDER: {name: 'Sleep Powder', type: Types.GRASS, power: 0, accuracy: 75, effect: Effects.INFLICT_STATUS, pp: 15, damagetype: 'STAT', range: 1, params: {status: "SLEEP"}},
SPORE: {name: 'Spore', type: Types.GRASS, power: 0, accuracy: 100, effect: Effects.INFLICT_STATUS, pp: 15, damagetype: 'STAT', range: 1, params: {status: "SLEEP"}},
STUN_SPORE: {name: 'Stun Spore', type: Types.GRASS, power: 0, accuracy: 75, effect: Effects.INFLICT_STATUS, pp: 30, damagetype: 'STAT', range: 1, params: {status: "PARALYSIS"}},
SUPERSONIC: {name: 'Supersonic', type: Types.NORMAL, power: 0, accuracy: 55, effect: Effects.INFLICT_STATUS, pp: 20, damagetype: 'STAT', range: 3, params: {status: "CONFUSION"}},
THUNDER_WAVE: {name: 'Thunder Wave', type: Types.ELECTRIC, power: 0, accuracy: 90, effect: Effects.INFLICT_STATUS, pp: 20, damagetype: 'STAT', range: 3, params: {status: "PARALYSIS"}},
TOXIC: {name: 'Toxic', type: Types.POISON, power: 0, accuracy: 90, effect: Effects.INFLICT_STATUS, pp: 10, damagetype: 'STAT', range: 2, params: {status: "BAD_POISON"}},
LEECH_SEED: {name: 'Leech Seed', type: Types.GRASS, power: 0, accuracy: 90, effect: Effects.INFLICT_STATUS, pp: 10, damagetype: 'STAT', range: 2, params: {status: "SEEDED"}},
FISSURE: {name: 'Fissure', type: Types.GROUND, power: 0, accuracy: 0, effect: Effects.KO, pp: 5, damagetype: 'PHYS', params: {}},
GUILLOTINE: {name: 'Guillotine', type: Types.NORMAL, power: 0, accuracy: 0, effect: Effects.KO, pp: 5, damagetype: 'PHYS', params: {}},
HORN_DRILL: {name: 'Horn Drill', type: Types.NORMAL, power: 0, accuracy: 0, effect: Effects.KO, pp: 5, damagetype: 'PHYS', params: {}},
FLASH: {name: 'Flash', type: Types.NORMAL, power: 0, accuracy: 100, effect: Effects.LOWER_STAT, pp: 20, damagetype: 'STAT', range: 4, params: {stat: "ACC"}},
GROWL: {name: 'Growl', type: Types.NORMAL, power: 0, accuracy: 100, effect: Effects.LOWER_STAT, pp: 40, damagetype: 'STAT', range: 4, params: {stat: "ATK"}},
KINESIS: {name: 'Kinesis', type: Types.PSYCHIC, power: 0, accuracy: 80, effect: Effects.LOWER_STAT, pp: 15, damagetype: 'STAT', range: 3, params: {stat: "ACC"}},
LEER: {name: 'Leer', type: Types.NORMAL, power: 0, accuracy: 100, effect: Effects.LOWER_STAT, pp: 30, damagetype: 'STAT', range: 4, params: {stat: "DEF"}},
SAND_ATTACK: {name: 'Sand Attack', type: Types.GROUND, power: 0, accuracy: 100, effect: Effects.LOWER_STAT, pp: 15, damagetype: 'STAT', range: 3, params: {stat: "ACC"}},
SCREECH: {name: 'Screech', type: Types.NORMAL, power: 0, accuracy: 85, effect: Effects.LOWER_STAT, pp: 40, damagetype: 'STAT', range: 4, params: {stat: "DEF", level: 2}},
SMOKESCREEN: {name: 'Smokescreen', type: Types.NORMAL, power: 0, accuracy: 100, effect: Effects.LOWER_STAT, pp: 20, damagetype: 'STAT', range: 3, params: {stat: "ACC"}},
STRING_SHOT: {name: 'String Shot', type: Types.BUG, power: 0, accuracy: 95, effect: Effects.LOWER_STAT, pp: 40, damagetype: 'STAT', range: 3, params: {stat: "SPD", level: 2}},
TAIL_WHIP: {name: 'Tail Whip', type: Types.NORMAL, power: 0, accuracy: 100, effect: Effects.LOWER_STAT, pp: 30, damagetype: 'STAT', range: 4, params: {stat: "DEF"}},
SPLASH: {name: 'Splash', type: Types.NORMAL, power: 0, accuracy: 0, effect: Effects.NOTHING, pp: 40, damagetype: 'STAT', params: {}},
DOUBLE_TEAM: {name: 'Double Team', type: Types.NORMAL, power: 0, accuracy: 0, effect: Effects.RAISE_STAT, pp: 15, damagetype: 'SPEC', params: {stat: "EVA"}},
ACID_ARMOR: {name: 'Acid Armor', type: Types.POISON, power: 0, accuracy: 0, effect: Effects.RAISE_STAT, pp: 20, damagetype: 'STAT', params: {stat: "DEF", level: 2}},
AGILITY: {name: 'Agility', type: Types.PSYCHIC, power: 0, accuracy: 0, effect: Effects.RAISE_STAT, pp: 30, damagetype: 'STAT', params: {stat: "SPD", level: 2}},
AMNESIA: {name: 'Amnesia', type: Types.PSYCHIC, power: 0, accuracy: 0, effect: Effects.RAISE_STAT, pp: 20, damagetype: 'STAT', params: {stat: "SP_DEF", level: 2}},
BARRIER: {name: 'Barrier', type: Types.PSYCHIC, power: 0, accuracy: 0, effect: Effects.RAISE_STAT, pp: 20, damagetype: 'STAT', params: {stat: "DEF", level: 2}},
DEFENSE_CURL: {name: 'Defense Curl', type: Types.NORMAL, power: 0, accuracy: 0, effect: Effects.RAISE_STAT, pp: 40, damagetype: 'STAT', params: {stat: "DEF"}},
FOCUS_ENERGY: {name: 'Focus Energy', type: Types.NORMAL, power: 0, accuracy: 0, effect: Effects.SET_STATUS, pp: 30, damagetype: 'STAT', params: {status: "FOCUSED"}},
GROWTH: {name: 'Growth', type: Types.NORMAL, power: 0, accuracy: 0, effect: Effects.RAISE_STAT, pp: 40, damagetype: 'STAT', params: {stat: "ATK"}},
HARDEN: {name: 'Harden', type: Types.NORMAL, power: 0, accuracy: 0, effect: Effects.RAISE_STAT, pp: 30, damagetype: 'STAT', params: {stat: "DEF"}},
MEDITATE: {name: 'Meditate', type: Types.PSYCHIC, power: 0, accuracy: 0, effect: Effects.RAISE_STAT, pp: 40, damagetype: 'STAT', params: {stat: "ATK"}},
MINIMIZE: {name: 'Minimize', type: Types.NORMAL, power: 0, accuracy: 0, effect: Effects.RAISE_STAT, pp: 10, damagetype: 'STAT', params: {stat: "DEF", level: 2}},
SHARPEN: {name: 'Sharpen', type: Types.NORMAL, power: 0, accuracy: 0, effect: Effects.RAISE_STAT, pp: 30, damagetype: 'STAT', params: {stat: "ATK"}},
SWORDS_DANCE: {name: 'Swords Dance', type: Types.NORMAL, power: 0, accuracy: 0, effect: Effects.RAISE_STAT, pp: 20, damagetype: 'STAT', params: {stat: "DEF", level: 2}},
WITHDRAW: {name: 'Withdraw', type: Types.WATER, power: 0, accuracy: 0, effect: Effects.RAISE_STAT, pp: 40, damagetype: 'STAT', params: {stat: "DEF"}},
METRONOME: {name: 'Metronome', type: Types.NORMAL, power: 0, accuracy: 0, effect: Effects.RANDOM_MOVE, pp: 10, damagetype: 'STAT', params: {}},
RECOVER: {name: 'Recover', type: Types.NORMAL, power: 0, accuracy: 0, effect: Effects.RECOVER_HP, pp: 10, damagetype: 'STAT', params: {proportion: 50}},
SOFT_BOILED: {name: 'Soft-Boiled', type: Types.NORMAL, power: 0, accuracy: 0, effect: Effects.RECOVER_HP, pp: 10, damagetype: 'STAT', params: {proportion: 50}},
HAZE: {name: 'Haze', type: Types.ICE, power: 0, accuracy: 0, effect: Effects.RESET_STATUS, pp: 30, damagetype: 'STAT', params: {}},
REST: {name: 'Rest', type: Types.PSYCHIC, power: 0, accuracy: 0, effect: Effects.SET_FLAG, pp: 10, damagetype: 'STAT', params: {flag: "RESTING", turns: 2}},
BIDE: {name: 'Bide', type: Types.NORMAL, power: 0, accuracy: 0, effect: Effects.SET_FLAG, pp: 10, damagetype: 'PHYS', params: {flag: "BIDE"}},
COUNTER: {name: 'Counter', type: Types.FIGHTING, power: 0, accuracy: 100, effect: Effects.SET_FLAG, pp: 20, damagetype: 'PHYS', params: {flag: "BIDE"}},
LIGHT_SCREEN: {name: 'Light Screen', type: Types.PSYCHIC, power: 0, accuracy: 0, effect: Effects.SET_FLAG, pp: 30, damagetype: 'STAT', params: {flag: "PROTECTED_SPATK", turns: 5}},
MIST: {name: 'Mist', type: Types.ICE, power: 0, accuracy: 0, effect: Effects.SET_FLAG, pp: 30, damagetype: 'STAT', params: {flag: "STATUS_NULL", turns: 2}},
REFLECT: {name: 'Reflect', type: Types.PSYCHIC, power: 0, accuracy: 0, effect: Effects.SET_FLAG, pp: 20, damagetype: 'STAT', params: {flag: "PROTECTED_ATK", turns: 5}},
TRANSFORM: {name: 'Transform', type: Types.NORMAL, power: 0, accuracy: 0, effect: Effects.TRANSFORM, pp: 10, damagetype: 'STAT', params: {}},
TELEPORT: {name: 'Teleport', type: Types.PSYCHIC, power: 0, accuracy: 0, effect: Effects.WARP_AWAY, pp: 20, damagetype: 'STAT', params: {}},
ROAR: {name: 'Roar', type: Types.NORMAL, power: 0, accuracy: 0, effect: Effects.WHIRLWIND, pp: 20, damagetype: 'STAT', params: {}},
WHIRLWIND: {name: 'Whirlwind', type: Types.NORMAL, power: 0, accuracy: 0, effect: Effects.WHIRLWIND, pp: 20, damagetype: 'STAT', params: {}}
}
},{"./Effects.enum":26,"./Stats.enum":31,"./Status.enum":32,"./Types.enum":33}],31:[function(require,module,exports){
module.exports = {
	ATK: {
		id: "ATK",
		name: "Attack"
	},
	DEF: {
		id: "DEF",
		name: "Defense"
	},
	SPD: {
		id: "SPD",
		name: "Speed"
	},
	SP_ATK: {
		id: "SP_ATK",
		name: "Special Attack"
	},
	SP_DEF: {
		id: "SP_DEF",
		name: "Special Defense"
	},
	ACC: {
		id: "ACC",
		name: "Accuracy"
	},
	EVA: {
		id: "EVA",
		name: "Evasion"
	}
}
},{}],32:[function(require,module,exports){
module.exports = {
	BURN: {
		id: 'burn'
	},
	CONFUSION: {
		id: 'confusion'
	},
	FLINCH: {
		id: 'flinch'
	},
	FREEZE: {
		id: 'freeze'
	},
	PARALYZE: {
		id: 'paralyze'
	},
	POISON: {
		id: 'poison'
	},
	RAGE: {
		id: 'rage'
	},
	FOCUSED: {
		id: 'focused',
		onSetMessage: "focuses on the battle!"
	}
}
},{}],33:[function(require,module,exports){
module.exports = {
	NORMAL: {
		id: 'NORMAL'
	},
	FIGHTING: {
		id: 'FIGHTING'
	},
	FLYING: {
		id: 'FLYING'
	},
	POISON: {
		id: 'POISON'
	},
	GROUND: {
		id: 'GROUND'
	},
	ROCK: {
		id: 'ROCK'
	},
	BUG: {
		id: 'BUG'
	},
	GHOST: {
		id: 'GHOST'
	},
	FIRE: {
		id: 'FIRE'
	},
	WATER: {
		id: 'WATER'
	},
	GRASS: {
		id: 'GRASS'
	},
	ELECTRIC: {
		id: 'ELECTRIC'
	},
	PSYCHIC: {
		id: 'PSYCHIC'
	},
	ICE: {
		id: 'ICE'
	},
	DRAGON: {
		id: 'DRAGON'
	}
}
},{}],34:[function(require,module,exports){
var Random = require('../Random');

var TownNames = {
	generateName: function(){
		return Random.from(this.COLORS, true);
	},
	COLORS: ["Alabaster",
		"Alizarin",
		"Almond",
		"Amaranth",
		"Amber",
		"Apricot",
		"Artichoke",
		"Arylide",
		"Ash",
		"Auburn",
		"Azure",
		"Begonia",
		"Beige",
		"Bisque",
		"Bistre",
		"Blush",
		"Bole",
		"Brass",
		"Brunswick",
		"Burgundy",
		"Burlywood",
		"Cadet",
		"Cadmium",
		"Capri",
		"Carmine",
		"Carnation",
		"Carnelian",
		"Catawba",
		"Celeste",
		"Cerise",
		"Cerulean",
		"Chamoisee",
		"Chartreuse",
		"Cinereous",
		"Cinnabar",
		"Cinnamon",
		"Citrine",
		"Citron",
		"Claret",
		"Cobalt",
		"Coquelicot",
		"Coral",
		"Cordovan",
		"Crimson",
		"Cyclamen",
		"Daffodil",
		"Dandelion",
		"Drab",
		"Ebony",
		"Lavender",
		"Lilac",
		"Maroon",
		"Peach",
		"Scarlet",
		"Sienna",
		"Sienna",
		"Taupe",
		"Ube",
		"Umber"
	]
}



module.exports = TownNames;

},{"../Random":15}],35:[function(require,module,exports){
function Box (term, height, width, position) {
	this.term = term;
	this.height = height;
	this.width = width;
	this.position = position;
	this.spaces = "";
	for (var i = 0; i < width; i++){
		this.spaces += " ";
	}
}

Box.prototype.draw = function(){
	for (var i = 0; i < this.height; i++) {
		this.term.putString(this.spaces, this.position.x, this.position.y + i, 255, 255, 255);
    }
};

module.exports = Box;
},{}],36:[function(require,module,exports){
/** Represents a text box which can be updated to
 * show a new text along with the old one until
 * it is full, in which case it shows a [More]
 * prompt, waits for a player keypress, erases it
 * selfs and continues exhibiting the same behaviour.
 * @author Santiago Zapata
 * @author Eben Howard
 */
 
function TextBox (term, height, width, position, display) {
	this.display = display;
	this.term = term;
	this.curx = 0;
	this.cury = 0;
	this.height = height;
	this.width = width;

	this.lines = new Array();
	this.position = position;
	for (var i = 0; i < height; i++){
		this.lines[i] = "";
	}
	this.spaces = "";
	for (var i = 0; i < width; i++){
		this.spaces += " ";
	}
	this.lastUpdateMillis = 0;
}

TextBox.prototype.draw = function(){
	 for (var i = 0; i < this.lines.length; i++) {
		this.term.putString(this.lines[i], this.position.x, this.position.y + i, 255, 255, 255);
     }
};

TextBox.prototype.overgrown = function(){
	return this.lines.length > this.height;
}

TextBox.prototype.checkFaint = function(){
	var currentTime = new Date().getTime();
	if (this.overgrown() && currentTime - this.lastUpdateMillis > 200){
		this.clear();
		this.display.refresh();
	}
}

TextBox.prototype.addText = function(text){
	var currentTime = new Date().getTime();
	if (this.cury >= this.height - 1 && currentTime - this.lastUpdateMillis > 200){
		this.clear();
		this.display.refresh();
	}
	this.lastUpdateMillis = currentTime; 

	var tokens = text.split(" ");
    for (var i = 0; i < tokens.length; i++) {
        var distance = this.width - this.curx;
        if (distance < tokens[i].length + 1) {
            this.curx = 0;
            this.cury++;
        }
        if (!this.lines[this.cury]){
        	this.lines[this.cury] = [];
        }
        this.lines[this.cury] += tokens[i] + " ";
        this.curx += tokens[i].length + 1;
    }
};
    
TextBox.prototype.setText = function(text) {
	this.clear();
	this.addText(text);
	this.draw();
	this.term.render();
};

TextBox.prototype.clear = function() {
	for (var i = 0; i < this.lines.length; i++) {
		this.lines[i] = "";
		this.term.putString(this.spaces, this.position.x, this.position.y + i, 255, 255, 255);
	}
	this.lines.length = this.height;
	this.curx = 0;
	this.cury = 0;
};

module.exports = TextBox;
},{}],37:[function(require,module,exports){
module.exports = {
	direction: function(x1, y1, x2, y2){
		return {x: this.sign(x2 - x1), y: this.sign(y2 - y1)};
	},
	sign: function(a){
		if (a > 0)
			return 1;
		else if (a < 0)
			return -1;
		else
			return 0;
	},
	dxMap: {
		UP: {
			x: 0,
			y: -1
		},
		DOWN: {
			x: 0,
			y: 1
		},
		LEFT: {
			x: -1,
			y: 0
		},
		RIGHT: {
			x: 1,
			y: 0
		}
	},
	opposite: {
		UP: "DOWN",
		DOWN: "UP",
		LEFT: "RIGHT",
		RIGHT: "LEFT"	
	},
	CARDINALS: ["UP", "DOWN", "LEFT", "RIGHT"]
}

},{}]},{},[4]);
